local AddonName, AddonTable = ...

local LuaColor = "|cff0099ff"

if type(AddonTable.defaultColorTable) ~= "table" then
	AddonTable.defaultColorTable = {}
end
local ColorTable = AddonTable.defaultColorTable

local temp = {		
	"_ALERT",
	"_ERRORMESSAGE",
	"_G",
	"_INPUT",
	"_OUTPUT",
	"_PROMPT",
	"_STDERR",
	"_STDIN",
	"_STDOUT",
	"_VERSION",
	"abs",
	"acos",
	"asin",
	"assert",
	"atan",
	"atan2",
	"band",
	"bit",
	"bit.band",
	"bit.bor",
	"bnot",
	"bor",
	"bxor",
	"byte",
	"call",
	"ceil",
	"char",
	"clock",
	"close",
	"collectgarbage",
	"concat",
	"coroutine",
	"coroutine.create",
	"coroutine.resume",
	"coroutine.running",
	"coroutine.status",
	"coroutine.wrap",
	"coroutine.yield",
	"cos",
	"cosh",
	"cpath",
	"create",
	"date",
	"debug",
	"debug.debug",
	"debug.getfenv",
	"debug.gethook",
	"debug.getinfo",
	"debug.getlocal",
	"debug.getmetatable",
	"debug.getregistry",
	"debug.getupvalue",
	"debug.setfenv",
	"debug.sethook",
	"debug.setlocal",
	"debug.setmetatable",
	"debug.setupvalue",
	"debug.traceback",
	"deg",
	"difftime",
	"dofile",
	"dostring",
	"dump",
	"error",
	"execute",
	"exit",
	"exp",
	"file",
	"file.close",
	"file.flush",
	"file.lines",
	"file.read",
	"file.seek",
	"file.setvbuf",
	"file.write",
	"find",
	"floor",
	"flush",
	"fmod",
	"foreach",
	"foreachi",
	"format",
	"frexp",
	"gcinfo",
	"getenv",
	"getfenv",
	"gethook",
	"getinfo",
	"getlocal",
	"getmetatable",
	"getn",
	"getregistry",
	"getupvalue",
	"gfind",
	"globals",
	"gmatch",
	"gsub",
	"huge",
	"input",
	"insert",
	"io",
	"io.close",
	"io.flush",
	"io.input",
	"io.lines",
	"io.open",
	"io.output",
	"io.popen",
	"io.read",
	"io.stderr",
	"io.stdin",
	"io.stdout",
	"io.tmpfile",
	"io.type",
	"io.write",
	"ipairs",
	"join",
	"ldexp",
	"len",
	"lines",
	"load",
	"loaded",
	"loaders",
	"loadfile",
	"loadlib",
	"loadstring",
	"log",
	"log10",
	"lower",
	"lshift",
	"match",
	"math",
	"math.abs",
	"math.acos",
	"math.asin",
	"math.atan",
	"math.atan2",
	"math.ceil",
	"math.cos",
	"math.cosh",
	"math.deg",
	"math.exp",
	"math.floor",
	"math.fmod",
	"math.frexp",
	"math.huge",
	"math.ldexp",
	"math.log",
	"math.log10",
	"math.max",
	"math.min",
	"math.modf",
	"math.pi",
	"math.pow",
	"math.rad",
	"math.random",
	"math.randomseed",
	"math.sin",
	"math.sinh",
	"math.sqrt",
	"math.tan",
	"math.tanh",
	"max",
	"maxn",
	"min",
	"mod",
	"modf",
	"module",
	"new",
	"newtable",
	"newtype",
	"next",
	"open",
	"os",
	"os_clock",
	"os.date",
	"os.difftime",
	"os.execute",
	"os.exit",
	"os.getenv",
	"os.remove",
	"os.rename",
	"os.setlocale",
	"os.time",
	"os.tmpname",
	"output",
	"package",
	"package.cpath",
	"package.loaded",
	"package.loaders",
	"package.loadlib",
	"package.path",
	"package.preload",
	"package.seeall",
	"pairs",
	"path",
	"pcall",
	"pi",
	"popen",
	"pow",
	"preload",
	"print",
	"rad",
	"random",
	"randomseed",
	"rawegal",
	"rawequal",
	"rawget",
	"rawset",
	"read",
	"remove",
	"rename",
	"rep",
	"require",
	"resume",
	"reverse",
	"rshift",
	"rtgsub",
	"running",
	"seeall",
	"seek",
	"select",
	"setfenv",
	"sethook",
	"setlocal",
	"setlocale",
	"setmetatable",
	"setupvalue",
	"setvbuf",
	"sin",
	"sinh",
	"sort",
	"split",
	"sqrt",
	"status",
	"stderr",
	"stdin",
	"stdout",
	"strbyte",
	"strchar",
	"strconcat",
	"strdump",
	"strfind",
	"strformat",
	"strgmatch",
	"strgsub",
	"string",
	"string.byte",
	"string.char",
	"string.dump",
	"string.find",
	"string.format",
	"string.gmatch",
	"string.gsub",
	"string.len",
	"string.lower",
	"string.match",
	"string.rep",
	"string.reverse",
	"string.split",
	"string.sub",
	"string.upper",
	"strlen",
	"strlower",
	"strmatch",
	"strrep",
	"strreverse",
	"strsub",
	"strupper",
	"sub",
	"table",
	"table.concat",
	"table.insert",
	"table.maxn",
	"table.remove",
	"table.sort",
	"tan",
	"tanh",
	"time",
	"tinsert",
	"tmpfile",
	"tmpname",
	"tonumber",
	"tostring",
	"tostringall",
	"traceback",
	"tremove",
	"trim",
	"type",
	"unpack",
	"upper",
	"wrap",
	"write",
	"xpcall",
	"yield",
}

for x = 1, #temp do
	ColorTable[temp[x]] = LuaColor
end
temp = nil

