local AddonName, AddonTable = ...
local SM = SlashMagicAddonTable
local on, off = true, false

-- Bill's Utils
local addOptionMt = BillsUtils.addOptionMt

BillsUtils.Locals[#BillsUtils.Locals +1] = function ()
	addOptionMt = BillsUtils.addOptionMt
end

SM.Commands_Defaults = {
--    ["blank"] = {
--        desc = "",
--        state = true,
--        vers = 1,
--        -- alias = ""
--        -- defaultCommand = "/blank",
--        -- autorun = false,
--        code = {
--            "",
--        },
--    },

    ["artifact"] = {
        desc = "Display Artifact power",
        vers = 1.5,
        alias = "ap",
        state = off,
        --defaultCommand = "/artifact",
        --autorun = false,
        code = {
            "print(\"|cFFFFC028ArtifactPower\")",
            "if HasArtifactEquipped() then",
            "    local mil = 1000000",
            "    local bil = 1000000000",
            "    local tril = 1000000000000",
            "    local cost = {",
            "        100,         300,        325,          350,          375,          400,          425,          450,          525,        625,",
            "        750,         875,        1000,         6840,         8830,         11280,        14440,        18620,        24000,      30600,",
            "        39520,       50880,      64800,        82500,        105280,       138650,       182780,       240870,       315520,     417650,",
            "        546000,      718200,     946660,       1245840,      1635200,      1.915*mil,    10*mil,       13*mil,       17*mil,     22*mil,",
            "        29*mil,      38*mil,     49*mil,       64*mil,       83*mil,       108*mil,      140*mil,      182*mil,      237*mil,    308*mil,",
            "        400*mil,     520*mil,    676*mil,      880*mil,      1.144*bil,    1.488*bil,    1.936*bil,    2.516*bil,    3.272*bil,  4.252*bil,",
            "        5.528*bil,   7.188*bil,  9.344*bil,    12.148*bil,   15.792*bil,   20.528*bil,   26.688*bil,   34.696*bil,   45.104*bil, 58.636*bil,",
            "        76.228*bil,  99.096*bil, 128.824*bil,  167.472*bil,  217.712*bil,  283.024*bil,  367.932*bil,  478.312*bil,  622*bil,    808*bil,",
            "        1.05*tril,   1.37*tril,  1.78*tril,    2.31*tril,    3*tril,       3.9*tril,     5.07*tril,    6.59*tril,    8.57*tril,  11.1*tril,",
            "        14.5*tril,   18.8*tril,  24.5*tril,    31.8*tril,    41.4*tril,    53.8*tril,    69.9*tril,    90.9*tril,    118*tril,   154*tril,",
            "        200*tril,",
            "    }",
            "    local _, _, _, _, powerAvailable, ranksPurchased = C_ArtifactUI.GetEquippedArtifactInfo()",
            "    print(\"    |cFFDEA00BRanks Purchased: |cFF04CC2D\"..ranksPurchased..\"/101|cFF777777 (does not include relics)\")",
            "    print(\"    |cFFDEA00BPower Available: |cFF04CC2D\"..BillsUtils.FormatNumber(powerAvailable))",
            "    nextRank = ranksPurchased + 1",
            "    if ranksPurchased == 101 then",
            "        print(\"    |cFFDEA00BWeapon ranks fully purchased\")",
            "    else",
            "        print(\"    |cFFDEA00BNext Rank cost: |cFF04CC2D\"..BillsUtils.FormatNumber( cost[nextRank]))",
            "        if powerAvailable > cost[nextRank] then",
            "            print(\"    |cFFDEA00BNext rank is |cFF04CC2Dunlocked\")",
            "        else",
            "            print(\"    |cFFDEA00BNext rank is unlocked in |cFF04CC2D\"..BillsUtils.FormatNumber( cost[nextRank] - powerAvailable)..\"|cFFDEA00B power\" )",
            "        end",
            "    end",
            "    total = 0",
            "    for x = 1, ranksPurchased do",
            "        total = total + cost[x]",
            "    end",
            "    print(\"    |cFFDEA00BPower Spent On Ranks: |cFF04CC2D\"..BillsUtils.FormatNumber(total))",
            "    print(\"    |cFFDEA00BTotal Power On Artifact: |cFF04CC2D\"..BillsUtils.FormatNumber(total + powerAvailable))",
            "else",
            "    print(\"    |cFFCC0433You don't have an artifact equipped\")",
            "end",
        },
    },
	
    ["autoclick"] = {
        desc = "Auto click certain pop up dialogs",
        vers = 0.24,
        state = on,
		alias = "",
        --defaultCommand = "/autoclick on",
        --autorun = false,
        code = {
            "msg = string.lower(msg)",
            "if msg == \"on\" then",
            "    AutoClickApprovedMsg = {",
            "        [\"CONFIRM_PURCHASE_TOKEN_ITEM\"] = true, -- Purchase Items with Garrison Resources and such",
            "        [\"CONFIRM_BINDER\"] = true, -- Move Hearthstone",
            "        [\"CONFIRM_LOOT_ROLL\"] = true, -- Confirms your loot roll",
            "        [\"CONFIRM_DISENCHANT_ROLL\"] = true, -- Confirm when you roll d/e on loot ",
            "        [\"LOOT_BIND_CONFIRM\"] = true, -- Confirms Loot binding on pickup",
            "        [\"ABANDON_QUEST\"] = true, -- Just what it says   lol",
            "    }",
            "    local Autoclick = function(self)",
            "        if AutoClickApprovedMsg[self.which] then",
            "            BillsUtils.FWait( 1, self.button1.Click, self.button1, \"LeftButton\") -- need to wait 1 frame for some popups",
            "            return",
            "        end",
            "        if saved.hints then",
            "            print(\"Autoclick popup dialog showing: \"..self.which)",
            "        end",
            "    end",
            "    if not(static.hooked) then",
            "        StaticPopup1:HookScript(\"OnShow\", Autoclick)",
            "        StaticPopup2:HookScript(\"OnShow\", Autoclick)",
            "        StaticPopup3:HookScript(\"OnShow\", Autoclick)",
            "        StaticPopup4:HookScript(\"OnShow\", Autoclick)",
            "        static.hooked = true",
            "    end",
            "    print(\"Autoclick is now on for approved popup dialogs\")",
            "elseif msg == \"off\" then",
            "    AutoClickApprovedMsg = nil",
            "    print(\"Autoclick is now off\")",
            "elseif msg == \"hints\" then",
            "    saved.hints = true",
            "    print(\"Autoclick hints are now on\")",
            "elseif msg == \"nohints\" then",
            "    saved.hints = nil",
            "    print(\"Autoclick hints are now off\")",
            "else",
            "    print(\"Autoclick commands and usage\")",
            "    print(\"\\\"on\\\" enables autoclick\")",
            "    print(\"\\\"off\\\" disables autoclick\")",
            "    print(\"\\\"hints\\\" enables autoclick hints (shows popup name)\")",
            "    print(\"\\\"nohints\\\" disables autoclick hints\")",
            "   print(\"if you add popups to the approved list you must do \\\"autoclick on\\\" for the changes to take effect\")",
            "end",
        },
    },
	
    ["autodnd"] = {
        desc = "Auto set yourself as DND",
        vers = 0.2,
        alias = "autobusy",
        state = on,
        --defaultCommand = "/autodnd on",
        --autorun = false,
        code = {
            "msg = string.lower(msg)",
            "if msg == \"on\" then",
            "    if not(static.loaded) then",
            "        OnEvent(\"PLAYER_FLAGS_CHANGED\", function()",
            "            if not(UnitIsAFK(\"player\")) and not(UnitIsDND(\"player\")) then",
            "                SendChatMessage(\"\", \"DND\")",
            "            end",
            "        end)",
            "        SendChatMessage(\"\", \"DND\")",
            "        static.loaded = true",
            "    end",
            "    print(\"AutoDND is on\")",
            "elseif msg == \"off\" then",
            "    OnEvent(\"PLAYER_FLAGS_CHANGED\", nil)",
            "    static.loaded = nil",
            "    print(\"AutoDND is off\")",
            "else",
            "    print(\"AutoDND options\")",
            "    print(\"    on    enable autodnd\")",
            "    print(\"    off   disable autodnd\")",
            "    print(\"AutoDND is currently \"..(static.loaded and \"on\" or \"off\"))",
            "end",
        },
    },
	
    ["autogeneral"] = {
        desc = "Auto leave general chat when in an instance and rejoin when no longer in an instance.",
        vers = 0.01,
        state = on,
		alias = "",
        --defaultCommand = "/autogeneral on",
        --autorun = false,
        code = {
            "msg = string.lower(msg)",
            "if msg == \"on\" then",
            "    if not(static.loaded) then",
            "        OnEvent(\"PLAYER_ENTERING_WORLD\", function()",
            "            local _, type, _, _, _, _, _, mapID = GetInstanceInfo()",
            "            if type == \"none\" then",
            "                JoinChannelByName(\"General\")",
            "                print(\"You are not in an instance, General chat is |cff00FF00enabled|r\")",
            "            elseif mapID == 1152 or mapID == 1330 or mapID == 1153 or mapID == 1154 or mapID ==    1158 or mapID == 1331 or mapID == 1159 or mapID == 1160 then",
            "                JoinChannelByName(\"General\")",
            "                print(\"You are in your garrison, General chat is |cff00FF00enabled|r\")",
            "            else",
            "                LeaveChannelByName(\"General\")",
            "                print(\"You are in an instance, General chat has been |cffFF0000disabled|r\")",
            "            end",
            "        end)",
            "        static.loaded = true",
            "    end",
            "    print(\"Auto joining/leaving general chat is |cff00FF00enabled|r\")",
            "elseif msg == \"off\" then",
            "    static.loaded = nil",
            "    OnEvent(\"PLAYER_ENTERING_WORLD\", nil)",
            "    print(\"Auto joining/leaving general chat is |cffFF0000disabled|r\")",
            "else",
            "    print(\"autogeneral command options\")",
            "    print(\"   on   enable auto join/leave general chat\")",
            "    print(\"   off  disable auto join/leave general chat\")",
            "end",
        },
    },
	
    ["autorez"] = {
        desc = "Auto-accept Rez request when out of combat",
        vers = 0.2,
        alias = "ar",
        state = on,
        defaultCommand = "/autorez on",
        autorun = false,
        code = {
            "msg = string.lower(msg)",
            "if msg == \"on\" then",
            "    if not(static.loaded) then",
            "        OnEvent(\"RESURRECT_REQUEST\", function()",
            "            if InCombatLockdown() then return end",
            "            AcceptResurrect()",
            "            if saved.chats then",
            "                SendChatMessage(\"Thanks for the Resurrection\", (IsInRaid() and \"RAID\" or \"PARTY\"))",
            "            end",
            "        end)",
            "        OnEvent(\"PLAYER_DEAD\", function()",
            "            if saved.chats then",
            "                SendChatMessage(\"I have died, could I please get a Resurrection?\", (IsInRaid() and \"RAID\" or \"PARTY\"))",
            "            end",
            "        end)",
            "        OnEvent(\"PLAYER_UNGHOST\", function()",
            "            if saved.chats then",
            "                SendChatMessage(\"I have walked back to my body.\", (IsInRaid() and \"RAID\" or \"PARTY\"))",
            "            end",
            "        end)",
            "        static.loaded = true",
            "    end",
            "    print(\"Autorez accept is now ON\")",
            "elseif msg == \"off\" then",
            "    OnEvent(\"RESURRECT_REQUEST\", nil)",
            "    OnEvent(\"PLAYER_DEAD\", nil)",
            "    OnEvent(\"PLAYER_UNGHOST\" ,nil)",
            "    static.loaded = nil",
            "    print(\"Autorez accept is now OFF\")",
            "elseif msg == \"chatson\" then",
            "    saved.chats = true",
            "    print( \"AutoRez chat messages are on\")",
            "elseif msg == \"chatsoff\" then",
            "    saved.chats = nil",
            "    print( \"AutoRez chat messages are off\")",
            "else",
            "    print(\"AutoRez valid options are:\")",
            "    print(\"    on         enables auto rez accept\")",
            "    print(\"    off        disable auto rez accept\")",
            "    print(\"    chatson    enables auto rez chat messages\")",
            "    print(\"    chatsoff   disable auto rez chat messages\")",
            "    print(\"AutoRes is set: \"..(static.loaded and \"ON\" or \"OFF\"))",
            "    print(\"AutoRes chat messages are set: \"..(saved.chats and \"ON\" or \"OFF\"))",
            "end",
        },
    },
	
    ["calc"] = {
        desc = "A simple command line calculator",
        vers = 0.22,
        alias = "=",
        state = off,
        -- defaultCommand = "",
        -- autorun = false,
        code = {
            "msg = string.lower(msg)",
            "if not(tonumber(static.answer)) then static.answer = 0 end",
            "msg = msg:gsub(\"ans\", tostring(static.answer))",
            "local proc = loadstring(\"return \"..msg)",
            "static.answer = proc()",
            "print(\"calc: \" .. msg .. \" = \" .. static.answer)",
        }
    },
	
    ["carbautotrack"] = {
        desc = "Set Carbonite's auto quest track from the command line",
        vers = 0.05,
        alias = "autotrack",
        state = off,
        defaultCommand = "/carbautotrack on",
        autorun = false,
        code = {
            "print( \"CarbAutoTrack:\" )",
            "if not(NxQuestWatch) then",
            "    print( \"Carbonite Quest Tracker does not seem to be loaded.\")",
            "    return",
            "end",
            "msg = string.lower(msg)",
            "if msg == \"on\" or msg == \"off\" then",
            "    local temp = NxQuestWatch.NxWin.ButMiner.User.User.ButATarget",
            "    temp.Pressed = (msg == \"on\")",
            "    temp:Update()",
            "    print(\"Auto Track is now \"..msg)",
            "else",
            "    print( msg .. \" is not a valid option\")",
            "    print(\"Valid Options are: on / off \")",
            "end",
        },
    },
	
    ["cdown"] = {
        desc = "counts down from passed number by optional second passed number",
        vers = 1.11,
        state = on,
		alias = "",
        -- defaultCommand = "",
        -- autorun = false,
        code = {
            "local delay, by = string.split(\" \", msg)",
            "delay = tonumber(delay)",
            "by = tonumber(by)",
            "if not(by) then by = 1 end",
            "if delay then",
            "    for x = delay, 0, -by do",
            "        BillsUtils.Wait( delay, SendChatMsg, tostring(x), \"SAY\" )",
            "    end",
            "end",
        },
    },
	
    ["clear"] = {
        desc = "clear all world markers (smoke bombs)",
        vers = 1,
        state = on,
		alias = "cwm",
        -- defaultCommand = "",
        -- autorun = false,
        code =  {
            "ClearRaidMarker()",
        },
    },
	
    ["cmount"] = {
        desc = "summons the class mount",
        vers = 0.1,
        alias = "cm",
        state = on,
        -- defaultCommand = "",
        -- autorun = false,
        code = {
            "msg = string.lower(msg)",
            "print(\"Class Mount:\")",
            "if InCombatLockdown() then",
            "    print(\"You cannot summon a mount this way while in combat\")",
            "    return",
            "end",
            "local _, _, class = UnitClass(\"player\")",
            "if class == 11 then",
            "    print(\"Sorry, but Blizzard hates Druids so you cannot mount your class mount this way.\")",
            "    return",
            "end",
             "local mounts = { ",
            "    \"Battlelord's Bloodthirsty War Wyrm\",    -- 229388 Warrior = 1",
            "    \"Highlord's Golden Charger\",             -- 231435 Paladin = 2",
            "    \"Huntmaster's Loyal Wolfhawk\",        -- 229386 Hunter = 3",
            "    \"Shadowblade's Murderous Omen\",        -- 231434 Rogue = 4",
            "    \"High Priest's Lightsworn Seeker\",    -- 229377 Priest = 5",
            "    \"Deathlord's Vilebrood Vanquisher\",    -- 229387 DeathKnight = 6",
            "    \"Farseer's Raging Tempest\",            -- 231442 Shaman = 7",
            "    \"Archmage's Prismatic Disc\",             -- 229376 Mage = 8",
            "    \"Netherlord's Chaotic Wrathsteed\",    -- 232412 Warlock = 9",
            "    \"Ban-Lu, Grandmaster's Companion\",     -- 229385 Monk = 10",
            "    \"Travel Form\",                        --        Druid = 11",
            "    \"Slayer's Felbroken Shrieker\",        -- 229417 Demon Hunter = 12",
            "}",
            "local mountIDs = C_MountJournal.GetMountIDs()",
            "local thisMount, Match = mounts[class], false",
            "local creatureName, isUsable, hideOnChar, isCollected, mountID -- Used returns from C_MountJournal.GetMountInfoByID()",
            "for x = 1, #mountIDs do",
            "    creatureName, _, _, _, isUsable, _, _, _, _, hideOnChar, isCollected, mountID = C_MountJournal.GetMountInfoByID(mountIDs[x])",
            "    if not( hideOnChar ) and isUsable and isCollected then",
            "        if string.find( creatureName, thisMount, nil, true ) then",
            "            Match = true",
            "            break",
            "        end",
            "    end",
            "end",
            "if Match then",
            "    C_MountJournal.SummonByID(mountID)",
            "    print(\"Summoning \"..creatureName)",
            "else",
            "    print(\"No usable class mount was found.\")",
            "end",
        },
    },
	
    ["critter"] = {
        desc = "summons the first vanity pet matching the passed string (attempts favorite pets first)",
        vers = 1.23,
        alias = "vpet",
        state = on,
        -- defaultCommand = "",
        -- autorun = false,
        code = {
            "msg = string.lower(msg)",
            "if InCombatLockdown() then",
            "    print(\"You cannot summon a pet this way while in combat\")",
            "    return",
            "elseif msg == \"\" then",
            "    print(\"proper usage is /critter PartialPetName\")",
            "    return",
            "end",
            "local numPets, numOwned = C_PetJournal.GetNumPets()",
            "local Match, Name",
            "for x = 1, numPets do",
            "    local petID, _, owned, customName, _, favorite, _, speciesName, _, _, _, _, _, _, _, _, _, _ = C_PetJournal.GetPetInfoByIndex(x)",
            "    if owned and ( string.find( (string.lower(customName and customName or \"\")), msg, nil, true ) or string.find( (string.lower(speciesName)), msg, nil, true )  )then",
            "        if favorite then",
            "            Match, Name = petID, string.find( string.lower(customName and customName or \"\"), msg, nil, true) and customName or speciesName",
            "            break",
            "        elseif not( Match ) then",
            "            Match, Name = petID, string.find( string.lower(customName and customName or \"\"), msg, nil, true) and customName or speciesName",
            "        end",
            "    end",
            "end",
            "if Match then",
            "    C_PetJournal.SummonPetByGUID(Match)",
            "    print(\"Summoning \"..Name)",
            "else",
            "    print(\"No owned vanity pet matching \\\"\"..msg..\"\\\" was found.\")",
            "end",
        },
    },
	
    ["dboss"] = {
        desc = "Are the daily world bosses/quests done?",
        vers = 1.16,
        alias = "daily",
        state = off,
        defaultCommand = "/dboss",
        autorun = false,
        code = {
            "local completed, uncomplete = {}, {}",
            "local db = {     [\"Path of the Mistwalker\"] = 33374,",
            "    [\"Timeless Trivia\"] = 33211,",
            "    [\"Neverending Spritewood\"] = 32961,",
            "    Zarhym = 32962,",
            "    [\"Archiereus of Flame\"] = 333112,",
            "    [\"Blingtron 4000\"] = 31752,",
            "}",
            "for k, v in pairs( db ) do",
            "    if (type(v) == \"table\" and (IsQuestFlaggedCompleted(v[1]) or IsQuestFlaggedCompleted(v[2]))) or (type(v) == \"number\" and IsQuestFlaggedCompleted(v)) then",
            "        completed[#completed + 1] = k",
            "    else",
            "        uncomplete[#uncomplete + 1] = k",
            "    end",
            "end",
            "table.sort(completed)",
            "table.sort(uncomplete)",
            "print(\"Daily world bosses / quest complete?\")",
            "if #completed > 0 then",
            "    print(\"\\n|cFF66CC00Completed:\")",
            "    for x = 1, #completed do",
            "        print(\"|cff80FF00      \"..completed[x])",
            "    end",
            "end",
            "if #uncomplete > 0 then",
            "    print(\"\\n|cFFFF3333Uncomplete:\")",
            "    for x = 1, #uncomplete do",
            "        print(\"|cFFFF6666      \"..uncomplete[x])",
            "    end",
            "end",
        },
    },
	
    ["eject"] = {
        desc = "ejects passenger from seat # or all seats",
        vers = 1.11,
        state = on,
		alias = "",
        -- defaultCommand = "",
        -- autorun = false,
        code = {
            "msg = math.floor( tonumber(msg) and tonumber(msg) or 0 )",
            "if msg ~= 0 then",
            "    EjectPassengerFromSeat( msg )",
            "else",
            "    for x = 1, UnitVehicleSeatCount(\"player\") do",
            "        EjectPassengerFromSeat(x)",
            "    end",
            "end",
        },
    },
	
    ["events"] = {
        desc = "Starts event debugger that shows ALL events",
        state = off,
        vers = 1,
        alias = "",
        -- defaultCommand = "/events on",
        -- autorun = false,
        code = {
            "if not(static.frame) then",
            "    static.frame = CreateFrame(\"frame\")",
            "    static.frame:SetScript(\"OnEvent\",function(self, event, ...)",
            "        args = {...}",
            "        print(\"event debugger\")",
            "        print(\"event\", event)",
            "        for x = 1, #args do",
            "            print(x, args[x])",
            "        end",
            "    end)",
            "end",
            "",
            "msg = string.lower(msg)",
            "if msg == \"on\" then",
            "    static.frame:RegisterAllEvents()",
            "elseif msg == \"off\" then",
            "    static.frame:UnregisterAllEvents()",
            "end",
            "",
        },
    },
	
    ["exp"] = {
        desc = "displays your experience and rested experience",
        vers = 2.6,
        state = on,
        defaultCommand = "/exp",
        autorun = false,
        code = {
            "print(\"Your experience\")",
            "if not(static.MaxLevel) then",
            "    static.MaxLevel = GetMaxLevelForExpansionLevel( min(GetAccountExpansionLevel(), GetServerExpansionLevel() ) )",
            "end",
            "if(UnitLevel('player') < static.MaxLevel) then",
            "    local XP = UnitXP('player')",
            "    local MaxXP = UnitXPMax('player')",
            "    local XP2Go = MaxXP - XP",
            "    local XPE = GetXPExhaustion()",
            "    print((\"   Exp: %d / %d  %.2f%% of next level.\"):format( XP, MaxXP, (XP / MaxXP) * 100 ))",
            "    if ( XP2Go > 1000000 ) then", -- [9]
            "        print((\"   Exp to level: %.2f Mil\"):format( XP2Go / 1000000))",
            "    elseif ( XP2Go > 10000) then", -- [11]
            "        print((\"   Exp to level: %.2f k\"):format( XP2Go / 1000))",
            "    else",
            "        print((\"   Exp to level: %d \"):format( XP2Go ))",
            "    end",
            "    if not(XPE) then",
            "        print(\"   You are not well rested\")",
            "    elseif (XPE > 1000000) then",
            "        print((\"   Rested exp: %.1f Mil\"):format( XPE / 1000000))",
            "    elseif (XPE > 10000) then",
            "        print((\"   Rested exp: %.1f k\"):format( XPE / 1000))",
            "    else",
            "        print((\"   Rested exp: %d\"):format( XPE ))",
            "    end",
            "else",
            "    print(\"You have reached then maximum level of \"..static.MaxLevel..\".\")",
            "    if SlashMagicStaticValues.expauto and SlashMagicStaticValues.expauto.loaded then",
            "        DoIt(\"/expauto off\" )",
            "        print(\"EXPAUTO has now been shut off\")",
            "    end",
            "end",
        },
    },
	
    ["expauto"] = {
        desc = "displays experience summary at certain percents of level (0 = each time you get exp  25 =  when you cross 25/50/75/100 ect)",
        vers = 2,
        state = on,
        defaultCommand = "/expauto",
        autorun = false,
        code = {
            "msg = string.lower(msg)",
            "value = tonumber(msg)",
            "if value then",
            "    static.percent = value",
            "    static.last = 0",
            "    static.steps = math.floor(100/static.percent)",
            "    if not(static.loaded) then",
            "        OnEvent(\"PLAYER_XP_UPDATE\", function()",
            "            if static.percent == 0 then",
            "                DoIt(\"/exp\" )",
            "            else",
            "                local announce = false",
            "                local percent = (UnitXP('player') / UnitXPMax('player')) * 100",
            "                local stepPercent = 0",
            "",
            "                for x = 1, static.steps do",
            "                    if percent > static.percent * x and percent < static.percent * (x + 1) then",
            "                        if (static.last < static.percent * x) or (static.last == 0) or (static.last > percent) then",
            "                            announce = true",
            "                            stepPercent = static.percent * x",
            "                        end",
            "                        break",
            "                    end",
            "                end",
            "                if announce then",
            "                    DoIt( \"/exp\" )",
            "                    PlaySound(SOUNDKIT.PUT_DOWN_GEMS)",
            "                    static.last = stepPercent",
            "                end",
            "            end",
            "        end)",
            "        static.loaded = true",
            "    end",
            "    print(\"ExpAuto is on\")",
            "elseif msg == \"off\" then",
            "    OnEvent(\"PLAYER_XP_UPDATE\", nil)",
            "    static.loaded = nil",
            "    print(\"ExpAuto is off\")",
            "else",
            "    print(\"ExpAuto options\")",
            "    print(\"    ##    enable when crossing a multiple of this number as a percent\")",
            "    print(\"          example 25 = 25%/50%/75%/100%   5 = 5/10/15/20...\")",
            "    print(\"    off   disable ExpAuto\")",
            "    print(\"ExpAuto is currently \"..(static.loaded and \"on\" or \"off\"))",
            "    if static.loaded then",
            "        print(\"at \"..static.percent.. \" percent. \")",
            "    end",
            "end",
        },
    },
	
    ["gfx"] = {
        desc = "restart the gfx engine",
        vers = 1,
        state = on,
        -- defaultCommand = "",
        -- autorun = false,
        code = {
            "RestartGx()",
        },
    },
	
    ["gryphons"] = {
        desc = "hides or shows the Blizzard gryphons",
        state = on,
        vers = 1,
        alias = "",
        -- defaultCommand = "/gryphons hide",
        -- autorun = false,
        code = {
            "msg = string.lower(msg)",
            "if msg == \"hide\" then",
            "    MainMenuBarArtFrame.LeftEndCap:Hide()",
            "    MainMenuBarArtFrame.RightEndCap:Hide()",
            "elseif msg == \"show\" then",
            "    MainMenuBarArtFrame.LeftEndCap:Show()",
            "    MainMenuBarArtFrame.RightEndCap:Show()",
            "else",
            "    print('Options are \"hide\" and \"show\"')",
            "end",
        },
    },
	
    ["hn"] = {
        desc = "HandyNotes display toggle",
        vers = 0.21,
        -- alias = "",
        state = off,
        --defaultCommand = "",
        -- autorun = false,
        code = {
            "msg = string.lower(msg)",
            "print(\"Handy Notes quick settings:\")",
            "if not(HandyNotes) then",
            "    print(\"The Handy Notes addon does not seem to be enabled or installed\")",
            "elseif msg == \"clear\" then",
            "    HandyNotes:OnDisable()",
            "    print(\"Note display cleared until map reopened\")",
            "elseif msg == \"on\" then",
            "    HandyNotes:Enable()",
            "    print(\"Note display enabled\")",
            "elseif msg == \"off\" then",
            "    HandyNotes:Disable()",
            "    print(\"Note display disabled\")",
            "else",
            "    print(\"clear = clears notes until map reopened\")",
            "    print(\"on = enable notes\")",
            "    print(\"off = disable notes\")",
            "    print(\"Settings will revert to default on a reload\")",
            "end",
        },
    },
	
    ["in"] = {
        desc = "will run a slash command in a set amount of time \"/in ## /whatever\" or \"/in #:## /whatever\" (not all slash commands can be delayed)",
        vers = 3.5,
        state = on,
        -- defaultCommand = "",
        -- autorun = false,
        code = {
            "local delay, what = string.split(\" \", msg, 2)",
            "if string.find( delay, \":\" ) then",
            "    local mins, secs = string.split(\":\", delay)",
            "    mins = tonumber(mins)",
            "    secs = tonumber(secs)",
            "    delay = (mins * 60) + secs",
            "else",
            "    delay = tonumber(delay)",
            "end",
            "if delay <= 0 then",
            "    print(\"/in delay must be greater than 0\")",
            "    return",
            "end",
            "BillsUtils.Wait( delay, DoIt, what )",
        },
    },
	
    ["inframes"] = {
        desc = "will run a slash command in a set amount of frames \"/inframes ## /whatever\" (not all slash commands can be delayed)",
        vers = 1.5,
        state = off,
        -- defaultCommand = "",
        -- autorun = false,
        code = {
            "local delay, what = string.split(\" \", msg, 2)",
            "delay = tonumber(delay)",
            "if delay <= 0 then",
            "    print(\"/inframes delay must be greater than 0\")",
            "    return",
            "end",
            "BillsUtils.FWait( delay, DoIt, what )",
        },
    },
	
    ["lvgrp"] = {
        desc = "will leave your group",
        vers = 2,
        state = on,
        -- defaultCommand = "",
        -- autorun = false,
        code = {
            "C_PartyInfo.LeaveParty()",
        },
    },
	
    ["mana"] = {
        desc = "alerts your group if your mana goes below user set percentage",
        state = true,
        vers = 1.6,
        alias = "",
        -- defaultCommand = "/mana 10 40",
        -- autorun = false,
        code = {
            "print(\"Mana Alert:\")",
            "if UnitPowerMax(\"player\", SPELL_POWER_MANA) < 1 then",
            "    print(\"    You currently cannot have mana so this command can do nothing for you and will now exit\")",
            "    return",
            "end",
            "local cmd = string.lower(msg)",
            "local alert, resume = string.split(\" \", msg)",
            "alert = alert and tonumber(alert) or nil",
            "resume = resume and tonumber(resume) or nil",
            "if cmd == \"cancel\" or cmd == \"stop\" then",
            "    OnEvent(\"UNIT_SPELLCAST_SENT\", nil)",
            "    OnEvent(\"UNIT_AURA\", nil)",
            "    static.init = nil",
            "    static.alert = nil",
            "    static.resume = nil",
            "    static.warned = nil",
            "    print(\"Mana Alert is disabled\")",
            "elseif alert and resume then",
            "    if not(static.init) then",
            "        OnEvent(\"UNIT_SPELLCAST_SENT\", function()",
            "            if not(static.warned) and IsInGroup() then",
            "                local MaxMana = UnitPowerMax(\"player\", SPELL_POWER_MANA)",
            "                local CurrentMana = UnitPower(\"player\", SPELL_POWER_MANA)",
            "                if static.alert <= (CurrentMana / MaxMana) then",
            "                    local msgType",
            "                    if IsInGroup(LE_PARTY_CATEGORY_INSTANCE) then",
            "                        msgType = \"INSTANCE\"",
            "                    elseif IsInRaid() then",
            "                        msgType = \"RAID\"",
            "                    else",
            "                        msgType = \"PARTY\"",
            "                    end",
            "                    SendChatMessage(\"My mana level is getting low!\",msgType)",
            "                    DoEmote(\"oom\",\"none\")",
            "                    static.warned = true",
            "                end",
            "            end",
            "        end)",
            "        OnEvent(\"UNIT_AURA\", function()",
            "            if static.warned and IsInGroup() then",
            "                local MaxMana = UnitPowerMax(\"player\", SPELL_POWER_MANA)",
            "                local CurrentMana = UnitPower(\"player\", SPELL_POWER_MANA)",
            "                if (CurrentMana / MaxMana) >= static.resume then",
            "                    local msgType",
            "                    if IsInGroup(LE_PARTY_CATEGORY_INSTANCE) then",
            "                        msgType = \"INSTANCE\"",
            "                    elseif IsInRaid() then",
            "                        msgType = \"RAID\"",
            "                    else",
            "                        msgType = \"PARTY\"",
            "                    end",
            "                    SendChatMessage(\"Mana level is ok now.\",msgType)",
            "                    DoEmote(\"ready\",\"none\")",
            "                    static.warned = nil",
            "                end",
            "            end",
            "        end)",
            "        static.init = true",
            "    end",
            "    static.alert = alert / 100",
            "    static.resume = resume / 100",
            "    print(\"    alert at \" .. alert .. \"%\")",
            "    print(\"    resume at \" .. resume .. \"%\")",
            "    print(\"    to stop the alerts type \\\"/mana stop\\\" \")",
            "else",
            "    print(\"    Proper usage is \\\"/mana WarnPercent ResumePercent\\\" \")",
            "    print(\"    example \\\"/mana 10 40\\\" \")",
            "    print(\"    will warn of low mana at 10% and report ready at 40% \")",
            "    print(\"    to stop the alerts type \\\"/mana stop\\\" \")",
            "end",
        },
    },
	
    ["matchmount"] = {
        desc = "attempts to match the mount of your target",
        state = true,
        vers = 1.2,
        alias = "mm",
        -- defaultCommand = "matchmount",
        -- autorun = false,
        code = {
            "print(\"MatchMount:\")",
            "if InCombatLockdown() then",
            "    print(\"You cannot summon a mount this way while in combat\")",
            "    return",
            "elseif not UnitExists(\"target\") then",
            "    print(\"You must target another player to match their mount.\")",
            "    return",
            "end",
            "local _, mountID, spellID, buffName",
            "for x = 1, 40 do",
            "    buffName, _, _, _, _, _, _, _, _, spellID = UnitBuff(\"target\", x)",
            "    if not(buffName) then break end",
            "    mountID = spellID and C_MountJournal.GetMountFromSpell(spellID) or nil",
            "    if mountID then break end",
            "end",
            "if not(mountID) then",
            "    print(\"    Your target does not appear to be mounted\")",
            "    return",
            "end",
            "local creatureName, _, _, _, isUsable, _, _, _, _, _, isCollected, _ = C_MountJournal.GetMountInfoByID(mountID)",
            "if isUsable and isCollected then",
            "    C_MountJournal.SummonByID(mountID)",
            "    print(\"    Summoning \\\"\".. creatureName .. \"\\\"\" )",
            "elseif not(isCollected) then",
            "    print(\"    You have not collected \" .. creatureName .. \" so it cannot be summoned\")",
            "else",
            "    print(\"    I can't find a usable match for your target's mount\")",
            "end",
        },
    },
	
    ["motd"] = {
        desc = "Guild MOTD",
        vers = 0.12,
        -- alias = "",
        state = on,
        defaultCommand = "/motd",
        autorun = false,
        code = {
            "print(\"|cFF40C040Guild MOTD:\")",
            "if msg ~=\"\" then",
            "    if CanEditMOTD() then",
            "        GuildSetMOTD(msg)",
            "        print(\"|cff40ff40  MoTD set to: \"..msg)",
            "    else",
            "        print(\"|cff40ff40  You do not have permission to change the guild's MoTD\")",
            "    end",
            "else",
            "    print(\"|cff40ff40  \"..GetGuildRosterMOTD())",
            "end",
        },
    },
	
    ["mount"] = {
        desc = "summons the first mount matching the passed string (attempts favorite flying/ favorite/ flying/ any mount in that order)",
        vers = 2.6,
        state = on,
        -- defaultCommand = "",
        -- autorun = false,
        code = {
            "msg = string.lower(msg)",
            "print(\"Mount:\")",
            "if InCombatLockdown() then",
            "    print(\"You cannot summon a mount this way while in combat\")",
            "    return",
            "elseif msg == \"\" then",
            "    print(\"proper usage is /mount partialmountname\")",
            "    return",
            "elseif msg == \"random\" then",
            "    C_MountJournal.SummonByID(0)",
            "    print(\"Trying to summon a random favorite mount for you\")",
            "    return",
            "end",
            "local flyableArea = IsFlyableArea()",
            "local mountIDs = C_MountJournal.GetMountIDs()",
            "local Match, Name, Flying, Favorite",
            "local creatureName, isUsable, isFavorite, hideOnChar, isCollected, mountID -- Used returns from C_MountJournal.GetMountInfoByID()",
            "local mountType -- Used returns from C_MountJournal.GetMountInfoExtraByID()",
            "local isFlying",
            "for x = 1, #mountIDs do",
            "    creatureName, _, _, _, isUsable, _, isFavorite, _, _, hideOnChar, isCollected, mountID = C_MountJournal.GetMountInfoByID(mountIDs[x])",
            "    if not( hideOnChar ) and isUsable and isCollected then",
            "        if string.find( string.lower(creatureName), msg, nil, true ) then",
            "            _, _, _, _, mountType = C_MountJournal.GetMountInfoExtraByID(mountIDs[x])",
            "            isFlying = (mountType == 247 or mountType == 248)",
            "            if isFavorite and ((isFlying and flyableArea) or not(flyableArea)) then",
            "                Match, Name, Favorite = mountID, creatureName, isFavorite",
            "                break",
            "            elseif (not(Favorite) and isFavorite) or",
            "                   (not( Match )) or",
            "                   (not(Favorite) and Match and not(Flying) and isFlying and flyableArea) then",
            "                Match, Name, Flying, Favorite = mountID, creatureName, isFlying, isFavorite",
            "            end",
            "        end",
            "    end",
            "end",
            "if Match then",
            "    C_MountJournal.SummonByID(Match)",
            "    print(\"Summoning \"..(Favorite and \"Favorite Mount: \" or \"Mount: \")..Name)",
            "else",
            "    print(\"No usable mount matching \\\"\"..msg..\"\\\" was found.\")",
            "end",
        },
    },
	
	["moveselljunk"] = {
		desc = "Moves the SellJunk addon button to the vendor name bar",
		state = true,
        vers = 1,
        alias = "msj",
        --defaultCommand = "/blank",
        --autorun = false,
        code = {
            "if not(SellJunk) then",
			"    print(color.Red..\"You don't appear to have the \\\"SellJunk\\\" addon loaded so this command will now exit\")",
			"    return",
			"end",
			"",
			"SellJunk.sellButton:ClearAllPoints()",
			"SellJunk.sellButton:SetPoint(\"TOPRIGHT\", -23, 0)",
			"return",
        },
    },
	
    ["names"] = {
        desc = "toggles the display of names in the 3d world",
        vers = 1.31,
        state = on,
        -- defaultCommand = "",
        -- autorun = false,
        code = {
            "if InCombatLockdown() then",
            "    print(\"You can no longer toggle names while in combat\")",
            "    return",
            "end",
            "if type(saved.showing) ~= \"boolean\" then",
            "    saved.showing = true",
            "end",
            "local what = { \"UnitNameEnemyGuardianName\", \"UnitNameEnemyPetName\", \"UnitNameEnemyPlayerName\", \"UnitNameEnemyTotemName\",",
            "    \"UnitNameFriendlyGuardianName\", \"UnitNameFriendlyPetName\", \"UnitNameFriendlyPlayerName\", \"UnitNameFriendlySpecialNPCName\",",
            "    \"UnitNameFriendlyTotemName\", \"UnitNameGuildTitle\", \"UnitNameHostleNPC\", \"UnitNameNPC\",",
            "    \"UnitNameNonCombatCreatureName\", \"UnitNameOwn\", \"UnitNamePlayerGuild\", \"UnitNamePlayerPVPTitle\",",
            "    \"nameplateShowEnemies\", \"nameplateShowEnemyGuardians\", \"nameplateShowEnemyPets\", \"nameplateShowEnemyTotems\",",
            "    \"nameplateShowFriendlyGuardians\", \"nameplateShowFriendlyPets\", \"nameplateShowFriendlyTotems\", \"nameplateShowFriends\",",
            "    }",
            "if saved.showing then",
            "    for x = 1, #what do",
            "        saved[what[x]] = GetCVar(what[x])",
            "        SetCVar( what[x], \"0\")",
            "    end",
            "    saved.showing = false",
            "else",
            "    for x = 1, #what do",
            "        SetCVar( what[x], saved[what[x]])",
            "    end",
            "    saved.showing = true",
            "end",
        },
    },
	
    ["narco"] = {
        desc = "wakes you up if a long time has passed since last keypress/movement",
        vers = 0.2,
        state = off,
        defaultCommand = "/narco on",
        autorun = false,
        code = {
            "msg = string.lower(msg)",
            "if msg == \"on\" then",
            "    static.time = -2",
            "    print(\"Narco is now enabled\")",
            "    InTime(.1, 2, function()",
            "        if not(static.running) then",
            "            return true -- returning true stops the repeating of the function",
            "        end",
            "        if static.moving then return end",
            "        static.time = static.time + 2",
            "        if static.time >= 30 and static.time % 10 == 0 then",
            "            RaidNotice_AddMessage(RaidWarningFrame, \"NARCO: Wake Up! Last movement was \"..static.time..\" seconds ago.\", ChatTypeInfo[\"RAID_WARNING\"])",
            "            PlaySound(SOUNDKIT.RAID_WARNING)",
            "        end",
            "    end)",
            "    OnEvent(\"PLAYER_STARTED_MOVING\", function()",
            "        static.moving = true",
            "        static.time = 0",
            "    end)",
            "    OnEvent(\"PLAYER_STOPPED_MOVING\", function()",
            "        static.moving = false",
            "    end)",
            "    OnEvent(\"MODIFIER_STATE_CHANGED\", function()",
            "        static.time = 0",
            "    end)",
            "    OnEvent(\"ACTIONBAR_UPDATE_STATE\", function()",
            "        static.time = 0",
            "    end)",
            "   static.running = true",
            "elseif msg == \"off\" then",
            "    print(\"Narco is now disabled\")",
            "    static.running = nil",
            "    static.time = nil",
            "    OnEvent(\"PLAYER_STARTED_MOVING\",nil)",
            "    OnEvent(\"PLAYER_STOPPED_MOVING\",nil)",
            "    OnEvent(\"MODIFIER_STATE_CHANGED\",nil)",
            "    OnEvent(\"ACTIONBAR_UPDATE_STATE\",nil)",
            "else",
            "    print(\"Narco: keeps your awake\")",
            "    print(\"    valid commands are on/off\")",
            "    print(\"Narco is currently \"..(static.running and \"enabled\" or \"disabled\"))",
            "end",
        },
    },
	
	["phased"] = {
		desc = "will scan your group and report the phased status of members and if called with option \"only\" it will only report those who are out of phase. If called with \"compact\" it will generate a list for each state then output the list. If called with \"self\" it will report the scan to you only. If called with \"verbose\" will give more info on War Mode phasing",
		state = true,
		vers = 1.3,
		alias = "wmo warmodeon",
		--defaultCommand = "/blank",
		-- autorun = false,
		code = {
			"print(color.LightGreen..\"Phased Check is now running\"..color.Reset)",
			"if not(IsInGroup()) then",
			"    print(color.Red..\"You are not in a group so this scan will terminate now\")",
			"    return",
			"end",
			"",
			"msg = string.lower(msg)",
			"local noOptions = msg:len() == 0",
			"local default = msg:find(\"default\")",
			"local only = noOptions and saved.only or msg:find(\"only\")",
			"local self = noOptions and saved.self or msg:find(\"self\")",
			"local verbose = noOptions and saved.verbose or msg:find(\"verbose\")",
			"local compact = noOptions and saved.compact or msg:find(\"compact\")",
			"",
			"if default then",
			"    saved.only = only",
			"    saved.self = self",
			"    saved.verbose = verbose",
			"    saved.compact = compact",
			"    print(color.LightBlue..\"Default settings have been saved as: |r\"..(only and color.Green or color.Red)..\"ONLY |r\"..(self and color.Green or color.Red)..\"SELF |r\"..(verbose and color.Green or color.Red)..\"VERBOSE |r\"..(compact and color.Green or color.Red)..\"COMPACT |r\")",
			"    print(color.Green..\"No scan performed and now exiting. To use default settings call this command without any options.\"..color.Reset)",
			"    return",
			"end",
			"",
			"local myWarMode = (C_PvP.IsWarModeDesired() or C_PvP.IsWarModeActive())",
			"local myChromieTime = C_PlayerInfo.IsPlayerInChromieTime()",
			"local groupType = IsInGroup(LE_PARTY_CATEGORY_INSTANCE) and \"INSTANCE\" or IsInRaid() and \"RAID\" or \"PARTY\"",
			"local unitKey = IsInRaid() and  \"raid%d\" or \"party%d\"",
			"local groupMaxMembers = IsInRaid() and 40 or 4",
			"local phases = {",
			"    [false]                        = \"Currently in phase!\",",
			"    [Enum.PhaseReason.WarMode]     = verbose and (myWarMode and PARTY_PLAYER_WARMODE_DISABLED or PARTY_PLAYER_WARMODE_ENABLED) or _G[\"ERR_PVP_WARMODE_TOGGLE_\"..(myWarMode and \"OFF\" or \"ON\")],",
			"    [Enum.PhaseReason.ChromieTime] = myChromieTime and \"not doing the Timewalking Campaign\" or \"in a Timewalking Campaign\",",
			"    [Enum.PhaseReason.Sharding]    = PARTY_SHARDED_MESSAGE,",
			"    [Enum.PhaseReason.Phasing]     = PARTY_PHASED_MESSAGE,",
			"}",
			"",
			"local unit, name, phase",
			"local msgTable = {\"\", \"\", \"\", \"\", \"\"}",
			"for i=1, groupMaxMembers do",
			"    unit = unitKey:format(i)",
			"    if UnitExists(unit) and not(UnitIsUnit(unit, \"player\")) then",
			"        name = UnitName(unit)",
			"   	 phase = UnitPhaseReason(unit)",
			"        phase = phase and phase or false",
			"",
			"        if compact then",
			"            if ((only and phase) or not(only)) then",
			"                msgTable[not(phase) and 1 or (phase +2)] = msgTable[not(phase) and 1 or (phase +2)] .. name .. \"  \"",
			"            end",
			"        else",
			"            if ((only and phase) or not(only)) then",
			"                if self then",
			"                    print((\"Group member %s: %s\"):format(name, phases[phase]))",
			"                else",
			"                    DoIt( (\"/%s Group member %s: %s\"):format(groupType, name, phases[phase]))",
			"                end",
			"            end",
			"        end",
			"    end",
			"end",
			"if compact then",
			"    for x = 1, #msgTable do",
			"        if string.len(msgTable[x]) > 0 then",
			"            if self then",
			"                print((\"%s: %s\"):format( (phases[x==1 and false or x - 2]), msgTable[x]))",
			"            else",
			"                DoIt( (\"/%s %s: %s\"):format(groupType, phases[(x > 1 and x - 2 or false)], msgTable[x]))",
			"            end",
			"        end",
			"    end",
			"end",
			"print(color.LightGreen..\"Phased Check is complete\"..color.Reset)",
		},
    },
    ["ready"] = {
        desc = "initiate a ready check",
        vers = 1.1,
        state = on,
        -- defaultCommand = "",
        -- autorun = false,
        code = {
            "DoReadyCheck()",
        },
    },
	
    ["role"] = {
        desc = "initiates a role check",
        vers = 1.1,
        state = on,
        -- defaultCommand = "",
        -- autorun = false,
        code = {
            "InitiateRolePoll()",
        },
    },
	
    ["sha"] = {
        desc = "checks to see if you did the \"Sha of Anger\"",
        vers = 1.26,
        state = off,
        defaultCommand = "/sha",
        autorun = false,
        code = {
            "if ( IsQuestFlaggedCompleted(32099) ) then",
            "    print(\"You have completed \\\"Sha of Anger\\\" this week.\")",
            "else",
            "    print(\"You haven\'t completed \\\"Sha of Anger\\\" this week.\")",
            "end",
        },
    },
	
    ["sticky"] = {
        desc = "Change the sticky chat channels",
        vers = 0.01,
        alias = "sc",
        state = off,
        defaultCommand = "/sticky",
        autorun = false,
        code = {
            "local channels = {",
            "    -- 1 for sticky, 0 for not sticky.",
            "    [\"SAY\"] = 1,",
            "    [\"YELL\"] = 0,",
            "    [\"EMOTE\"] = 0,",
            "    [\"PARTY\"] = 1,",
            "    [\"RAID\"] = 1,",
            "    [\"RAID_WARNING\"] = 0,",
            "    [\"INSTANCE_CHAT\"] = 1,",
            "    [\"GUILD\"] = 1,",
            "    [\"OFFICER\"] = 1,",
            "    [\"WHISPER\"] = 0,",
            "    [\"CHANNEL\"] = 0,",
            "    [\"BN_WHISPER\"] = 0",
            "}",
            "for i, v in pairs(channels) do",
            "    ChatTypeInfo[i].sticky = v",
            "end",
            "print(\"Sticky channels changed\")",
        },
    },
	
    ["tmover"] = {
        desc = "Toggle \"Toast Mover\" anchor",
        vers = 0.13,
        state = off,
        -- defaultCommand = "",
        -- autorun = false,
        code = {
            "msg = string.lower(msg)",
            "if msg == \"toggle\" then",
            "    msg = _G[\"ToastMoverAnchorFrame\"]:IsVisible() and \"hide\" or \"show\"",
            "end",
            "if msg == \"on\" or msg == \"show\" then",
            "    _G[\"ToastMoverAnchorFrame\"]:Show()",
            "elseif msg == \"off\" or msg == \"hide\" then",
            "    _G[\"ToastMoverAnchorFrame\"]:Hide()",
            "else",
            "    print(\"tmover commands are hide / show / toggle\")",
            "end",
        },
    },
	
    ["toast"] = {
        desc = "sets or clears your Battle-Net toast message",
        vers = 1.01,
        state = on,
        -- defaultCommand = "",
        -- autorun = false,
        code = {
            "if msg ~= \"\" then",
            "    BNSetCustomMessage( msg )",
            "    print(\"Toast message set to: \"..msg)",
            "else",
            "    BNSetCustomMessage( \"\" )",
            "    print(\"Toast message cleared\" )",
            "end",
        },
    },
	
    ["tele"] = {
        desc = "teleport in/out of lfg dungeon",
        vers = 1,
        state = on,
        -- defaultCommand = "",
        -- autorun = false,
        code = {
            "LFGTeleport(IsInInstance())",
        },
    },
	
    ["p2r"] = {
        desc = "convert your party to a raid",
        vers = 1.5,
        alias = "party2raid",
        state = on,
        -- defaultCommand = "",
        -- autorun = false,
        code = {
            "C_PartyInfo.ConvertToRaid()",
        },
    },
	
    ["passloot"] = {
        desc = "will toggle pass on loot",
        vers = 1.06,
        state = off,
        -- defaultCommand = "",
        -- autorun = false,
        code = {
            "local passing = GetOptOutOfLoot()",
            "if passing then",
            "    SetOptOutOfLoot()",
            "    print(\"You are no longer passing on all loot\")",
            "else",
            "    SetOptOutOfLoot(1)",
            "    print(\"You are now passing on all loot\")",
            "end",
        },
    },
	
    ["r2p"] = {
        desc = "convert your raid to a party",
        vers = 1.5,
        alias = "raid2party",
        state = on,
        -- defaultCommand = "",
        -- autorun = false,
        code = {
            "C_PartyInfo.ConvertToParty()",
        },
    },
	
	["searchg"] = {
        desc = "Searches the global variable tables for the passed value and prints the matching key/value pairs",
        state = true,
        vers = 1,
        alias = "",
        --defaultCommand = "/blank",
        --autorun = false,
        code = {
			"print(color.LightGreen..\"Search Globals:\"..color.Reset)",
			"if not(msg) or msg == \"\" then",
			"    print(\"You didn't specify what to search for so this command will now exit\")",
			"    return",
			"end",
			"local valueString",
            "for index, value in pairs(_G) do",
			"    valueString = type(value) == \"string\" and value or tostring(value)",
			"    if string.find(index, msg) or string.find(valueString, msg) then",
			"        print(\"_G[\\\"\"..index..\"\\\"] = \"..valueString)",
			"    end",
			"end",
        },
    },
	
    ["unsheath"] = {
        desc = "Keeps your weapon out",
        vers = 0.5,
        state = on,
        defaultCommand = "/unsheath on",
        autorun = false,
        code = {
            "msg = string.lower(msg)",
            "if msg == \"on\" then",
            "    print(\"Auto-unsheath is now enabled\")",
            "    static.tick = 0",
            "    static.tock = 0",
            "    InTime(.1, 2, function()",
            "        if static.tock > 0 then",
            "            static.tock = static.tock - 1",
            "            return",
            "        end",
            "        if not(HasFullControl()) or IsMounted() or IsSwimming() or UnitIsPossessed(\"player\") or UnitInVehicle(\"player\") or UnitOnTaxi(\"player\") then",
            "            static.tick = 0",
            "            static.tock = 0",
            "            return",
            "        end",
            "        if static.running and GetSheathState() ~= 2 then",
            "            static.tick = static.tick + 1",
            "            ToggleSheath()",
            "        elseif not(static.running) then",
            "            return true -- returning true stops the repeating of the function",
            "        else",
            "            static.tick = 0",
            "            static.tock = 0",
            "        end",
            "        if static.tick > 3 then static.tock = static.tock + static.tick end",
            "    end)",
            "    static.running = true",
            "elseif msg == \"off\" then",
            "    print(\"Auto-unsheath is now disabled\")",
            "    static.running = nil",
            "else",
            "    print(\"Unsheath: keeps your weapon unsheathed\")",
            "    print(\"    valid commands are on/off\")",
            "    print(\"Unsheath is currently \"..(static.running and \"enabled\" or \"disabled\"))",
            "end",
        },
    },
	
    ["wboss"] = {
        desc = "Are the weekly world bosses/quests done?",
        vers = 1.21,
        alias = "weekly",
        state = off,
        defaultCommand = "/wboss",
        autorun = false,
        code = {
            "local completed, uncomplete = {}, {}",
            "local wb = {     Ordos = 33118,",
            "     [\"Trove of the Thunder King\"] = 32609,",
            "     Celestials = 33117,",
            "     Galleon = 32098,",
            "     Nalak = 32518,",
            "     Oondasta = 32519,",
            "     [\"Sha of Anger\"] = 32099,",
            "     [\"Victory In Wintergrasp\"] = {13181, 13183},",
            "     [\"Victory In Tol Barad\"] = {28882, 28884},",
            "     [\"Empowering the Hourglass\"] = 33338,",
            "     [\"Strong Enough To Survive\"] = 33334,",
            "}",
            "for k, v in pairs( wb ) do",
            "     if (type(v) == \"table\" and (IsQuestFlaggedCompleted(v[1]) or IsQuestFlaggedCompleted(v[2]))) or (type(v) == \"number\" and IsQuestFlaggedCompleted(v)) then",
            "          completed[#completed + 1] = k",
            "     else",
            "          uncomplete[#uncomplete + 1] = k",
            "     end",
            "end",
            "table.sort(completed)",
            "table.sort(uncomplete)",
            "print(\"Weekly world bosses / quest complete?\")",
            "if #completed > 0 then",
            "     print(\"\\n|cFF66CC00Completed:\")",
            "     for x = 1, #completed do",
            "          print(\"|cff80FF00      \"..completed[x])",
            "     end",
            "end",
            "if #uncomplete > 0 then",
            "     print(\"\\n|cFFFF3333Uncomplete:\")",
            "     for x = 1, #uncomplete do",
            "          print(\"|cFFFF6666      \"..uncomplete[x])",
            "     end",
            "end",
        },
    },
	
    ["xx"] = {
        desc = "attempts to dismount you and leave any vehicle you are in including taxis",
        vers = 2.01,
        state = on,
        -- defaultCommand = "",
        -- autorun = false,
        code = {
            "if UnitInVehicle(\"player\") then",
            "     VehicleExit()",
            "end",
            "if IsMounted() then",
            "     Dismount()",
            "end",
            "if UnitOnTaxi(\"player\") then",
            "     TaxiRequestEarlyLanding()",
            "end",
        },
    },

-- ****************************************************************************
-- * Dead commands - Blizz removed features for them to work                  *
-- ****************************************************************************

--  BLIZZARD REMOVED COMMAND ABILITY IN LEGION
    ["cloak"] = {
		desc = "toggle your cloak visibility -- Blizz removed cloak toggle ability",
        vers = 1,
        state = off,
		isDead = true,
		defaultCommand = "",
		autorun = false,
		code = {
			"ShowCloak( not(ShowingCloak()) )",
        },
    },

-- Bliz Removed ability in Legion
    ["fquit"] ={
        desc = "fast quit / force quit -- Blizz protected ForceQuit so command is dead",
        vers = 1.1,
        state = off,
		isDead = true,
        -- defaultCommand = "",
        -- autorun = false,
        code = {
            "LeaveParty()",
            "LeaveParty()",
            "ForceQuit()",
        },
    },

--  BLIZZARD REMOVED COMMAND ABILITY IN LEGION
    ["helm"] = {
        desc = "toggle your helm visibility -- Blizz removed helm toggle ability",
        vers = 1,
        state = off,
		isDead = true,
        --defaultCommand = "",
        --autorun = false,
        code = {
            "ShowHelm( not(ShowingHelm()) )",
        },
    },

-- Blizzard killed it
    ["lo"] = {
        desc = "leaves groups and logs out -- Blizz protected Logout so command is dead",
        vers = 0.2,
        state = off,
		isDead = true,
        -- defaultCommand = "",
        -- autorun = false,
        code = {
            "LeaveParty()",
            "LeaveParty()",
            "Logout()",
        },
    },

-- Blizzard killed it in LEGION
    ["quitaftertaxi"] = {
        desc = "quits the game once you land from a taxi flight -- Blizz protected Logout/ForceQuit so dead",
        vers = 1.15,
        alias = "qat",
        state = off,
		isDead = true,
        -- defaultCommand = "",
        -- autorun = false,
        code = {
            "msg = string.lower(msg)",
            "if msg == \"cancel\" then",
            "     print(\"Auto-\"..(static.logout and \"Logout\" or \"Exit\")..\" after Taxi has been cancelled\")",
            "     static.cancel = true",
            "     return",
            "elseif msg == \"logout\" then",
            "     static.logout = true",
            "end",
            "InTime( .1 , 5, function()",
            "    if static.cancel then",
            "        table.wipe(static)",
            "        return true -- returning true stops the repeating of the function",
            "    end",
            "    if not(static.count) or static.count == 3 then static.count = 0 end",
            "    static.count = static.count + 1",
            "    if UnitOnTaxi( \"player\" ) then",
            "        static.running = true",
            "        if static.count == 1 then",
            "            print(\"|cFFFF0000You will \"..(static.logout and\"Logout of\" or \"Exit\")..\" the game once you land (to cancel type /quitaftertaxi cancel)\")",
            "        end",
            "    elseif not(static.running) and static.count == 1 then",
            "        print(\"|cFFFF0000Once you select a flight then land you will \"..(static.logout and\"Logout of\" or \"Exit\")..\" the game (to cancel type /quitaftertaxi cancel)\")",
            "    elseif static.running and static.logout then",
            "        Logout()",
            "    elseif static.running then",
            "        ForceQuit()",
            "    end",
            "end)",
        },
    },
}

for index, value in pairs(SM.Commands_Defaults) do
	if not(SlashMagic_Commands[index]) then
		SlashMagic_Commands[index] = {}
	end
	addOptionMt(SlashMagic_Commands[index], value)
end