local AddonName, AddonTable = ...

local WoWFuncColor = "|c0000ccff"
local eventColor   = "|c00cc66ff"
local methodColor  = "|c0000ffff"
local protectedFuncColor    = "|cFFFF0000"

if type(AddonTable.defaultColorTable) ~= "table" then
	AddonTable.defaultColorTable = {}
end
local ColorTable = AddonTable.defaultColorTable

if type(AddonTable.defaultTextColorTable) ~= "table" then
	AddonTable.defaultTextColorTable = {}
end
local TextColorTable = AddonTable.defaultTextColorTable

-- ****************************************************************************
-- * WoW Functions                                                            *
-- ****************************************************************************

local temp = {		
	"AbandonSkill",
	"AcceptAreaSpiritHeal",
	"AcceptBattlefieldPort",
	"AcceptDuel",
	"AcceptGroup",
	"AcceptGuild",
	"AcceptProposal",
	"AcceptQuest",
	"AcceptResurrect",
	"AcceptSockets",
	"AcceptSpellConfirmationPrompt",
	"AcceptTrade",
	"AcceptXPLoss",
	"AcknowledgeAutoAcceptQuest",
	"AcknowledgeSurvey",
	"ActionBindsItem",
	"ActionHasRange",
	"AddAutoQuestPopUp",
	"AddChatWindowChannel",
	"AddChatWindowMessages",
	"AddTrackedAchievement",
	"AddTradeMoney",
	"Ambiguate",
	"AntiAliasingSupported",
	"ApplyBarberShopStyle",
	"ArchaeologyGetIconInfo",
	"ArchaeologyMapUpdateAll",
	"ArcheologyGetVisibleBlobID",
	"AreAccountAchievementsHidden",
	"AreDangerousScriptsAllowed",
	"AreTalentsLocked",
	"AscendStop",
	"AssistUnit",
	"AttachGlyphToSpell",
	"AttackTarget",
	"AutoChooseCurrentGraphicsSetting",
	"AutoEquipCursorItem",
	"AutoLootMailItem",
	"AutoStoreGuildBankItem",
	"BNAcceptFriendInvite",
	"BNCheckBattleTagInviteToGuildMember",
	"BNCheckBattleTagInviteToUnit",
	"BNConnected",
	"BNDeclineFriendInvite",
	"BNFeaturesEnabled",
	"BNFeaturesEnabledAndConnected",
	"BNGetBlockedInfo",
	"BNGetDisplayName",
	"BNGetFOFInfo",
	"BNGetFriendIndex",
	"BNGetFriendInviteInfo",
	"BNGetInfo",
	"BNGetNumBlocked",
	"BNGetNumFOF",
	"BNGetNumFriendInvites",
	"BNGetNumFriends",
	"BNGetSelectedBlock",
	"BNGetSelectedFriend",
	"BNInviteFriend",
	"BNIsBlocked",
	"BNIsFriend",
	"BNIsSelf",
	"BNRemoveFriend",
	"BNRequestFOFInfo",
	"BNRequestInviteFriend",
	"BNSendFriendInvite",
	"BNSendFriendInviteByID",
	"BNSendGameData",
	"BNSendSoR",
	"BNSendVerifiedBattleTagInvite",
	"BNSendWhisper",
	"BNSetAFK",
	"BNSetBlocked",
	"BNSetCustomMessage",
	"BNSetDND",
	"BNSetFriendFavoriteFlag",
	"BNSetFriendNote",
	"BNSetSelectedBlock",
	"BNSetSelectedFriend",
	"BNSummonFriendByIndex",
	"BNTokenFindName",
	"BankButtonIDToInvSlotID",
	"BarberShopReset",
	"BattlefieldMgrEntryInviteResponse",
	"BattlefieldMgrExitRequest",
	"BattlefieldMgrQueueInviteResponse",
	"BattlefieldMgrQueueRequest",
	"BattlefieldSetPendingReportTarget",
	"BeginTrade",
	"BindEnchant",
	"BreakUpLargeNumbers",
	"BuyGuildBankTab",
	"BuyGuildCharter",
	"BuyMerchantItem",
	"BuyReagentBank",
	"BuyTrainerService",
	"BuybackItem",
	"C_AccountInfo.GetIDFromBattleNetAccountGUID",
	"C_AccountInfo.IsGUIDBattleNetAccountType",
	"C_AccountInfo.IsGUIDRelatedToLocalAccount",
	"C_AchievementInfo.GetRewardItemID",
	"C_AchievementInfo.GetSupercedingAchievements",
	"C_AchievementInfo.IsValidAchievement",
	"C_AchievementInfo.SetPortraitTexture",
	"C_ActionBar.FindFlyoutActionButtons",
	"C_ActionBar.FindPetActionButtons",
	"C_ActionBar.FindSpellActionButtons",
	"C_ActionBar.GetBonusBarIndexForSlot",
	"C_ActionBar.GetPetActionPetBarIndices",
	"C_ActionBar.HasFlyoutActionButtons",
	"C_ActionBar.HasPetActionButtons",
	"C_ActionBar.HasPetActionPetBarIndices",
	"C_ActionBar.HasSpellActionButtons",
	"C_ActionBar.IsAutoCastPetAction",
	"C_ActionBar.IsEnabledAutoCastPetAction",
	"C_ActionBar.IsHarmfulAction",
	"C_ActionBar.IsHelpfulAction",
	"C_ActionBar.IsOnBarOrSpecialBar",
	"C_ActionBar.PutActionInSlot",
	"C_ActionBar.ShouldOverrideBarShowHealthBar",
	"C_ActionBar.ShouldOverrideBarShowManaBar",
	"C_ActionBar.ToggleAutoCastPetAction",
	"C_AdventureJournal.ActivateEntry",
	"C_AdventureJournal.CanBeShown",
	"C_AdventureJournal.GetNumAvailableSuggestions",
	"C_AdventureJournal.GetPrimaryOffset",
	"C_AdventureJournal.GetReward",
	"C_AdventureJournal.GetSuggestions",
	"C_AdventureJournal.SetPrimaryOffset",
	"C_AdventureJournal.UpdateSuggestions",
	"C_AdventureMap.Close",
	"C_AdventureMap.GetMapID",
	"C_AdventureMap.GetMapInsetDetailTileInfo",
	"C_AdventureMap.GetMapInsetInfo",
	"C_AdventureMap.GetNumMapInsets",
	"C_AdventureMap.GetNumQuestOffers",
	"C_AdventureMap.GetNumZoneChoices",
	"C_AdventureMap.GetQuestInfo",
	"C_AdventureMap.GetQuestOfferInfo",
	"C_AdventureMap.GetZoneChoiceInfo",
	"C_AdventureMap.StartQuest",
	"C_AlliedRaces.ClearAlliedRaceDetailsGiver",
	"C_AlliedRaces.GetAllRacialAbilitiesFromID",
	"C_AlliedRaces.GetRaceInfoByID",
	"C_AnimaDiversion.CloseUI",
	"C_AnimaDiversion.GetAnimaDiversionNodes",
	"C_AnimaDiversion.GetOriginPosition",
	"C_AnimaDiversion.GetReinforceProgress",
	"C_AnimaDiversion.GetTextureKit",
	"C_AnimaDiversion.OpenAnimaDiversionUI",
	"C_AnimaDiversion.SelectAnimaNode",
	"C_ArdenwealdGardening.GetGardenData",
	"C_ArdenwealdGardening.IsGardenAccessible",
	"C_AreaPoiInfo.GetAreaPOIForMap",
	"C_AreaPoiInfo.GetAreaPOIInfo",
	"C_AreaPoiInfo.GetAreaPOISecondsLeft",
	"C_AreaPoiInfo.IsAreaPOITimed",
	"C_ArtifactUI.AddPower",
	"C_ArtifactUI.ApplyCursorRelicToSlot",
	"C_ArtifactUI.CanApplyArtifactRelic",
	"C_ArtifactUI.CanApplyCursorRelicToSlot",
	"C_ArtifactUI.CanApplyRelicItemIDToEquippedArtifactSlot",
	"C_ArtifactUI.CanApplyRelicItemIDToSlot",
	"C_ArtifactUI.CheckRespecNPC",
	"C_ArtifactUI.Clear",
	"C_ArtifactUI.ClearForgeCamera",
	"C_ArtifactUI.ConfirmRespec",
	"C_ArtifactUI.DoesEquippedArtifactHaveAnyRelicsSlotted",
	"C_ArtifactUI.GetAppearanceInfo",
	"C_ArtifactUI.GetAppearanceInfoByID",
	"C_ArtifactUI.GetAppearanceSetInfo",
	"C_ArtifactUI.GetArtifactArtInfo",
	"C_ArtifactUI.GetArtifactInfo",
	"C_ArtifactUI.GetArtifactItemID",
	"C_ArtifactUI.GetArtifactTier",
	"C_ArtifactUI.GetArtifactXPRewardTargetInfo",
	"C_ArtifactUI.GetCostForPointAtRank",
	"C_ArtifactUI.GetEquippedArtifactArtInfo",
	"C_ArtifactUI.GetEquippedArtifactInfo",
	"C_ArtifactUI.GetEquippedArtifactItemID",
	"C_ArtifactUI.GetEquippedArtifactNumRelicSlots",
	"C_ArtifactUI.GetEquippedArtifactRelicInfo",
	"C_ArtifactUI.GetEquippedRelicLockedReason",
	"C_ArtifactUI.GetForgeRotation",
	"C_ArtifactUI.GetItemLevelIncreaseProvidedByRelic",
	"C_ArtifactUI.GetMetaPowerInfo",
	"C_ArtifactUI.GetNumAppearanceSets",
	"C_ArtifactUI.GetNumObtainedArtifacts",
	"C_ArtifactUI.GetNumRelicSlots",
	"C_ArtifactUI.GetPointsRemaining",
	"C_ArtifactUI.GetPowerHyperlink",
	"C_ArtifactUI.GetPowerInfo",
	"C_ArtifactUI.GetPowerLinks",
	"C_ArtifactUI.GetPowers",
	"C_ArtifactUI.GetPowersAffectedByRelic",
	"C_ArtifactUI.GetPowersAffectedByRelicItemLink",
	"C_ArtifactUI.GetPreviewAppearance",
	"C_ArtifactUI.GetRelicInfo",
	"C_ArtifactUI.GetRelicInfoByItemID",
	"C_ArtifactUI.GetRelicLockedReason",
	"C_ArtifactUI.GetRelicSlotType",
	"C_ArtifactUI.GetRespecArtifactArtInfo",
	"C_ArtifactUI.GetRespecArtifactInfo",
	"C_ArtifactUI.GetRespecCost",
	"C_ArtifactUI.GetTotalPowerCost",
	"C_ArtifactUI.GetTotalPurchasedRanks",
	"C_ArtifactUI.IsArtifactDisabled",
	"C_ArtifactUI.IsAtForge",
	"C_ArtifactUI.IsEquippedArtifactDisabled",
	"C_ArtifactUI.IsEquippedArtifactMaxed",
	"C_ArtifactUI.IsMaxedByRulesOrEffect",
	"C_ArtifactUI.IsPowerKnown",
	"C_ArtifactUI.IsViewedArtifactEquipped",
	"C_ArtifactUI.SetAppearance",
	"C_ArtifactUI.SetForgeCamera",
	"C_ArtifactUI.SetForgeRotation",
	"C_ArtifactUI.SetPreviewAppearance",
	"C_ArtifactUI.ShouldSuppressForgeRotation",
	"C_AuctionHouse.CalculateCommodityDeposit",
	"C_AuctionHouse.CalculateItemDeposit",
	"C_AuctionHouse.CanCancelAuction",
	"C_AuctionHouse.CancelAuction",
	"C_AuctionHouse.CancelCommoditiesPurchase",
	"C_AuctionHouse.CancelSell",
	"C_AuctionHouse.CloseAuctionHouse",
	"C_AuctionHouse.ConfirmCommoditiesPurchase",
	"C_AuctionHouse.FavoritesAreAvailable",
	"C_AuctionHouse.GetAuctionItemSubClasses",
	"C_AuctionHouse.GetAvailablePostCount",
	"C_AuctionHouse.GetBidInfo",
	"C_AuctionHouse.GetBidType",
	"C_AuctionHouse.GetBrowseResults",
	"C_AuctionHouse.GetCancelCost",
	"C_AuctionHouse.GetCommoditySearchResultInfo",
	"C_AuctionHouse.GetCommoditySearchResultsQuantity",
	"C_AuctionHouse.GetExtraBrowseInfo",
	"C_AuctionHouse.GetFilterGroups",
	"C_AuctionHouse.GetItemCommodityStatus",
	"C_AuctionHouse.GetItemKeyFromItem",
	"C_AuctionHouse.GetItemKeyInfo",
	"C_AuctionHouse.GetItemKeyRequiredLevel",
	"C_AuctionHouse.GetItemSearchResultInfo",
	"C_AuctionHouse.GetItemSearchResultsQuantity",
	"C_AuctionHouse.GetMaxBidItemBid",
	"C_AuctionHouse.GetMaxBidItemBuyout",
	"C_AuctionHouse.GetMaxCommoditySearchResultPrice",
	"C_AuctionHouse.GetMaxItemSearchResultBid",
	"C_AuctionHouse.GetMaxItemSearchResultBuyout",
	"C_AuctionHouse.GetMaxOwnedAuctionBid",
	"C_AuctionHouse.GetMaxOwnedAuctionBuyout",
	"C_AuctionHouse.GetNumBidTypes",
	"C_AuctionHouse.GetNumBids",
	"C_AuctionHouse.GetNumCommoditySearchResults",
	"C_AuctionHouse.GetNumItemSearchResults",
	"C_AuctionHouse.GetNumOwnedAuctionTypes",
	"C_AuctionHouse.GetNumOwnedAuctions",
	"C_AuctionHouse.GetNumReplicateItems",
	"C_AuctionHouse.GetOwnedAuctionInfo",
	"C_AuctionHouse.GetOwnedAuctionType",
	"C_AuctionHouse.GetQuoteDurationRemaining",
	"C_AuctionHouse.GetReplicateItemBattlePetInfo",
	"C_AuctionHouse.GetReplicateItemInfo",
	"C_AuctionHouse.GetReplicateItemLink",
	"C_AuctionHouse.GetReplicateItemTimeLeft",
	"C_AuctionHouse.GetTimeLeftBandInfo",
	"C_AuctionHouse.HasFavorites",
	"C_AuctionHouse.HasFullBidResults",
	"C_AuctionHouse.HasFullBrowseResults",
	"C_AuctionHouse.HasFullCommoditySearchResults",
	"C_AuctionHouse.HasFullItemSearchResults",
	"C_AuctionHouse.HasFullOwnedAuctionResults",
	"C_AuctionHouse.HasMaxFavorites",
	"C_AuctionHouse.HasSearchResults",
	"C_AuctionHouse.IsFavoriteItem",
	"C_AuctionHouse.IsSellItemValid",
	"C_AuctionHouse.IsThrottledMessageSystemReady",
	"C_AuctionHouse.MakeItemKey",
	"C_AuctionHouse.PlaceBid",
	"C_AuctionHouse.PostCommodity",
	"C_AuctionHouse.PostItem",
	"C_AuctionHouse.QueryBids",
	"C_AuctionHouse.QueryOwnedAuctions",
	"C_AuctionHouse.RefreshCommoditySearchResults",
	"C_AuctionHouse.RefreshItemSearchResults",
	"C_AuctionHouse.ReplicateItems",
	"C_AuctionHouse.RequestMoreBrowseResults",
	"C_AuctionHouse.RequestMoreCommoditySearchResults",
	"C_AuctionHouse.RequestMoreItemSearchResults",
	"C_AuctionHouse.RequestOwnedAuctionBidderInfo",
	"C_AuctionHouse.SearchForFavorites",
	"C_AuctionHouse.SearchForItemKeys",
	"C_AuctionHouse.SendBrowseQuery",
	"C_AuctionHouse.SendSearchQuery",
	"C_AuctionHouse.SendSellSearchQuery",
	"C_AuctionHouse.SetFavoriteItem",
	"C_AuctionHouse.StartCommoditiesPurchase",
	"C_AzeriteEmpoweredItem.CanSelectPower",
	"C_AzeriteEmpoweredItem.CloseAzeriteEmpoweredItemRespec",
	"C_AzeriteEmpoweredItem.ConfirmAzeriteEmpoweredItemRespec",
	"C_AzeriteEmpoweredItem.GetAllTierInfo",
	"C_AzeriteEmpoweredItem.GetAllTierInfoByItemID",
	"C_AzeriteEmpoweredItem.GetAzeriteEmpoweredItemRespecCost",
	"C_AzeriteEmpoweredItem.GetPowerInfo",
	"C_AzeriteEmpoweredItem.GetPowerText",
	"C_AzeriteEmpoweredItem.GetSpecsForPower",
	"C_AzeriteEmpoweredItem.HasAnyUnselectedPowers",
	"C_AzeriteEmpoweredItem.HasBeenViewed",
	"C_AzeriteEmpoweredItem.IsAzeriteEmpoweredItem",
	"C_AzeriteEmpoweredItem.IsAzeriteEmpoweredItemByID",
	"C_AzeriteEmpoweredItem.IsAzeritePreviewSourceDisplayable",
	"C_AzeriteEmpoweredItem.IsHeartOfAzerothEquipped",
	"C_AzeriteEmpoweredItem.IsPowerAvailableForSpec",
	"C_AzeriteEmpoweredItem.IsPowerSelected",
	"C_AzeriteEmpoweredItem.SelectPower",
	"C_AzeriteEmpoweredItem.SetHasBeenViewed",
	"C_AzeriteEssence.ActivateEssence",
	"C_AzeriteEssence.CanActivateEssence",
	"C_AzeriteEssence.CanDeactivateEssence",
	"C_AzeriteEssence.CanOpenUI",
	"C_AzeriteEssence.ClearPendingActivationEssence",
	"C_AzeriteEssence.CloseForge",
	"C_AzeriteEssence.GetEssenceHyperlink",
	"C_AzeriteEssence.GetEssenceInfo",
	"C_AzeriteEssence.GetEssences",
	"C_AzeriteEssence.GetMilestoneEssence",
	"C_AzeriteEssence.GetMilestoneInfo",
	"C_AzeriteEssence.GetMilestoneSpell",
	"C_AzeriteEssence.GetMilestones",
	"C_AzeriteEssence.GetNumUnlockedEssences",
	"C_AzeriteEssence.GetNumUsableEssences",
	"C_AzeriteEssence.GetPendingActivationEssence",
	"C_AzeriteEssence.HasNeverActivatedAnyEssences",
	"C_AzeriteEssence.HasPendingActivationEssence",
	"C_AzeriteEssence.IsAtForge",
	"C_AzeriteEssence.SetPendingActivationEssence",
	"C_AzeriteEssence.UnlockMilestone",
	"C_AzeriteItem.FindActiveAzeriteItem",
	"C_AzeriteItem.GetAzeriteItemXPInfo",
	"C_AzeriteItem.GetPowerLevel",
	"C_AzeriteItem.GetUnlimitedPowerLevel",
	"C_AzeriteItem.HasActiveAzeriteItem",
	"C_AzeriteItem.IsAzeriteItem",
	"C_AzeriteItem.IsAzeriteItemAtMaxLevel",
	"C_AzeriteItem.IsAzeriteItemByID",
	"C_AzeriteItem.IsAzeriteItemEnabled",
	"C_BarberShop.ApplyCustomizationChoices",
	"C_BarberShop.Cancel",
	"C_BarberShop.ClearPreviewChoices",
	"C_BarberShop.GetAvailableCustomizations",
	"C_BarberShop.GetCurrentCameraZoom",
	"C_BarberShop.GetCurrentCharacterData",
	"C_BarberShop.GetCurrentCost",
	"C_BarberShop.HasAnyChanges",
	"C_BarberShop.IsViewingAlteredForm",
	"C_BarberShop.OldBarberShopLoaded",
	"C_BarberShop.PreviewCustomizationChoice",
	"C_BarberShop.ResetCameraRotation",
	"C_BarberShop.ResetCustomizationChoices",
	"C_BarberShop.RotateCamera",
	"C_BarberShop.SetCameraDistanceOffset",
	"C_BarberShop.SetCameraZoomLevel",
	"C_BarberShop.SetCustomizationChoice",
	"C_BarberShop.SetModelDressState",
	"C_BarberShop.SetSelectedSex",
	"C_BarberShop.SetViewingAlteredForm",
	"C_BarberShop.SetViewingShapeshiftForm",
	"C_BarberShop.ZoomCamera",
	"C_BattleNet.GetAccountInfoByGUID",
	"C_BattleNet.GetAccountInfoByID",
	"C_BattleNet.GetFriendAccountInfo",
	"C_BattleNet.GetFriendGameAccountInfo",
	"C_BattleNet.GetFriendNumGameAccounts",
	"C_BattleNet.GetGameAccountInfoByGUID",
	"C_BattleNet.GetGameAccountInfoByID",
	"C_BlackMarket.Close",
	"C_BlackMarket.GetHotItem",
	"C_BlackMarket.GetItemInfoByID",
	"C_BlackMarket.GetItemInfoByIndex",
	"C_BlackMarket.GetNumItems",
	"C_BlackMarket.IsViewOnly",
	"C_BlackMarket.ItemPlaceBid",
	"C_BlackMarket.RequestItems",
	"C_CVar.GetCVar",
	"C_CVar.GetCVarBitfield",
	"C_CVar.GetCVarBool",
	"C_CVar.GetCVarDefault",
	"C_CVar.RegisterCVar",
	"C_CVar.ResetTestCVars",
	"C_CVar.SetCVar",
	"C_CVar.SetCVarBitfield",
	"C_Calendar.AddEvent",
	"C_Calendar.AreNamesReady",
	"C_Calendar.CanAddEvent",
	"C_Calendar.CanSendInvite",
	"C_Calendar.CloseEvent",
	"C_Calendar.ContextMenuEventCanComplain",
	"C_Calendar.ContextMenuEventCanEdit",
	"C_Calendar.ContextMenuEventCanRemove",
	"C_Calendar.ContextMenuEventClipboard",
	"C_Calendar.ContextMenuEventComplain",
	"C_Calendar.ContextMenuEventCopy",
	"C_Calendar.ContextMenuEventGetCalendarType",
	"C_Calendar.ContextMenuEventPaste",
	"C_Calendar.ContextMenuEventRemove",
	"C_Calendar.ContextMenuEventSignUp",
	"C_Calendar.ContextMenuGetEventIndex",
	"C_Calendar.ContextMenuInviteAvailable",
	"C_Calendar.ContextMenuInviteDecline",
	"C_Calendar.ContextMenuInviteRemove",
	"C_Calendar.ContextMenuInviteTentative",
	"C_Calendar.ContextMenuSelectEvent",
	"C_Calendar.CreateCommunitySignUpEvent",
	"C_Calendar.CreateGuildAnnouncementEvent",
	"C_Calendar.CreateGuildSignUpEvent",
	"C_Calendar.CreatePlayerEvent",
	"C_Calendar.EventAvailable",
	"C_Calendar.EventCanEdit",
	"C_Calendar.EventClearAutoApprove",
	"C_Calendar.EventClearLocked",
	"C_Calendar.EventClearModerator",
	"C_Calendar.EventDecline",
	"C_Calendar.EventGetCalendarType",
	"C_Calendar.EventGetClubId",
	"C_Calendar.EventGetInvite",
	"C_Calendar.EventGetInviteResponseTime",
	"C_Calendar.EventGetInviteSortCriterion",
	"C_Calendar.EventGetSelectedInvite",
	"C_Calendar.EventGetStatusOptions",
	"C_Calendar.EventGetTextures",
	"C_Calendar.EventGetTypes",
	"C_Calendar.EventGetTypesDisplayOrdered",
	"C_Calendar.EventHasPendingInvite",
	"C_Calendar.EventHaveSettingsChanged",
	"C_Calendar.EventInvite",
	"C_Calendar.EventRemoveInvite",
	"C_Calendar.EventRemoveInviteByGuid",
	"C_Calendar.EventSelectInvite",
	"C_Calendar.EventSetAutoApprove",
	"C_Calendar.EventSetClubId",
	"C_Calendar.EventSetDate",
	"C_Calendar.EventSetDescription",
	"C_Calendar.EventSetInviteStatus",
	"C_Calendar.EventSetLocked",
	"C_Calendar.EventSetModerator",
	"C_Calendar.EventSetTextureID",
	"C_Calendar.EventSetTime",
	"C_Calendar.EventSetTitle",
	"C_Calendar.EventSetType",
	"C_Calendar.EventSignUp",
	"C_Calendar.EventSortInvites",
	"C_Calendar.EventTentative",
	"C_Calendar.GetClubCalendarEvents",
	"C_Calendar.GetDayEvent",
	"C_Calendar.GetDefaultGuildFilter",
	"C_Calendar.GetEventIndex",
	"C_Calendar.GetEventIndexInfo",
	"C_Calendar.GetEventInfo",
	"C_Calendar.GetFirstPendingInvite",
	"C_Calendar.GetGuildEventInfo",
	"C_Calendar.GetGuildEventSelectionInfo",
	"C_Calendar.GetHolidayInfo",
	"C_Calendar.GetMaxCreateDate",
	"C_Calendar.GetMinDate",
	"C_Calendar.GetMonthInfo",
	"C_Calendar.GetNextClubId",
	"C_Calendar.GetNumDayEvents",
	"C_Calendar.GetNumGuildEvents",
	"C_Calendar.GetNumInvites",
	"C_Calendar.GetNumPendingInvites",
	"C_Calendar.GetRaidInfo",
	"C_Calendar.IsActionPending",
	"C_Calendar.IsEventOpen",
	"C_Calendar.MassInviteCommunity",
	"C_Calendar.MassInviteGuild",
	"C_Calendar.OpenCalendar",
	"C_Calendar.OpenEvent",
	"C_Calendar.RemoveEvent",
	"C_Calendar.SetAbsMonth",
	"C_Calendar.SetMonth",
	"C_Calendar.SetNextClubId",
	"C_Calendar.UpdateEvent",
	"C_CampaignInfo.GetAvailableCampaigns",
	"C_CampaignInfo.GetCampaignChapterInfo",
	"C_CampaignInfo.GetCampaignID",
	"C_CampaignInfo.GetCampaignInfo",
	"C_CampaignInfo.GetChapterIDs",
	"C_CampaignInfo.GetCurrentChapterID",
	"C_CampaignInfo.GetFailureReason",
	"C_CampaignInfo.GetState",
	"C_CampaignInfo.IsCampaignQuest",
	"C_CampaignInfo.UsesNormalQuestIcons",
	"C_ChallengeMode.ClearKeystone",
	"C_ChallengeMode.CloseKeystoneFrame",
	"C_ChallengeMode.GetActiveChallengeMapID",
	"C_ChallengeMode.GetActiveKeystoneInfo",
	"C_ChallengeMode.GetAffixInfo",
	"C_ChallengeMode.GetCompletionInfo",
	"C_ChallengeMode.GetDeathCount",
	"C_ChallengeMode.GetGuildLeaders",
	"C_ChallengeMode.GetMapTable",
	"C_ChallengeMode.GetMapUIInfo",
	"C_ChallengeMode.GetPowerLevelDamageHealthMod",
	"C_ChallengeMode.GetSlottedKeystoneInfo",
	"C_ChallengeMode.HasSlottedKeystone",
	"C_ChallengeMode.IsChallengeModeActive",
	"C_ChallengeMode.RemoveKeystone",
	"C_ChallengeMode.RequestLeaders",
	"C_ChallengeMode.Reset",
	"C_ChallengeMode.SetKeystoneTooltip",
	"C_ChallengeMode.SlotKeystone",
	"C_ChallengeMode.StartChallengeMode",
	"C_CharacterServices.AssignUpgradeDistribution",
	"C_CharacterServices.GetActiveCharacterUpgradeBoostType",
	"C_CharacterServices.GetActiveClassTrialBoostType",
	"C_CharacterServices.GetAutomaticBoost",
	"C_CharacterServices.GetAutomaticBoostCharacter",
	"C_CharacterServices.GetCharacterServiceDisplayData",
	"C_CharacterServices.GetCharacterServiceDisplayOrder",
	"C_CharacterServices.HasRequiredBoostForClassTrial",
	"C_CharacterServices.HasRequiredBoostForUnrevoke",
	"C_CharacterServices.SetAutomaticBoost",
	"C_CharacterServices.SetAutomaticBoostCharacter",
	"C_CharacterServicesPublic.ShouldSeeControlPopup",
	"C_ChatBubbles.GetAllChatBubbles",
	"C_ChatInfo.GetChannelRosterInfo",
	"C_ChatInfo.GetChannelRuleset",
	"C_ChatInfo.GetChannelRulesetForChannelID",
	"C_ChatInfo.GetChannelShortcut",
	"C_ChatInfo.GetChannelShortcutForChannelID",
	"C_ChatInfo.GetClubStreamIDs",
	"C_ChatInfo.GetGeneralChannelID",
	"C_ChatInfo.GetGeneralChannelLocalID",
	"C_ChatInfo.GetMentorChannelID",
	"C_ChatInfo.GetNumActiveChannels",
	"C_ChatInfo.GetRegisteredAddonMessagePrefixes",
	"C_ChatInfo.IsAddonMessagePrefixRegistered",
	"C_ChatInfo.IsChannelRegional",
	"C_ChatInfo.IsChannelRegionalForChannelID",
	"C_ChatInfo.IsPartyChannelType",
	"C_ChatInfo.IsRegionalServiceAvailable",
	"C_ChatInfo.IsValidChatLine",
	"C_ChatInfo.RegisterAddonMessagePrefix",
	"C_ChatInfo.ReplaceIconAndGroupExpressions",
	"C_ChatInfo.ResetDefaultZoneChannels",
	"C_ChatInfo.SendAddonMessage",
	"C_ChatInfo.SendAddonMessageLogged",
	"C_ChatInfo.SwapChatChannelsByChannelIndex",
	"C_ChromieTime.CloseUI",
	"C_ChromieTime.GetChromieTimeExpansionOption",
	"C_ChromieTime.GetChromieTimeExpansionOptions",
	"C_ChromieTime.SelectChromieTimeOption",
	"C_ClassColor.GetClassColor",
	"C_ClassTrial.GetClassTrialLogoutTimeSeconds",
	"C_ClassTrial.IsClassTrialCharacter",
	"C_Club.AcceptInvitation",
	"C_Club.AddClubStreamChatChannel",
	"C_Club.AdvanceStreamViewMarker",
	"C_Club.AssignMemberRole",
	"C_Club.CanResolvePlayerLocationFromClubMessageData",
	"C_Club.ClearAutoAdvanceStreamViewMarker",
	"C_Club.ClearClubPresenceSubscription",
	"C_Club.CompareBattleNetDisplayName",
	"C_Club.CreateClub",
	"C_Club.CreateStream",
	"C_Club.CreateTicket",
	"C_Club.DeclineInvitation",
	"C_Club.DestroyClub",
	"C_Club.DestroyMessage",
	"C_Club.DestroyStream",
	"C_Club.DestroyTicket",
	"C_Club.EditClub",
	"C_Club.EditMessage",
	"C_Club.EditStream",
	"C_Club.Flush",
	"C_Club.FocusStream",
	"C_Club.GetAssignableRoles",
	"C_Club.GetAvatarIdList",
	"C_Club.GetClubCapacity",
	"C_Club.GetClubInfo",
	"C_Club.GetClubLimits",
	"C_Club.GetClubMembers",
	"C_Club.GetClubPrivileges",
	"C_Club.GetClubStreamNotificationSettings",
	"C_Club.GetCommunityNameResultText",
	"C_Club.GetGuildClubId",
	"C_Club.GetInfoFromLastCommunityChatLine",
	"C_Club.GetInvitationCandidates",
	"C_Club.GetInvitationInfo",
	"C_Club.GetInvitationsForClub",
	"C_Club.GetInvitationsForSelf",
	"C_Club.GetLastTicketResponse",
	"C_Club.GetMemberInfo",
	"C_Club.GetMemberInfoForSelf",
	"C_Club.GetMessageInfo",
	"C_Club.GetMessageRanges",
	"C_Club.GetMessagesBefore",
	"C_Club.GetMessagesInRange",
	"C_Club.GetStreamInfo",
	"C_Club.GetStreamViewMarker",
	"C_Club.GetStreams",
	"C_Club.GetSubscribedClubs",
	"C_Club.GetTickets",
	"C_Club.IsAccountMuted",
	"C_Club.IsBeginningOfStream",
	"C_Club.IsEnabled",
	"C_Club.IsRestricted",
	"C_Club.IsSubscribedToStream",
	"C_Club.KickMember",
	"C_Club.LeaveClub",
	"C_Club.RedeemTicket",
	"C_Club.RequestInvitationsForClub",
	"C_Club.RequestMoreMessagesBefore",
	"C_Club.RequestTicket",
	"C_Club.RequestTickets",
	"C_Club.RevokeInvitation",
	"C_Club.SendBattleTagFriendRequest",
	"C_Club.SendCharacterInvitation",
	"C_Club.SendInvitation",
	"C_Club.SendMessage",
	"C_Club.SetAutoAdvanceStreamViewMarker",
	"C_Club.SetAvatarTexture",
	"C_Club.SetClubMemberNote",
	"C_Club.SetClubPresenceSubscription",
	"C_Club.SetClubStreamNotificationSettings",
	"C_Club.SetFavorite",
	"C_Club.SetSocialQueueingEnabled",
	"C_Club.ShouldAllowClubType",
	"C_Club.UnfocusStream",
	"C_Club.ValidateText",
	"C_ClubFinder.ApplicantAcceptClubInvite",
	"C_ClubFinder.ApplicantDeclineClubInvite",
	"C_ClubFinder.CancelMembershipRequest",
	"C_ClubFinder.CheckAllPlayerApplicantSettings",
	"C_ClubFinder.ClearAllFinderCache",
	"C_ClubFinder.ClearClubApplicantsCache",
	"C_ClubFinder.ClearClubFinderPostingsCache",
	"C_ClubFinder.DoesPlayerBelongToClubFromClubGUID",
	"C_ClubFinder.GetClubFinderDisableReason",
	"C_ClubFinder.GetClubRecruitmentSettings",
	"C_ClubFinder.GetClubTypeFromFinderGUID",
	"C_ClubFinder.GetFocusIndexFromFlag",
	"C_ClubFinder.GetPlayerApplicantLocaleFlags",
	"C_ClubFinder.GetPlayerApplicantSettings",
	"C_ClubFinder.GetPlayerClubApplicationStatus",
	"C_ClubFinder.GetPlayerSettingsFocusFlagsSelectedCount",
	"C_ClubFinder.GetPostingIDFromClubFinderGUID",
	"C_ClubFinder.GetRecruitingClubInfoFromClubID",
	"C_ClubFinder.GetRecruitingClubInfoFromFinderGUID",
	"C_ClubFinder.GetStatusOfPostingFromClubId",
	"C_ClubFinder.GetTotalMatchingCommunityListSize",
	"C_ClubFinder.GetTotalMatchingGuildListSize",
	"C_ClubFinder.HasAlreadyAppliedToLinkedPosting",
	"C_ClubFinder.HasPostingBeenDelisted",
	"C_ClubFinder.IsEnabled",
	"C_ClubFinder.IsListingEnabledFromFlags",
	"C_ClubFinder.IsPostingBanned",
	"C_ClubFinder.LookupClubPostingFromClubFinderGUID",
	"C_ClubFinder.PlayerGetClubInvitationList",
	"C_ClubFinder.PlayerRequestPendingClubsList",
	"C_ClubFinder.PlayerReturnPendingCommunitiesList",
	"C_ClubFinder.PlayerReturnPendingGuildsList",
	"C_ClubFinder.PostClub",
	"C_ClubFinder.ReportPosting",
	"C_ClubFinder.RequestApplicantList",
	"C_ClubFinder.RequestClubsList",
	"C_ClubFinder.RequestMembershipToClub",
	"C_ClubFinder.RequestNextCommunityPage",
	"C_ClubFinder.RequestNextGuildPage",
	"C_ClubFinder.RequestPostingInformationFromClubId",
	"C_ClubFinder.RequestSubscribedClubPostingIDs",
	"C_ClubFinder.ResetClubPostingMapCache",
	"C_ClubFinder.RespondToApplicant",
	"C_ClubFinder.ReturnClubApplicantList",
	"C_ClubFinder.ReturnMatchingCommunityList",
	"C_ClubFinder.ReturnMatchingGuildList",
	"C_ClubFinder.ReturnPendingClubApplicantList",
	"C_ClubFinder.SetAllRecruitmentSettings",
	"C_ClubFinder.SetPlayerApplicantLocaleFlags",
	"C_ClubFinder.SetPlayerApplicantSettings",
	"C_ClubFinder.SetRecruitmentLocale",
	"C_ClubFinder.SetRecruitmentSettings",
	"C_ClubFinder.ShouldShowClubFinder",
	"C_Commentator.AddPlayerOverrideName",
	"C_Commentator.AddTrackedDefensiveAuras",
	"C_Commentator.AddTrackedOffensiveAuras",
	"C_Commentator.AreTeamsSwapped",
	"C_Commentator.AssignPlayerToTeam",
	"C_Commentator.AssignPlayersToTeam",
	"C_Commentator.AssignPlayersToTeamInCurrentInstance",
	"C_Commentator.CanUseCommentatorCheats",
	"C_Commentator.ClearCameraTarget",
	"C_Commentator.ClearFollowTarget",
	"C_Commentator.ClearLookAtTarget",
	"C_Commentator.EnterInstance",
	"C_Commentator.ExitInstance",
	"C_Commentator.FindSpectatedUnit",
	"C_Commentator.FindTeamNameInCurrentInstance",
	"C_Commentator.FindTeamNameInDirectory",
	"C_Commentator.FlushCommentatorHistory",
	"C_Commentator.FollowPlayer",
	"C_Commentator.FollowUnit",
	"C_Commentator.ForceFollowTransition",
	"C_Commentator.GetAdditionalCameraWeight",
	"C_Commentator.GetAdditionalCameraWeightByToken",
	"C_Commentator.GetAllPlayerOverrideNames",
	"C_Commentator.GetCamera",
	"C_Commentator.GetCameraCollision",
	"C_Commentator.GetCameraPosition",
	"C_Commentator.GetCommentatorHistory",
	"C_Commentator.GetCurrentMapID",
	"C_Commentator.GetDampeningPercent",
	"C_Commentator.GetDistanceBeforeForcedHorizontalConvergence",
	"C_Commentator.GetDurationToForceHorizontalConvergence",
	"C_Commentator.GetExcludeDistance",
	"C_Commentator.GetHardlockWeight",
	"C_Commentator.GetHorizontalAngleThresholdToSmooth",
	"C_Commentator.GetIndirectSpellID",
	"C_Commentator.GetInstanceInfo",
	"C_Commentator.GetLookAtLerpAmount",
	"C_Commentator.GetMapInfo",
	"C_Commentator.GetMatchDuration",
	"C_Commentator.GetMaxNumPlayersPerTeam",
	"C_Commentator.GetMaxNumTeams",
	"C_Commentator.GetMode",
	"C_Commentator.GetMsToHoldForHorizontalMovement",
	"C_Commentator.GetMsToHoldForVerticalMovement",
	"C_Commentator.GetMsToSmoothHorizontalChange",
	"C_Commentator.GetMsToSmoothVerticalChange",
	"C_Commentator.GetNumMaps",
	"C_Commentator.GetNumPlayers",
	"C_Commentator.GetOrCreateSeries",
	"C_Commentator.GetPlayerAuraInfo",
	"C_Commentator.GetPlayerAuraInfoByUnit",
	"C_Commentator.GetPlayerCooldownInfo",
	"C_Commentator.GetPlayerCooldownInfoByUnit",
	"C_Commentator.GetPlayerCrowdControlInfo",
	"C_Commentator.GetPlayerCrowdControlInfoByUnit",
	"C_Commentator.GetPlayerData",
	"C_Commentator.GetPlayerFlagInfo",
	"C_Commentator.GetPlayerFlagInfoByUnit",
	"C_Commentator.GetPlayerOverrideName",
	"C_Commentator.GetPlayerSpellCharges",
	"C_Commentator.GetPlayerSpellChargesByUnit",
	"C_Commentator.GetPositionLerpAmount",
	"C_Commentator.GetSmoothFollowTransitioning",
	"C_Commentator.GetSoftlockWeight",
	"C_Commentator.GetSpeedFactor",
	"C_Commentator.GetStartLocation",
	"C_Commentator.GetTeamColor",
	"C_Commentator.GetTeamColorByUnit",
	"C_Commentator.GetTimeLeftInMatch",
	"C_Commentator.GetTrackedSpellID",
	"C_Commentator.GetTrackedSpells",
	"C_Commentator.GetTrackedSpellsByUnit",
	"C_Commentator.GetUnitData",
	"C_Commentator.GetWargameInfo",
	"C_Commentator.HasTrackedAuras",
	"C_Commentator.IsSmartCameraLocked",
	"C_Commentator.IsSpectating",
	"C_Commentator.IsTrackedDefensiveAura",
	"C_Commentator.IsTrackedOffensiveAura",
	"C_Commentator.IsTrackedSpell",
	"C_Commentator.IsTrackedSpellByUnit",
	"C_Commentator.IsUsingSmartCamera",
	"C_Commentator.LookAtPlayer",
	"C_Commentator.RemoveAllOverrideNames",
	"C_Commentator.RemovePlayerOverrideName",
	"C_Commentator.RequestPlayerCooldownInfo",
	"C_Commentator.ResetFoVTarget",
	"C_Commentator.ResetSeriesScores",
	"C_Commentator.ResetSettings",
	"C_Commentator.ResetTrackedAuras",
	"C_Commentator.SetAdditionalCameraWeight",
	"C_Commentator.SetAdditionalCameraWeightByToken",
	"C_Commentator.SetBlacklistedAuras",
	"C_Commentator.SetBlacklistedCooldowns",
	"C_Commentator.SetCamera",
	"C_Commentator.SetCameraCollision",
	"C_Commentator.SetCameraPosition",
	"C_Commentator.SetCheatsEnabled",
	"C_Commentator.SetCommentatorHistory",
	"C_Commentator.SetDistanceBeforeForcedHorizontalConvergence",
	"C_Commentator.SetDurationToForceHorizontalConvergence",
	"C_Commentator.SetExcludeDistance",
	"C_Commentator.SetFollowCameraSpeeds",
	"C_Commentator.SetHardlockWeight",
	"C_Commentator.SetHorizontalAngleThresholdToSmooth",
	"C_Commentator.SetLookAtLerpAmount",
	"C_Commentator.SetMapAndInstanceIndex",
	"C_Commentator.SetMouseDisabled",
	"C_Commentator.SetMoveSpeed",
	"C_Commentator.SetMsToHoldForHorizontalMovement",
	"C_Commentator.SetMsToHoldForVerticalMovement",
	"C_Commentator.SetMsToSmoothHorizontalChange",
	"C_Commentator.SetMsToSmoothVerticalChange",
	"C_Commentator.SetPositionLerpAmount",
	"C_Commentator.SetRequestedDebuffCooldowns",
	"C_Commentator.SetRequestedDefensiveCooldowns",
	"C_Commentator.SetRequestedOffensiveCooldowns",
	"C_Commentator.SetSeriesScore",
	"C_Commentator.SetSeriesScores",
	"C_Commentator.SetSmartCameraLocked",
	"C_Commentator.SetSmoothFollowTransitioning",
	"C_Commentator.SetSoftlockWeight",
	"C_Commentator.SetSpeedFactor",
	"C_Commentator.SetTargetHeightOffset",
	"C_Commentator.SetUseSmartCamera",
	"C_Commentator.SnapCameraLookAtPoint",
	"C_Commentator.StartWargame",
	"C_Commentator.SwapTeamSides",
	"C_Commentator.ToggleCheats",
	"C_Commentator.UpdateMapInfo",
	"C_Commentator.UpdatePlayerInfo",
	"C_Commentator.ZoomIn",
	"C_Commentator.ZoomOut",
	"C_Console.GetAllCommands",
	"C_Console.GetColorFromType",
	"C_Console.GetFontHeight",
	"C_Console.PrintAllMatchingCommands",
	"C_Console.SetFontHeight",
	"C_ContributionCollector.Close",
	"C_ContributionCollector.Contribute",
	"C_ContributionCollector.GetActive",
	"C_ContributionCollector.GetAtlases",
	"C_ContributionCollector.GetBuffs",
	"C_ContributionCollector.GetContributionAppearance",
	"C_ContributionCollector.GetContributionCollectorsForMap",
	"C_ContributionCollector.GetContributionResult",
	"C_ContributionCollector.GetDescription",
	"C_ContributionCollector.GetManagedContributionsForCreatureID",
	"C_ContributionCollector.GetName",
	"C_ContributionCollector.GetOrderIndex",
	"C_ContributionCollector.GetRequiredContributionCurrency",
	"C_ContributionCollector.GetRequiredContributionItem",
	"C_ContributionCollector.GetRewardQuestID",
	"C_ContributionCollector.GetState",
	"C_ContributionCollector.HasPendingContribution",
	"C_ContributionCollector.IsAwaitingRewardQuestData",
	"C_CovenantCallings.AreCallingsUnlocked",
	"C_CovenantCallings.RequestCallings",
	"C_CovenantPreview.CloseFromUI",
	"C_CovenantPreview.GetCovenantInfoForPlayerChoiceResponseID",
	"C_CovenantSanctumUI.CanAccessReservoir",
	"C_CovenantSanctumUI.CanDepositAnima",
	"C_CovenantSanctumUI.DepositAnima",
	"C_CovenantSanctumUI.EndInteraction",
	"C_CovenantSanctumUI.GetAnimaInfo",
	"C_CovenantSanctumUI.GetCurrentTalentTreeID",
	"C_CovenantSanctumUI.GetFeatures",
	"C_CovenantSanctumUI.GetRenownLevel",
	"C_CovenantSanctumUI.GetRenownLevels",
	"C_CovenantSanctumUI.GetRenownRewardsForLevel",
	"C_CovenantSanctumUI.GetSanctumType",
	"C_CovenantSanctumUI.GetSoulCurrencies",
	"C_Covenants.GetActiveCovenantID",
	"C_Covenants.GetCovenantData",
	"C_Covenants.GetCovenantIDs",
	"C_CreatureInfo.GetClassInfo",
	"C_CreatureInfo.GetFactionInfo",
	"C_CreatureInfo.GetRaceInfo",
	"C_CurrencyInfo.DoesWarModeBonusApply",
	"C_CurrencyInfo.ExpandCurrencyList",
	"C_CurrencyInfo.GetAzeriteCurrencyID",
	"C_CurrencyInfo.GetBackpackCurrencyInfo",
	"C_CurrencyInfo.GetBasicCurrencyInfo",
	"C_CurrencyInfo.GetCurrencyContainerInfo",
	"C_CurrencyInfo.GetCurrencyIDFromLink",
	"C_CurrencyInfo.GetCurrencyInfo",
	"C_CurrencyInfo.GetCurrencyInfoFromLink",
	"C_CurrencyInfo.GetCurrencyLink",
	"C_CurrencyInfo.GetCurrencyListInfo",
	"C_CurrencyInfo.GetCurrencyListLink",
	"C_CurrencyInfo.GetCurrencyListSize",
	"C_CurrencyInfo.GetFactionGrantedByCurrency",
	"C_CurrencyInfo.GetWarResourcesCurrencyID",
	"C_CurrencyInfo.IsCurrencyContainer",
	"C_CurrencyInfo.PickupCurrency",
	"C_CurrencyInfo.SetCurrencyBackpack",
	"C_CurrencyInfo.SetCurrencyUnused",
	"C_Cursor.DropCursorCommunitiesStream",
	"C_Cursor.GetCursorCommunitiesStream",
	"C_Cursor.GetCursorItem",
	"C_Cursor.SetCursorCommunitiesStream",
	"C_DateAndTime.AdjustTimeByDays",
	"C_DateAndTime.AdjustTimeByMinutes",
	"C_DateAndTime.CompareCalendarTime",
	"C_DateAndTime.GetCalendarTimeFromEpoch",
	"C_DateAndTime.GetCurrentCalendarTime",
	"C_DateAndTime.GetSecondsUntilDailyReset",
	"C_DateAndTime.GetSecondsUntilWeeklyReset",
	"C_DateAndTime.GetServerTimeLocal",
	"C_DeathInfo.GetCorpseMapPosition",
	"C_DeathInfo.GetDeathReleasePosition",
	"C_DeathInfo.GetGraveyardsForMap",
	"C_DeathInfo.GetSelfResurrectOptions",
	"C_DeathInfo.UseSelfResurrectOption",
	"C_Debug.DashboardIsEnabled",
	"C_Debug.GetAllPortLocsForMap",
	"C_Debug.GetMapDebugObjects",
	"C_Debug.TeleportToMapDebugObject",
	"C_Debug.TeleportToMapLocation",
	"C_EncounterJournal.GetDungeonEntrancesForMap",
	"C_EncounterJournal.GetEncountersOnMap",
	"C_EncounterJournal.GetLootInfo",
	"C_EncounterJournal.GetLootInfoByIndex",
	"C_EncounterJournal.GetSectionIconFlags",
	"C_EncounterJournal.GetSectionInfo",
	"C_EncounterJournal.GetSlotFilter",
	"C_EncounterJournal.InstanceHasLoot",
	"C_EncounterJournal.IsEncounterComplete",
	"C_EncounterJournal.ResetSlotFilter",
	"C_EncounterJournal.SetPreviewMythicPlusLevel",
	"C_EncounterJournal.SetPreviewPvpTier",
	"C_EncounterJournal.SetSlotFilter",
	"C_EquipmentSet.AssignSpecToEquipmentSet",
	"C_EquipmentSet.CanUseEquipmentSets",
	"C_EquipmentSet.ClearIgnoredSlotsForSave",
	"C_EquipmentSet.CreateEquipmentSet",
	"C_EquipmentSet.DeleteEquipmentSet",
	"C_EquipmentSet.EquipmentSetContainsLockedItems",
	"C_EquipmentSet.GetEquipmentSetAssignedSpec",
	"C_EquipmentSet.GetEquipmentSetForSpec",
	"C_EquipmentSet.GetEquipmentSetID",
	"C_EquipmentSet.GetEquipmentSetIDs",
	"C_EquipmentSet.GetEquipmentSetInfo",
	"C_EquipmentSet.GetIgnoredSlots",
	"C_EquipmentSet.GetItemIDs",
	"C_EquipmentSet.GetItemLocations",
	"C_EquipmentSet.GetNumEquipmentSets",
	"C_EquipmentSet.IgnoreSlotForSave",
	"C_EquipmentSet.IsSlotIgnoredForSave",
	"C_EquipmentSet.ModifyEquipmentSet",
	"C_EquipmentSet.PickupEquipmentSet",
	"C_EquipmentSet.SaveEquipmentSet",
	"C_EquipmentSet.UnassignEquipmentSetSpec",
	"C_EquipmentSet.UnignoreSlotForSave",
	"C_EquipmentSet.UseEquipmentSet",
	"C_FogOfWar.GetFogOfWarForMap",
	"C_FogOfWar.GetFogOfWarInfo",
	"C_FriendList.AddFriend",
	"C_FriendList.AddIgnore",
	"C_FriendList.AddOrDelIgnore",
	"C_FriendList.AddOrRemoveFriend",
	"C_FriendList.DelIgnore",
	"C_FriendList.DelIgnoreByIndex",
	"C_FriendList.GetFriendInfo",
	"C_FriendList.GetFriendInfoByIndex",
	"C_FriendList.GetIgnoreName",
	"C_FriendList.GetNumFriends",
	"C_FriendList.GetNumIgnores",
	"C_FriendList.GetNumOnlineFriends",
	"C_FriendList.GetNumWhoResults",
	"C_FriendList.GetSelectedFriend",
	"C_FriendList.GetSelectedIgnore",
	"C_FriendList.GetWhoInfo",
	"C_FriendList.IsFriend",
	"C_FriendList.IsIgnored",
	"C_FriendList.IsIgnoredByGuid",
	"C_FriendList.RemoveFriend",
	"C_FriendList.RemoveFriendByIndex",
	"C_FriendList.SendWho",
	"C_FriendList.SetFriendNotes",
	"C_FriendList.SetFriendNotesByIndex",
	"C_FriendList.SetSelectedFriend",
	"C_FriendList.SetSelectedIgnore",
	"C_FriendList.SetWhoToUi",
	"C_FriendList.ShowFriends",
	"C_FriendList.SortWho",
	"C_GamePad.ApplyConfigs",
	"C_GamePad.AxisIndexToConfigName",
	"C_GamePad.ButtonBindingToIndex",
	"C_GamePad.ButtonIndexToBinding",
	"C_GamePad.ButtonIndexToConfigName",
	"C_GamePad.DeleteConfig",
	"C_GamePad.GetActiveDeviceID",
	"C_GamePad.GetAllConfigIDs",
	"C_GamePad.GetAllDeviceIDs",
	"C_GamePad.GetCombinedDeviceID",
	"C_GamePad.GetConfig",
	"C_GamePad.GetDeviceMappedState",
	"C_GamePad.GetDeviceRawState",
	"C_GamePad.IsEnabled",
	"C_GamePad.SetConfig",
	"C_GamePad.StickIndexToConfigName",
	"C_Garrison.AddFollowerToMission",
	"C_Garrison.AllowMissionStartAboveSoftCap",
	"C_Garrison.AreMissionFollowerRequirementsMet",
	"C_Garrison.AssignFollowerToBuilding",
	"C_Garrison.CanGenerateRecruits",
	"C_Garrison.CanOpenMissionChest",
	"C_Garrison.CanSetRecruitmentPreference",
	"C_Garrison.CanSpellTargetFollowerIDWithAddAbility",
	"C_Garrison.CanUpgradeGarrison",
	"C_Garrison.CancelConstruction",
	"C_Garrison.CastItemSpellOnFollowerAbility",
	"C_Garrison.CastSpellOnFollower",
	"C_Garrison.CastSpellOnFollowerAbility",
	"C_Garrison.CastSpellOnMission",
	"C_Garrison.ClearCompleteTalent",
	"C_Garrison.CloseArchitect",
	"C_Garrison.CloseGarrisonTradeskillNPC",
	"C_Garrison.CloseMissionNPC",
	"C_Garrison.CloseRecruitmentNPC",
	"C_Garrison.CloseTalentNPC",
	"C_Garrison.CloseTradeskillCrafter",
	"C_Garrison.GenerateRecruits",
	"C_Garrison.GetAllBonusAbilityEffects",
	"C_Garrison.GetAllEncounterThreats",
	"C_Garrison.GetAutoCombatDamageClassValues",
	"C_Garrison.GetAutoMissionBoardState",
	"C_Garrison.GetAutoMissionEnvironmentEffect",
	"C_Garrison.GetAutoMissionTargetingInfo",
	"C_Garrison.GetAutoTroops",
	"C_Garrison.GetAvailableMissions",
	"C_Garrison.GetAvailableRecruits",
	"C_Garrison.GetBasicMissionInfo",
	"C_Garrison.GetBuffedFollowersForMission",
	"C_Garrison.GetBuildingInfo",
	"C_Garrison.GetBuildingLockInfo",
	"C_Garrison.GetBuildingSizes",
	"C_Garrison.GetBuildingSpecInfo",
	"C_Garrison.GetBuildingTimeRemaining",
	"C_Garrison.GetBuildingTooltip",
	"C_Garrison.GetBuildingUpgradeInfo",
	"C_Garrison.GetBuildings",
	"C_Garrison.GetBuildingsForPlot",
	"C_Garrison.GetBuildingsForSize",
	"C_Garrison.GetClassSpecCategoryInfo",
	"C_Garrison.GetCombatAllyMission",
	"C_Garrison.GetCombatLogSpellInfo",
	"C_Garrison.GetCompleteMissions",
	"C_Garrison.GetCompleteTalent",
	"C_Garrison.GetCurrencyTypes",
	"C_Garrison.GetCurrentGarrTalentTreeFriendshipFactionID",
	"C_Garrison.GetCurrentGarrTalentTreeID",
	"C_Garrison.GetFollowerAbilities",
	"C_Garrison.GetFollowerAbilityAtIndex",
	"C_Garrison.GetFollowerAbilityAtIndexByID",
	"C_Garrison.GetFollowerAbilityCounterMechanicInfo",
	"C_Garrison.GetFollowerAbilityCountersForMechanicTypes",
	"C_Garrison.GetFollowerAbilityDescription",
	"C_Garrison.GetFollowerAbilityIcon",
	"C_Garrison.GetFollowerAbilityInfo",
	"C_Garrison.GetFollowerAbilityIsTrait",
	"C_Garrison.GetFollowerAbilityLink",
	"C_Garrison.GetFollowerAbilityName",
	"C_Garrison.GetFollowerActivationCost",
	"C_Garrison.GetFollowerAutoCombatSpells",
	"C_Garrison.GetFollowerAutoCombatStats",
	"C_Garrison.GetFollowerBiasForMission",
	"C_Garrison.GetFollowerClassSpec",
	"C_Garrison.GetFollowerClassSpecAtlas",
	"C_Garrison.GetFollowerClassSpecByID",
	"C_Garrison.GetFollowerClassSpecName",
	"C_Garrison.GetFollowerDisplayID",
	"C_Garrison.GetFollowerInfo",
	"C_Garrison.GetFollowerInfoForBuilding",
	"C_Garrison.GetFollowerIsTroop",
	"C_Garrison.GetFollowerItemLevelAverage",
	"C_Garrison.GetFollowerItems",
	"C_Garrison.GetFollowerLevel",
	"C_Garrison.GetFollowerLevelXP",
	"C_Garrison.GetFollowerLink",
	"C_Garrison.GetFollowerLinkByID",
	"C_Garrison.GetFollowerMissionCompleteInfo",
	"C_Garrison.GetFollowerMissionTimeLeft",
	"C_Garrison.GetFollowerMissionTimeLeftSeconds",
	"C_Garrison.GetFollowerModelItems",
	"C_Garrison.GetFollowerName",
	"C_Garrison.GetFollowerNameByID",
	"C_Garrison.GetFollowerPortraitIconID",
	"C_Garrison.GetFollowerPortraitIconIDByID",
	"C_Garrison.GetFollowerQuality",
	"C_Garrison.GetFollowerQualityTable",
	"C_Garrison.GetFollowerRecentlyGainedAbilityIDs",
	"C_Garrison.GetFollowerRecentlyGainedTraitIDs",
	"C_Garrison.GetFollowerShipments",
	"C_Garrison.GetFollowerSoftCap",
	"C_Garrison.GetFollowerSourceTextByID",
	"C_Garrison.GetFollowerSpecializationAtIndex",
	"C_Garrison.GetFollowerStatus",
	"C_Garrison.GetFollowerTraitAtIndex",
	"C_Garrison.GetFollowerTraitAtIndexByID",
	"C_Garrison.GetFollowerTypeByID",
	"C_Garrison.GetFollowerTypeByMissionID",
	"C_Garrison.GetFollowerUnderBiasReason",
	"C_Garrison.GetFollowerXP",
	"C_Garrison.GetFollowerXPTable",
	"C_Garrison.GetFollowerZoneSupportAbilities",
	"C_Garrison.GetFollowers",
	"C_Garrison.GetFollowersSpellsForMission",
	"C_Garrison.GetFollowersTraitsForMission",
	"C_Garrison.GetGarrisonInfo",
	"C_Garrison.GetGarrisonPlotsInstancesForMap",
	"C_Garrison.GetGarrisonTalentTreeCurrencyTypes",
	"C_Garrison.GetGarrisonTalentTreeType",
	"C_Garrison.GetGarrisonUpgradeCost",
	"C_Garrison.GetInProgressMissions",
	"C_Garrison.GetLandingPageGarrisonType",
	"C_Garrison.GetLandingPageItems",
	"C_Garrison.GetLandingPageShipmentCount",
	"C_Garrison.GetLandingPageShipmentInfo",
	"C_Garrison.GetLandingPageShipmentInfoByContainerID",
	"C_Garrison.GetLooseShipments",
	"C_Garrison.GetMissionBonusAbilityEffects",
	"C_Garrison.GetMissionCompleteEncounters",
	"C_Garrison.GetMissionCost",
	"C_Garrison.GetMissionDeploymentInfo",
	"C_Garrison.GetMissionDisplayIDs",
	"C_Garrison.GetMissionEncounterIconInfo",
	"C_Garrison.GetMissionLink",
	"C_Garrison.GetMissionMaxFollowers",
	"C_Garrison.GetMissionName",
	"C_Garrison.GetMissionRewardInfo",
	"C_Garrison.GetMissionSuccessChance",
	"C_Garrison.GetMissionTexture",
	"C_Garrison.GetMissionTimes",
	"C_Garrison.GetMissionUncounteredMechanics",
	"C_Garrison.GetNumActiveFollowers",
	"C_Garrison.GetNumFollowerActivationsRemaining",
	"C_Garrison.GetNumFollowerDailyActivations",
	"C_Garrison.GetNumFollowers",
	"C_Garrison.GetNumFollowersForMechanic",
	"C_Garrison.GetNumFollowersOnMission",
	"C_Garrison.GetNumPendingShipments",
	"C_Garrison.GetNumShipmentCurrencies",
	"C_Garrison.GetNumShipmentReagents",
	"C_Garrison.GetOwnedBuildingInfo",
	"C_Garrison.GetOwnedBuildingInfoAbbrev",
	"C_Garrison.GetPartyBuffs",
	"C_Garrison.GetPartyMentorLevels",
	"C_Garrison.GetPartyMissionInfo",
	"C_Garrison.GetPendingShipmentInfo",
	"C_Garrison.GetPlots",
	"C_Garrison.GetPlotsForBuilding",
	"C_Garrison.GetPossibleFollowersForBuilding",
	"C_Garrison.GetRecruitAbilities",
	"C_Garrison.GetRecruiterAbilityCategories",
	"C_Garrison.GetRecruiterAbilityList",
	"C_Garrison.GetRecruitmentPreferences",
	"C_Garrison.GetShipDeathAnimInfo",
	"C_Garrison.GetShipmentContainerInfo",
	"C_Garrison.GetShipmentItemInfo",
	"C_Garrison.GetShipmentReagentCurrencyInfo",
	"C_Garrison.GetShipmentReagentInfo",
	"C_Garrison.GetShipmentReagentItemLink",
	"C_Garrison.GetSpecChangeCost",
	"C_Garrison.GetTabForPlot",
	"C_Garrison.GetTalentInfo",
	"C_Garrison.GetTalentPointsSpentInTalentTree",
	"C_Garrison.GetTalentTreeIDsByClassID",
	"C_Garrison.GetTalentTreeInfo",
	"C_Garrison.GetTalentTreeResetInfo",
	"C_Garrison.GetTalentTreeTalentPointResearchInfo",
	"C_Garrison.GetTalentUnlockWorldQuest",
	"C_Garrison.HasAdventures",
	"C_Garrison.HasGarrison",
	"C_Garrison.HasShipyard",
	"C_Garrison.IsAboveFollowerSoftCap",
	"C_Garrison.IsAtGarrisonMissionNPC",
	"C_Garrison.IsEnvironmentCountered",
	"C_Garrison.IsFollowerCollected",
	"C_Garrison.IsInvasionAvailable",
	"C_Garrison.IsMechanicFullyCountered",
	"C_Garrison.IsOnGarrisonMap",
	"C_Garrison.IsOnShipmentQuestForNPC",
	"C_Garrison.IsOnShipyardMap",
	"C_Garrison.IsPlayerInGarrison",
	"C_Garrison.IsTalentConditionMet",
	"C_Garrison.IsUsingPartyGarrison",
	"C_Garrison.IsVisitGarrisonAvailable",
	"C_Garrison.MarkMissionComplete",
	"C_Garrison.MissionBonusRoll",
	"C_Garrison.PlaceBuilding",
	"C_Garrison.RecruitFollower",
	"C_Garrison.RegenerateCombatLog",
	"C_Garrison.RemoveFollower",
	"C_Garrison.RemoveFollowerFromBuilding",
	"C_Garrison.RemoveFollowerFromMission",
	"C_Garrison.RenameFollower",
	"C_Garrison.RequestClassSpecCategoryInfo",
	"C_Garrison.RequestGarrisonUpgradeable",
	"C_Garrison.RequestLandingPageShipmentInfo",
	"C_Garrison.RequestShipmentCreation",
	"C_Garrison.RequestShipmentInfo",
	"C_Garrison.ResearchTalent",
	"C_Garrison.RushHealAllFollowers",
	"C_Garrison.RushHealFollower",
	"C_Garrison.SearchForFollower",
	"C_Garrison.SetAutoCombatSpellFastForward",
	"C_Garrison.SetBuildingActive",
	"C_Garrison.SetBuildingSpecialization",
	"C_Garrison.SetFollowerFavorite",
	"C_Garrison.SetFollowerInactive",
	"C_Garrison.SetRecruitmentPreferences",
	"C_Garrison.SetUsingPartyGarrison",
	"C_Garrison.ShouldShowMapTab",
	"C_Garrison.ShowFollowerNameInErrorMessage",
	"C_Garrison.StartMission",
	"C_Garrison.SwapBuildings",
	"C_Garrison.TargetSpellHasFollowerItemLevelUpgrade",
	"C_Garrison.TargetSpellHasFollowerReroll",
	"C_Garrison.TargetSpellHasFollowerTemporaryAbility",
	"C_Garrison.UpgradeBuilding",
	"C_Garrison.UpgradeGarrison",
	"C_GossipInfo.CloseGossip",
	"C_GossipInfo.ForceGossip",
	"C_GossipInfo.GetActiveQuests",
	"C_GossipInfo.GetAvailableQuests",
	"C_GossipInfo.GetNumActiveQuests",
	"C_GossipInfo.GetNumAvailableQuests",
	"C_GossipInfo.GetNumOptions",
	"C_GossipInfo.GetOptions",
	"C_GossipInfo.GetPoiForUiMapID",
	"C_GossipInfo.GetPoiInfo",
	"C_GossipInfo.GetText",
	"C_GossipInfo.RefreshOptions",
	"C_GossipInfo.SelectActiveQuest",
	"C_GossipInfo.SelectAvailableQuest",
	"C_GossipInfo.SelectOption",
	"C_GuildInfo.CanEditOfficerNote",
	"C_GuildInfo.CanSpeakInGuildChat",
	"C_GuildInfo.CanViewOfficerNote",
	"C_GuildInfo.GetGuildNewsInfo",
	"C_GuildInfo.GetGuildRankOrder",
	"C_GuildInfo.GetGuildTabardInfo",
	"C_GuildInfo.GuildControlGetRankFlags",
	"C_GuildInfo.GuildRoster",
	"C_GuildInfo.IsGuildOfficer",
	"C_GuildInfo.IsGuildRankAssignmentAllowed",
	"C_GuildInfo.QueryGuildMemberRecipes",
	"C_GuildInfo.RemoveFromGuild",
	"C_GuildInfo.SetGuildRankOrder",
	"C_GuildInfo.SetNote",
	"C_Heirloom.CanHeirloomUpgradeFromPending",
	"C_Heirloom.CreateHeirloom",
	"C_Heirloom.GetClassAndSpecFilters",
	"C_Heirloom.GetCollectedHeirloomFilter",
	"C_Heirloom.GetHeirloomInfo",
	"C_Heirloom.GetHeirloomItemIDFromDisplayedIndex",
	"C_Heirloom.GetHeirloomItemIDs",
	"C_Heirloom.GetHeirloomLink",
	"C_Heirloom.GetHeirloomMaxUpgradeLevel",
	"C_Heirloom.GetHeirloomSourceFilter",
	"C_Heirloom.GetNumDisplayedHeirlooms",
	"C_Heirloom.GetNumHeirlooms",
	"C_Heirloom.GetNumKnownHeirlooms",
	"C_Heirloom.GetUncollectedHeirloomFilter",
	"C_Heirloom.IsHeirloomSourceValid",
	"C_Heirloom.IsItemHeirloom",
	"C_Heirloom.IsPendingHeirloomUpgrade",
	"C_Heirloom.PlayerHasHeirloom",
	"C_Heirloom.SetClassAndSpecFilters",
	"C_Heirloom.SetCollectedHeirloomFilter",
	"C_Heirloom.SetHeirloomSourceFilter",
	"C_Heirloom.SetSearch",
	"C_Heirloom.SetUncollectedHeirloomFilter",
	"C_Heirloom.ShouldShowHeirloomHelp",
	"C_Heirloom.UpgradeHeirloom",
	"C_IncomingSummon.HasIncomingSummon",
	"C_IncomingSummon.IncomingSummonStatus",
	"C_InvasionInfo.AreInvasionsAvailable",
	"C_InvasionInfo.GetInvasionForUiMapID",
	"C_InvasionInfo.GetInvasionInfo",
	"C_InvasionInfo.GetInvasionTimeLeft",
	"C_IslandsQueue.CloseIslandsQueueScreen",
	"C_IslandsQueue.GetIslandDifficultyInfo",
	"C_IslandsQueue.GetIslandsMaxGroupSize",
	"C_IslandsQueue.GetIslandsWeeklyQuestID",
	"C_IslandsQueue.QueueForIsland",
	"C_IslandsQueue.RequestPreloadRewardData",
	"C_Item.CanScrapItem",
	"C_Item.CanViewItemPowers",
	"C_Item.DoesItemExist",
	"C_Item.DoesItemExistByID",
	"C_Item.DoesItemMatchBonusTreeReplacement",
	"C_Item.GetCurrentItemLevel",
	"C_Item.GetItemGUID",
	"C_Item.GetItemID",
	"C_Item.GetItemIcon",
	"C_Item.GetItemIconByID",
	"C_Item.GetItemInventoryType",
	"C_Item.GetItemInventoryTypeByID",
	"C_Item.GetItemLink",
	"C_Item.GetItemName",
	"C_Item.GetItemNameByID",
	"C_Item.GetItemQuality",
	"C_Item.GetItemQualityByID",
	"C_Item.GetStackCount",
	"C_Item.IsAnimaItemByID",
	"C_Item.IsBound",
	"C_Item.IsItemConduit",
	"C_Item.IsItemCorrupted",
	"C_Item.IsItemCorruptionRelated",
	"C_Item.IsItemCorruptionResistant",
	"C_Item.IsItemDataCached",
	"C_Item.IsItemDataCachedByID",
	"C_Item.IsItemKeystoneByID",
	"C_Item.IsLocked",
	"C_Item.LockItem",
	"C_Item.LockItemByGUID",
	"C_Item.RequestLoadItemData",
	"C_Item.RequestLoadItemDataByID",
	"C_Item.UnlockItem",
	"C_Item.UnlockItemByGUID",
	"C_ItemInteraction.ClearPendingItem",
	"C_ItemInteraction.CloseUI",
	"C_ItemInteraction.GetItemInteractionInfo",
	"C_ItemInteraction.GetItemInteractionSpellId",
	"C_ItemInteraction.InitializeFrame",
	"C_ItemInteraction.PerformItemInteraction",
	"C_ItemInteraction.Reset",
	"C_ItemInteraction.SetCorruptionReforgerItemTooltip",
	"C_ItemInteraction.SetPendingItem",
	"C_ItemSocketInfo.CompleteSocketing",
	"C_ItemUpgrade.GetItemHyperlink",
	"C_KeyBindings.GetCustomBindingType",
	"C_LFGInfo.CanPlayerUseGroupFinder",
	"C_LFGInfo.CanPlayerUseLFD",
	"C_LFGInfo.CanPlayerUseLFR",
	"C_LFGInfo.CanPlayerUsePVP",
	"C_LFGInfo.CanPlayerUsePremadeGroup",
	"C_LFGInfo.ConfirmLfgExpandSearch",
	"C_LFGInfo.GetAllEntriesForCategory",
	"C_LFGInfo.GetLFDLockStates",
	"C_LFGInfo.GetRoleCheckDifficultyDetails",
	"C_LFGInfo.HideNameFromUI",
	"C_LFGList.AcceptInvite",
	"C_LFGList.ApplyToGroup",
	"C_LFGList.CanActiveEntryUseAutoAccept",
	"C_LFGList.CanCreateQuestGroup",
	"C_LFGList.CancelApplication",
	"C_LFGList.ClearApplicationTextFields",
	"C_LFGList.ClearCreationTextFields",
	"C_LFGList.ClearSearchResults",
	"C_LFGList.ClearSearchTextFields",
	"C_LFGList.CopyActiveEntryInfoToCreationFields",
	"C_LFGList.CreateListing",
	"C_LFGList.DeclineApplicant",
	"C_LFGList.DeclineInvite",
	"C_LFGList.GetActiveEntryInfo",
	"C_LFGList.GetActivityGroupInfo",
	"C_LFGList.GetActivityIDForQuestID",
	"C_LFGList.GetActivityInfo",
	"C_LFGList.GetActivityInfoExpensive",
	"C_LFGList.GetApplicantInfo",
	"C_LFGList.GetApplicantMemberInfo",
	"C_LFGList.GetApplicantMemberStats",
	"C_LFGList.GetApplicants",
	"C_LFGList.GetApplicationInfo",
	"C_LFGList.GetApplications",
	"C_LFGList.GetAvailableActivities",
	"C_LFGList.GetAvailableActivityGroups",
	"C_LFGList.GetAvailableCategories",
	"C_LFGList.GetAvailableLanguageSearchFilter",
	"C_LFGList.GetAvailableRoles",
	"C_LFGList.GetCategoryInfo",
	"C_LFGList.GetDefaultLanguageSearchFilter",
	"C_LFGList.GetLanguageSearchFilter",
	"C_LFGList.GetNumApplicants",
	"C_LFGList.GetNumApplications",
	"C_LFGList.GetNumInvitedApplicantMembers",
	"C_LFGList.GetNumPendingApplicantMembers",
	"C_LFGList.GetRoleCheckInfo",
	"C_LFGList.GetSearchResultEncounterInfo",
	"C_LFGList.GetSearchResultFriends",
	"C_LFGList.GetSearchResultInfo",
	"C_LFGList.GetSearchResultMemberCounts",
	"C_LFGList.GetSearchResultMemberInfo",
	"C_LFGList.GetSearchResults",
	"C_LFGList.HasActiveEntryInfo",
	"C_LFGList.HasActivityList",
	"C_LFGList.HasSearchResultInfo",
	"C_LFGList.InviteApplicant",
	"C_LFGList.IsCurrentlyApplying",
	"C_LFGList.RefreshApplicants",
	"C_LFGList.RemoveApplicant",
	"C_LFGList.RemoveListing",
	"C_LFGList.ReportApplicant",
	"C_LFGList.ReportSearchResult",
	"C_LFGList.RequestAvailableActivities",
	"C_LFGList.SaveLanguageSearchFilter",
	"C_LFGList.Search",
	"C_LFGList.SetApplicantMemberRole",
	"C_LFGList.SetSearchToActivity",
	"C_LFGList.SetSearchToQuestID",
	"C_LFGList.UpdateListing",
	"C_LFGuildInfo.GetRecruitingGuildTabardInfo",
	"C_LegendaryCrafting.CloseRuneforgeInteraction",
	"C_LegendaryCrafting.CraftRuneforgeLegendary",
	"C_LegendaryCrafting.GetRuneforgeItemPreviewInfo",
	"C_LegendaryCrafting.GetRuneforgeLegendaryComponentInfo",
	"C_LegendaryCrafting.GetRuneforgeLegendaryCost",
	"C_LegendaryCrafting.GetRuneforgeLegendaryCraftSpellID",
	"C_LegendaryCrafting.GetRuneforgeLegendaryCurrencies",
	"C_LegendaryCrafting.GetRuneforgeLegendaryUpgradeCost",
	"C_LegendaryCrafting.GetRuneforgeModifierInfo",
	"C_LegendaryCrafting.GetRuneforgeModifiers",
	"C_LegendaryCrafting.GetRuneforgePowerInfo",
	"C_LegendaryCrafting.GetRuneforgePowerSlots",
	"C_LegendaryCrafting.GetRuneforgePowers",
	"C_LegendaryCrafting.GetRuneforgePowersByClassAndSpec",
	"C_LegendaryCrafting.IsRuneforgeLegendary",
	"C_LegendaryCrafting.IsRuneforgeLegendaryMaxLevel",
	"C_LegendaryCrafting.IsUpgradeItemValidForRuneforgeLegendary",
	"C_LegendaryCrafting.IsValidRuneforgeBaseItem",
	"C_LegendaryCrafting.MakeRuneforgeCraftDescription",
	"C_LegendaryCrafting.UpgradeRuneforgeLegendary",
	"C_LevelLink.IsActionLocked",
	"C_LevelLink.IsSpellLocked",
	"C_LevelSquish.ConvertFollowerLevel",
	"C_LevelSquish.ConvertPlayerLevel",
	"C_Loot.IsLegacyLootModeEnabled",
	"C_LootHistory.CanMasterLoot",
	"C_LootHistory.GetExpiration",
	"C_LootHistory.GetItem",
	"C_LootHistory.GetNumItems",
	"C_LootHistory.GetPlayerInfo",
	"C_LootHistory.GiveMasterLoot",
	"C_LootHistory.SetExpiration",
	"C_LoreText.RequestLoreTextForCampaignID",
	"C_LossOfControl.GetActiveLossOfControlData",
	"C_LossOfControl.GetActiveLossOfControlDataByUnit",
	"C_LossOfControl.GetActiveLossOfControlDataCount",
	"C_LossOfControl.GetActiveLossOfControlDataCountByUnit",
	"C_Mail.CanCheckInbox",
	"C_Mail.HasInboxMoney",
	"C_Mail.IsCommandPending",
	"C_Map.CanSetUserWaypointOnMap",
	"C_Map.ClearUserWaypoint",
	"C_Map.CloseWorldMapInteraction",
	"C_Map.GetAreaInfo",
	"C_Map.GetBestMapForUnit",
	"C_Map.GetBountySetMaps",
	"C_Map.GetFallbackWorldMapID",
	"C_Map.GetMapArtBackgroundAtlas",
	"C_Map.GetMapArtHelpTextPosition",
	"C_Map.GetMapArtID",
	"C_Map.GetMapArtLayerTextures",
	"C_Map.GetMapArtLayers",
	"C_Map.GetMapBannersForMap",
	"C_Map.GetMapChildrenInfo",
	"C_Map.GetMapDisplayInfo",
	"C_Map.GetMapGroupID",
	"C_Map.GetMapGroupMembersInfo",
	"C_Map.GetMapHighlightInfoAtPosition",
	"C_Map.GetMapInfo",
	"C_Map.GetMapInfoAtPosition",
	"C_Map.GetMapLevels",
	"C_Map.GetMapLinksForMap",
	"C_Map.GetMapPosFromWorldPos",
	"C_Map.GetMapRectOnMap",
	"C_Map.GetMapWorldSize",
	"C_Map.GetPlayerMapPosition",
	"C_Map.GetUserWaypoint",
	"C_Map.GetUserWaypointFromHyperlink",
	"C_Map.GetUserWaypointHyperlink",
	"C_Map.GetUserWaypointPositionForMap",
	"C_Map.GetWorldPosFromMapPos",
	"C_Map.HasUserWaypoint",
	"C_Map.IsMapValidForNavBarDropDown",
	"C_Map.MapHasArt",
	"C_Map.RequestPreloadMap",
	"C_Map.SetUserWaypoint",
	"C_MapExplorationInfo.GetExploredAreaIDsAtPosition",
	"C_MapExplorationInfo.GetExploredMapTextures",
	"C_MerchantFrame.GetBuybackItemID",
	"C_MerchantFrame.IsMerchantItemRefundable",
	"C_Minimap.GetDrawGroundTextures",
	"C_Minimap.GetUiMapID",
	"C_Minimap.GetViewRadius",
	"C_Minimap.IsRotateMinimapIgnored",
	"C_Minimap.SetDrawGroundTextures",
	"C_Minimap.SetIgnoreRotateMinimap",
	"C_Minimap.ShouldUseHybridMinimap",
	"C_ModelInfo.AddActiveModelScene",
	"C_ModelInfo.AddActiveModelSceneActor",
	"C_ModelInfo.ClearActiveModelScene",
	"C_ModelInfo.ClearActiveModelSceneActor",
	"C_ModelInfo.GetModelSceneActorDisplayInfoByID",
	"C_ModelInfo.GetModelSceneActorInfoByID",
	"C_ModelInfo.GetModelSceneCameraInfoByID",
	"C_ModelInfo.GetModelSceneInfoByID",
	"C_MountJournal.ApplyMountEquipment",
	"C_MountJournal.AreMountEquipmentEffectsSuppressed",
	"C_MountJournal.ClearFanfare",
	"C_MountJournal.ClearRecentFanfares",
	"C_MountJournal.Dismiss",
	"C_MountJournal.GetAppliedMountEquipmentID",
	"C_MountJournal.GetCollectedFilterSetting",
	"C_MountJournal.GetDisplayedMountAllCreatureDisplayInfo",
	"C_MountJournal.GetDisplayedMountInfo",
	"C_MountJournal.GetDisplayedMountInfoExtra",
	"C_MountJournal.GetIsFavorite",
	"C_MountJournal.GetMountAllCreatureDisplayInfoByID",
	"C_MountJournal.GetMountEquipmentUnlockLevel",
	"C_MountJournal.GetMountFromItem",
	"C_MountJournal.GetMountFromSpell",
	"C_MountJournal.GetMountIDs",
	"C_MountJournal.GetMountInfoByID",
	"C_MountJournal.GetMountInfoExtraByID",
	"C_MountJournal.GetMountUsabilityByID",
	"C_MountJournal.GetNumDisplayedMounts",
	"C_MountJournal.GetNumMounts",
	"C_MountJournal.GetNumMountsNeedingFanfare",
	"C_MountJournal.IsItemMountEquipment",
	"C_MountJournal.IsMountEquipmentApplied",
	"C_MountJournal.IsSourceChecked",
	"C_MountJournal.IsValidSourceFilter",
	"C_MountJournal.NeedsFanfare",
	"C_MountJournal.Pickup",
	"C_MountJournal.SetAllSourceFilters",
	"C_MountJournal.SetCollectedFilterSetting",
	"C_MountJournal.SetIsFavorite",
	"C_MountJournal.SetSearch",
	"C_MountJournal.SetSourceFilter",
	"C_MountJournal.SummonByID",
	"C_MythicPlus.GetCurrentAffixes",
	"C_MythicPlus.GetCurrentSeason",
	"C_MythicPlus.GetLastWeeklyBestInformation",
	"C_MythicPlus.GetOwnedKeystoneChallengeMapID",
	"C_MythicPlus.GetOwnedKeystoneLevel",
	"C_MythicPlus.GetRewardLevelForDifficultyLevel",
	"C_MythicPlus.GetRewardLevelFromKeystoneLevel",
	"C_MythicPlus.GetRunHistory",
	"C_MythicPlus.GetSeasonBestForMap",
	"C_MythicPlus.GetWeeklyBestForMap",
	"C_MythicPlus.GetWeeklyChestRewardLevel",
	"C_MythicPlus.IsMythicPlusActive",
	"C_MythicPlus.IsWeeklyRewardAvailable",
	"C_MythicPlus.RequestCurrentAffixes",
	"C_MythicPlus.RequestMapInfo",
	"C_MythicPlus.RequestRewards",
	"C_NamePlate.GetNamePlateEnemyClickThrough",
	"C_NamePlate.GetNamePlateEnemyPreferredClickInsets",
	"C_NamePlate.GetNamePlateEnemySize",
	"C_NamePlate.GetNamePlateForUnit",
	"C_NamePlate.GetNamePlateFriendlyClickThrough",
	"C_NamePlate.GetNamePlateFriendlyPreferredClickInsets",
	"C_NamePlate.GetNamePlateFriendlySize",
	"C_NamePlate.GetNamePlateSelfClickThrough",
	"C_NamePlate.GetNamePlateSelfPreferredClickInsets",
	"C_NamePlate.GetNamePlateSelfSize",
	"C_NamePlate.GetNamePlates",
	"C_NamePlate.GetNumNamePlateMotionTypes",
	"C_NamePlate.GetTargetClampingInsets",
	"C_NamePlate.SetNamePlateEnemyClickThrough",
	"C_NamePlate.SetNamePlateEnemyPreferredClickInsets",
	"C_NamePlate.SetNamePlateEnemySize",
	"C_NamePlate.SetNamePlateFriendlyClickThrough",
	"C_NamePlate.SetNamePlateFriendlyPreferredClickInsets",
	"C_NamePlate.SetNamePlateFriendlySize",
	"C_NamePlate.SetNamePlateSelfClickThrough",
	"C_NamePlate.SetNamePlateSelfPreferredClickInsets",
	"C_NamePlate.SetNamePlateSelfSize",
	"C_NamePlate.SetTargetClampingInsets",
	"C_Navigation.GetDistance",
	"C_Navigation.GetFrame",
	"C_Navigation.GetTargetState",
	"C_Navigation.HasValidScreenPosition",
	"C_Navigation.WasClampedToScreen",
	"C_NewItems.ClearAll",
	"C_NewItems.IsNewItem",
	"C_NewItems.RemoveNewItem",
	"C_PaperDollInfo.GetArmorEffectiveness",
	"C_PaperDollInfo.GetArmorEffectivenessAgainstTarget",
	"C_PaperDollInfo.GetInspectAzeriteItemEmpoweredChoices",
	"C_PaperDollInfo.GetInspectItemLevel",
	"C_PaperDollInfo.GetMinItemLevel",
	"C_PaperDollInfo.GetStaggerPercentage",
	"C_PaperDollInfo.OffhandHasShield",
	"C_PaperDollInfo.OffhandHasWeapon",
	"C_PartyInfo.AllowedToDoPartyConversion",
	"C_PartyInfo.CanInvite",
	"C_PartyInfo.ConfirmConvertToRaid",
	"C_PartyInfo.ConfirmInviteTravelPass",
	"C_PartyInfo.ConfirmInviteUnit",
	"C_PartyInfo.ConfirmLeaveParty",
	"C_PartyInfo.ConfirmRequestInviteFromUnit",
	"C_PartyInfo.ConvertToParty",
	"C_PartyInfo.ConvertToRaid",
	"C_PartyInfo.DoCountdown",
	"C_PartyInfo.GetActiveCategories",
	"C_PartyInfo.GetInviteConfirmationInvalidQueues",
	"C_PartyInfo.GetInviteReferralInfo",
	"C_PartyInfo.GetMinLevel",
	"C_PartyInfo.InviteUnit",
	"C_PartyInfo.IsPartyFull",
	"C_PartyInfo.IsPartyInJailersTower",
	"C_PartyInfo.LeaveParty",
	"C_PartyInfo.RequestInviteFromUnit",
	"C_PartyPose.GetPartyPoseInfoByMapID",
	"C_PetBattles.AcceptPVPDuel",
	"C_PetBattles.AcceptQueuedPVPMatch",
	"C_PetBattles.CanAcceptQueuedPVPMatch",
	"C_PetBattles.CanActivePetSwapOut",
	"C_PetBattles.CanPetSwapIn",
	"C_PetBattles.CancelPVPDuel",
	"C_PetBattles.ChangePet",
	"C_PetBattles.DeclineQueuedPVPMatch",
	"C_PetBattles.ForfeitGame",
	"C_PetBattles.GetAbilityEffectInfo",
	"C_PetBattles.GetAbilityInfo",
	"C_PetBattles.GetAbilityInfoByID",
	"C_PetBattles.GetAbilityProcTurnIndex",
	"C_PetBattles.GetAbilityState",
	"C_PetBattles.GetAbilityStateModification",
	"C_PetBattles.GetActivePet",
	"C_PetBattles.GetAllEffectNames",
	"C_PetBattles.GetAllStates",
	"C_PetBattles.GetAttackModifier",
	"C_PetBattles.GetAuraInfo",
	"C_PetBattles.GetBattleState",
	"C_PetBattles.GetBreedQuality",
	"C_PetBattles.GetDisplayID",
	"C_PetBattles.GetForfeitPenalty",
	"C_PetBattles.GetHealth",
	"C_PetBattles.GetIcon",
	"C_PetBattles.GetLevel",
	"C_PetBattles.GetMaxHealth",
	"C_PetBattles.GetName",
	"C_PetBattles.GetNumAuras",
	"C_PetBattles.GetNumPets",
	"C_PetBattles.GetPVPMatchmakingInfo",
	"C_PetBattles.GetPetSpeciesID",
	"C_PetBattles.GetPetType",
	"C_PetBattles.GetPlayerTrapAbility",
	"C_PetBattles.GetPower",
	"C_PetBattles.GetSelectedAction",
	"C_PetBattles.GetSpeed",
	"C_PetBattles.GetStateValue",
	"C_PetBattles.GetTurnTimeInfo",
	"C_PetBattles.GetXP",
	"C_PetBattles.IsInBattle",
	"C_PetBattles.IsPlayerNPC",
	"C_PetBattles.IsSkipAvailable",
	"C_PetBattles.IsTrapAvailable",
	"C_PetBattles.IsWaitingOnOpponent",
	"C_PetBattles.IsWildBattle",
	"C_PetBattles.SetPendingReportBattlePetTarget",
	"C_PetBattles.SetPendingReportTargetFromUnit",
	"C_PetBattles.ShouldShowPetSelect",
	"C_PetBattles.SkipTurn",
	"C_PetBattles.StartPVPDuel",
	"C_PetBattles.StartPVPMatchmaking",
	"C_PetBattles.StopPVPMatchmaking",
	"C_PetBattles.UseAbility",
	"C_PetBattles.UseTrap",
	"C_PetInfo.GetPetTamersForMap",
	"C_PetJournal.CagePetByID",
	"C_PetJournal.ClearFanfare",
	"C_PetJournal.ClearRecentFanfares",
	"C_PetJournal.ClearSearchFilter",
	"C_PetJournal.FindPetIDByName",
	"C_PetJournal.GetBattlePetLink",
	"C_PetJournal.GetDisplayIDByIndex",
	"C_PetJournal.GetDisplayProbabilityByIndex",
	"C_PetJournal.GetNumCollectedInfo",
	"C_PetJournal.GetNumDisplays",
	"C_PetJournal.GetNumMaxPets",
	"C_PetJournal.GetNumPetSources",
	"C_PetJournal.GetNumPetTypes",
	"C_PetJournal.GetNumPets",
	"C_PetJournal.GetNumPetsNeedingFanfare",
	"C_PetJournal.GetOwnedBattlePetString",
	"C_PetJournal.GetPetAbilityInfo",
	"C_PetJournal.GetPetAbilityList",
	"C_PetJournal.GetPetCooldownByGUID",
	"C_PetJournal.GetPetInfoByIndex",
	"C_PetJournal.GetPetInfoByItemID",
	"C_PetJournal.GetPetInfoByPetID",
	"C_PetJournal.GetPetInfoBySpeciesID",
	"C_PetJournal.GetPetLoadOutInfo",
	"C_PetJournal.GetPetModelSceneInfoBySpeciesID",
	"C_PetJournal.GetPetSortParameter",
	"C_PetJournal.GetPetStats",
	"C_PetJournal.GetPetSummonInfo",
	"C_PetJournal.GetPetTeamAverageLevel",
	"C_PetJournal.GetSummonBattlePetCooldown",
	"C_PetJournal.GetSummonRandomFavoritePetGUID",
	"C_PetJournal.GetSummonedPetGUID",
	"C_PetJournal.IsFilterChecked",
	"C_PetJournal.IsFindBattleEnabled",
	"C_PetJournal.IsJournalReadOnly",
	"C_PetJournal.IsJournalUnlocked",
	"C_PetJournal.IsPetSourceChecked",
	"C_PetJournal.IsPetTypeChecked",
	"C_PetJournal.PetCanBeReleased",
	"C_PetJournal.PetIsCapturable",
	"C_PetJournal.PetIsFavorite",
	"C_PetJournal.PetIsHurt",
	"C_PetJournal.PetIsLockedForConvert",
	"C_PetJournal.PetIsRevoked",
	"C_PetJournal.PetIsSlotted",
	"C_PetJournal.PetIsSummonable",
	"C_PetJournal.PetIsTradable",
	"C_PetJournal.PetIsUsable",
	"C_PetJournal.PetNeedsFanfare",
	"C_PetJournal.PetUsesRandomDisplay",
	"C_PetJournal.PickupPet",
	"C_PetJournal.PickupSummonRandomPet",
	"C_PetJournal.ReleasePetByID",
	"C_PetJournal.SetAbility",
	"C_PetJournal.SetAllPetSourcesChecked",
	"C_PetJournal.SetAllPetTypesChecked",
	"C_PetJournal.SetCustomName",
	"C_PetJournal.SetFavorite",
	"C_PetJournal.SetFilterChecked",
	"C_PetJournal.SetPetLoadOutInfo",
	"C_PetJournal.SetPetSortParameter",
	"C_PetJournal.SetPetSourceChecked",
	"C_PetJournal.SetPetTypeFilter",
	"C_PetJournal.SetSearchFilter",
	"C_PetJournal.SummonPetByGUID",
	"C_PetJournal.SummonRandomPet",
	"C_PlayerChoice.GetPlayerChoiceInfo",
	"C_PlayerChoice.GetPlayerChoiceOptionInfo",
	"C_PlayerChoice.GetPlayerChoiceRewardInfo",
	"C_PlayerChoice.IsWaitingForPlayerChoiceResponse",
	"C_PlayerInfo.CanPlayerEnterChromieTime",
	"C_PlayerInfo.CanPlayerUseAreaLoot",
	"C_PlayerInfo.CanPlayerUseMountEquipment",
	"C_PlayerInfo.GUIDIsPlayer",
	"C_PlayerInfo.GetClass",
	"C_PlayerInfo.GetContentDifficultyCreatureForPlayer",
	"C_PlayerInfo.GetContentDifficultyQuestForPlayer",
	"C_PlayerInfo.GetName",
	"C_PlayerInfo.GetRace",
	"C_PlayerInfo.GetSex",
	"C_PlayerInfo.IsConnected",
	"C_PlayerInfo.IsPlayerEligibleForNPE",
	"C_PlayerInfo.IsPlayerEligibleForNPEv2",
	"C_PlayerInfo.IsPlayerInChromieTime",
	"C_PlayerInfo.IsPlayerNPERestricted",
	"C_PlayerInfo.UnitIsSameServer",
	"C_PlayerMentorship.GetMentorLevelRequirement",
	"C_PlayerMentorship.GetMentorOptionalAchievementIDs",
	"C_PlayerMentorship.GetMentorshipStatus",
	"C_PlayerMentorship.IsActivePlayerConsideredNewcomer",
	"C_PlayerMentorship.IsMentorRestricted",
	"C_PrototypeDialog.EnsureRemoved",
	"C_PrototypeDialog.SelectOption",
	"C_PvP.CanDisplayDeaths",
	"C_PvP.CanDisplayHonorableKills",
	"C_PvP.CanPlayerUseRatedPVPUI",
	"C_PvP.CanToggleWarMode",
	"C_PvP.CanToggleWarModeInArea",
	"C_PvP.DoesMatchOutcomeAffectRating",
	"C_PvP.GetActiveBrawlInfo",
	"C_PvP.GetActiveMatchBracket",
	"C_PvP.GetActiveMatchDuration",
	"C_PvP.GetActiveMatchState",
	"C_PvP.GetActiveMatchWinner",
	"C_PvP.GetArenaCrowdControlInfo",
	"C_PvP.GetArenaRewards",
	"C_PvP.GetArenaSkirmishRewards",
	"C_PvP.GetAvailableBrawlInfo",
	"C_PvP.GetBattlefieldVehicleInfo",
	"C_PvP.GetBattlefieldVehicles",
	"C_PvP.GetBrawlRewards",
	"C_PvP.GetGlobalPvpScalingInfoForSpecID",
	"C_PvP.GetHonorRewardInfo",
	"C_PvP.GetLevelUpBattlegrounds",
	"C_PvP.GetMatchPVPStatColumn",
	"C_PvP.GetMatchPVPStatColumns",
	"C_PvP.GetNextHonorLevelForReward",
	"C_PvP.GetOutdoorPvPWaitTime",
	"C_PvP.GetPVPActiveMatchPersonalRatedInfo",
	"C_PvP.GetPostMatchCurrencyRewards",
	"C_PvP.GetPostMatchItemRewards",
	"C_PvP.GetPvpTierID",
	"C_PvP.GetPvpTierInfo",
	"C_PvP.GetRandomBGInfo",
	"C_PvP.GetRandomBGRewards",
	"C_PvP.GetRandomEpicBGInfo",
	"C_PvP.GetRandomEpicBGRewards",
	"C_PvP.GetRatedBGRewards",
	"C_PvP.GetRewardItemLevelsByTierEnum",
	"C_PvP.GetScoreInfo",
	"C_PvP.GetScoreInfoByPlayerGuid",
	"C_PvP.GetSeasonBestInfo",
	"C_PvP.GetSkirmishInfo",
	"C_PvP.GetSpecialEventDetails",
	"C_PvP.GetSpecialEventInfo",
	"C_PvP.GetTeamInfo",
	"C_PvP.GetWarModeRewardBonus",
	"C_PvP.GetWarModeRewardBonusDefault",
	"C_PvP.GetWeeklyChestInfo",
	"C_PvP.HasArenaSkirmishWinToday",
	"C_PvP.IsActiveBattlefield",
	"C_PvP.IsActiveMatchRegistered",
	"C_PvP.IsArena",
	"C_PvP.IsBattleground",
	"C_PvP.IsBattlegroundEnlistmentBonusActive",
	"C_PvP.IsInBrawl",
	"C_PvP.IsMatchConsideredArena",
	"C_PvP.IsMatchFactional",
	"C_PvP.IsPVPMap",
	"C_PvP.IsRatedArena",
	"C_PvP.IsRatedBattleground",
	"C_PvP.IsRatedMap",
	"C_PvP.IsWarModeActive",
	"C_PvP.IsWarModeDesired",
	"C_PvP.IsWarModeFeatureEnabled",
	"C_PvP.JoinBrawl",
	"C_PvP.RequestCrowdControlSpell",
	"C_PvP.SetWarModeDesired",
	"C_PvP.ToggleWarMode",
	"C_QuestLine.GetAvailableQuestLines",
	"C_QuestLine.GetQuestLineInfo",
	"C_QuestLine.GetQuestLineQuests",
	"C_QuestLine.IsComplete",
	"C_QuestLine.RequestQuestLinesForMap",
	"C_QuestLog.AbandonQuest",
	"C_QuestLog.AddQuestWatch",
	"C_QuestLog.AddWorldQuestWatch",
	"C_QuestLog.CanAbandonQuest",
	"C_QuestLog.GetAbandonQuest",
	"C_QuestLog.GetAbandonQuestItems",
	"C_QuestLog.GetActiveThreatMaps",
	"C_QuestLog.GetAllCompletedQuestIDs",
	"C_QuestLog.GetBountiesForMapID",
	"C_QuestLog.GetBountySetInfoForMapID",
	"C_QuestLog.GetDistanceSqToQuest",
	"C_QuestLog.GetInfo",
	"C_QuestLog.GetLogIndexForQuestID",
	"C_QuestLog.GetMapForQuestPOIs",
	"C_QuestLog.GetMaxNumQuests",
	"C_QuestLog.GetMaxNumQuestsCanAccept",
	"C_QuestLog.GetNextWaypoint",
	"C_QuestLog.GetNextWaypointForMap",
	"C_QuestLog.GetNextWaypointText",
	"C_QuestLog.GetNumQuestLogEntries",
	"C_QuestLog.GetNumQuestObjectives",
	"C_QuestLog.GetNumQuestWatches",
	"C_QuestLog.GetNumWorldQuestWatches",
	"C_QuestLog.GetQuestAdditionalHighlights",
	"C_QuestLog.GetQuestDetailsTheme",
	"C_QuestLog.GetQuestDifficultyLevel",
	"C_QuestLog.GetQuestIDForLogIndex",
	"C_QuestLog.GetQuestIDForQuestWatchIndex",
	"C_QuestLog.GetQuestIDForWorldQuestWatchIndex",
	"C_QuestLog.GetQuestObjectives",
	"C_QuestLog.GetQuestTagInfo",
	"C_QuestLog.GetQuestWatchType",
	"C_QuestLog.GetQuestsOnMap",
	"C_QuestLog.GetRequiredMoney",
	"C_QuestLog.GetSelectedQuest",
	"C_QuestLog.GetSuggestedGroupSize",
	"C_QuestLog.GetTimeAllowed",
	"C_QuestLog.GetTitleForLogIndex",
	"C_QuestLog.GetTitleForQuestID",
	"C_QuestLog.GetZoneStoryInfo",
	"C_QuestLog.HasActiveThreats",
	"C_QuestLog.IsAccountQuest",
	"C_QuestLog.IsComplete",
	"C_QuestLog.IsFailed",
	"C_QuestLog.IsLegendaryQuest",
	"C_QuestLog.IsOnMap",
	"C_QuestLog.IsOnQuest",
	"C_QuestLog.IsPushableQuest",
	"C_QuestLog.IsQuestBounty",
	"C_QuestLog.IsQuestCalling",
	"C_QuestLog.IsQuestCriteriaForBounty",
	"C_QuestLog.IsQuestDisabledForSession",
	"C_QuestLog.IsQuestFlaggedCompleted",
	"C_QuestLog.IsQuestInvasion",
	"C_QuestLog.IsQuestReplayable",
	"C_QuestLog.IsQuestReplayedRecently",
	"C_QuestLog.IsQuestTask",
	"C_QuestLog.IsQuestTrivial",
	"C_QuestLog.IsRepeatableQuest",
	"C_QuestLog.IsThreatQuest",
	"C_QuestLog.IsUnitOnQuest",
	"C_QuestLog.IsWorldQuest",
	"C_QuestLog.QuestCanHaveWarModeBonus",
	"C_QuestLog.QuestHasQuestSessionBonus",
	"C_QuestLog.QuestHasWarModeBonus",
	"C_QuestLog.ReadyForTurnIn",
	"C_QuestLog.RemoveQuestWatch",
	"C_QuestLog.RemoveWorldQuestWatch",
	"C_QuestLog.RequestLoadQuestByID",
	"C_QuestLog.SetAbandonQuest",
	"C_QuestLog.SetMapForQuestPOIs",
	"C_QuestLog.SetSelectedQuest",
	"C_QuestLog.ShouldShowQuestRewards",
	"C_QuestLog.SortQuestWatches",
	"C_QuestSession.CanStart",
	"C_QuestSession.CanStop",
	"C_QuestSession.Exists",
	"C_QuestSession.GetAvailableSessionCommand",
	"C_QuestSession.GetPendingCommand",
	"C_QuestSession.GetProposedMaxLevelForSession",
	"C_QuestSession.GetSessionBeginDetails",
	"C_QuestSession.GetSuperTrackedQuest",
	"C_QuestSession.HasJoined",
	"C_QuestSession.HasPendingCommand",
	"C_QuestSession.RequestSessionStart",
	"C_QuestSession.RequestSessionStop",
	"C_QuestSession.SendSessionBeginResponse",
	"C_QuestSession.SetQuestIsSuperTracked",
	"C_RaidLocks.IsEncounterComplete",
	"C_RecruitAFriend.ClaimActivityReward",
	"C_RecruitAFriend.ClaimNextReward",
	"C_RecruitAFriend.GenerateRecruitmentLink",
	"C_RecruitAFriend.GetRAFInfo",
	"C_RecruitAFriend.GetRAFSystemInfo",
	"C_RecruitAFriend.GetRecruitActivityRequirementsText",
	"C_RecruitAFriend.GetRecruitInfo",
	"C_RecruitAFriend.IsEnabled",
	"C_RecruitAFriend.IsRecruitingEnabled",
	"C_RecruitAFriend.RemoveRAFRecruit",
	"C_RecruitAFriend.RequestUpdatedRecruitmentInfo",
	"C_ReportSystem.CanReportPlayer",
	"C_ReportSystem.CanReportPlayerForLanguage",
	"C_ReportSystem.InitiateReportPlayer",
	"C_ReportSystem.OpenReportPlayerDialog",
	"C_ReportSystem.ReportServerLag",
	"C_ReportSystem.ReportStuckInCombat",
	"C_ReportSystem.SendReportPlayer",
	"C_ReportSystem.SetPendingReportPetTarget",
	"C_ReportSystem.SetPendingReportTarget",
	"C_ReportSystem.SetPendingReportTargetByGuid",
	"C_Reputation.GetFactionParagonInfo",
	"C_Reputation.IsFactionParagon",
	"C_Reputation.RequestFactionParagonPreloadRewardData",
	"C_ResearchInfo.GetDigSitesForMap",
	"C_Scenario.GetBonusStepRewardQuestID",
	"C_Scenario.GetBonusSteps",
	"C_Scenario.GetCriteriaInfo",
	"C_Scenario.GetCriteriaInfoByStep",
	"C_Scenario.GetInfo",
	"C_Scenario.GetProvingGroundsInfo",
	"C_Scenario.GetScenarioIconInfo",
	"C_Scenario.GetStepInfo",
	"C_Scenario.GetSupersededObjectives",
	"C_Scenario.IsInScenario",
	"C_Scenario.ShouldShowCriteria",
	"C_Scenario.TreatScenarioAsDungeon",
	"C_ScenarioInfo.GetJailersTowerTypeString",
	"C_ScrappingMachineUI.CloseScrappingMachine",
	"C_ScrappingMachineUI.DropPendingScrapItemFromCursor",
	"C_ScrappingMachineUI.GetCurrentPendingScrapItemLocationByIndex",
	"C_ScrappingMachineUI.GetScrapSpellID",
	"C_ScrappingMachineUI.GetScrappingMachineName",
	"C_ScrappingMachineUI.HasScrappableItems",
	"C_ScrappingMachineUI.RemoveAllScrapItems",
	"C_ScrappingMachineUI.RemoveCurrentScrappingItem",
	"C_ScrappingMachineUI.RemoveItemToScrap",
	"C_ScrappingMachineUI.ScrapItems",
	"C_ScrappingMachineUI.SetScrappingMachine",
	"C_ScrappingMachineUI.ValidateScrappingList",
	"C_ScriptedAnimations.GetAllScriptedAnimationEffects",
	"C_SharedCharacterServices.GetLastSeenCharacterUpgradePopup",
	"C_SharedCharacterServices.GetLastSeenExpansionTrialPopup",
	"C_SharedCharacterServices.GetUpgradeDistributions",
	"C_SharedCharacterServices.HasFreePromotionalUpgrade",
	"C_SharedCharacterServices.HasSeenFreePromotionalUpgradePopup",
	"C_SharedCharacterServices.IsPurchaseIDPendingUpgrade",
	"C_SharedCharacterServices.QueryClassTrialBoostResult",
	"C_SharedCharacterServices.SetCharacterUpgradePopupSeen",
	"C_SharedCharacterServices.SetExpansionTrialPopupSeen",
	"C_SharedCharacterServices.SetPromotionalPopupSeen",
	"C_Social.GetLastAchievement",
	"C_Social.GetLastItem",
	"C_Social.GetLastScreenshotIndex",
	"C_Social.GetMaxTweetLength",
	"C_Social.GetScreenshotInfoByIndex",
	"C_Social.GetTweetLength",
	"C_Social.IsSocialEnabled",
	"C_Social.RegisterSocialBrowser",
	"C_Social.SetTextureToScreenshot",
	"C_Social.TwitterCheckStatus",
	"C_Social.TwitterConnect",
	"C_Social.TwitterDisconnect",
	"C_Social.TwitterGetMSTillCanPost",
	"C_Social.TwitterPostAchievement",
	"C_Social.TwitterPostItem",
	"C_Social.TwitterPostMessage",
	"C_Social.TwitterPostScreenshot",
	"C_SocialQueue.GetAllGroups",
	"C_SocialQueue.GetConfig",
	"C_SocialQueue.GetGroupForPlayer",
	"C_SocialQueue.GetGroupInfo",
	"C_SocialQueue.GetGroupMembers",
	"C_SocialQueue.GetGroupQueues",
	"C_SocialQueue.RequestToJoin",
	"C_SocialQueue.SignalToastDisplayed",
	"C_SocialRestrictions.IsMuted",
	"C_SocialRestrictions.IsSilenced",
	"C_SocialRestrictions.IsSquelched",
	"C_Soulbinds.ActivateSoulbind",
	"C_Soulbinds.CanActivateSoulbind",
	"C_Soulbinds.CanModifySoulbind",
	"C_Soulbinds.CanResetConduitsInSoulbind",
	"C_Soulbinds.CanSwitchActiveSoulbindTreeBranch",
	"C_Soulbinds.CloseUI",
	"C_Soulbinds.CommitPendingConduitsInSoulbind",
	"C_Soulbinds.FindNodeIDActuallyInstalled",
	"C_Soulbinds.FindNodeIDAppearingInstalled",
	"C_Soulbinds.FindNodeIDPendingInstall",
	"C_Soulbinds.FindNodeIDPendingUninstall",
	"C_Soulbinds.GetActiveSoulbindID",
	"C_Soulbinds.GetConduitCharges",
	"C_Soulbinds.GetConduitChargesCapacity",
	"C_Soulbinds.GetConduitCollection",
	"C_Soulbinds.GetConduitCollectionCount",
	"C_Soulbinds.GetConduitCollectionData",
	"C_Soulbinds.GetConduitCollectionDataAtCursor",
	"C_Soulbinds.GetConduitCollectionDataByVirtualID",
	"C_Soulbinds.GetConduitDisplayed",
	"C_Soulbinds.GetConduitHyperlink",
	"C_Soulbinds.GetConduitIDPendingInstall",
	"C_Soulbinds.GetConduitItemLevel",
	"C_Soulbinds.GetConduitQuality",
	"C_Soulbinds.GetConduitRankFromCollection",
	"C_Soulbinds.GetConduitSpellID",
	"C_Soulbinds.GetInstalledConduitID",
	"C_Soulbinds.GetNode",
	"C_Soulbinds.GetSoulbindData",
	"C_Soulbinds.GetTotalConduitChargesPending",
	"C_Soulbinds.GetTotalConduitChargesPendingInSoulbind",
	"C_Soulbinds.GetTree",
	"C_Soulbinds.HasAnyInstalledConduitInSoulbind",
	"C_Soulbinds.HasAnyPendingConduits",
	"C_Soulbinds.HasPendingConduitsInSoulbind",
	"C_Soulbinds.IsConduitInstalled",
	"C_Soulbinds.IsConduitInstalledInSoulbind",
	"C_Soulbinds.IsItemConduitByItemInfo",
	"C_Soulbinds.IsNodePendingModify",
	"C_Soulbinds.IsUnselectedConduitPendingInSoulbind",
	"C_Soulbinds.ModifyNode",
	"C_Soulbinds.SelectNode",
	"C_Soulbinds.UnmodifyNode",
	"C_SpecializationInfo.CanPlayerUsePVPTalentUI",
	"C_SpecializationInfo.CanPlayerUseTalentSpecUI",
	"C_SpecializationInfo.CanPlayerUseTalentUI",
	"C_SpecializationInfo.GetAllSelectedPvpTalentIDs",
	"C_SpecializationInfo.GetInspectSelectedPvpTalent",
	"C_SpecializationInfo.GetPvpTalentAlertStatus",
	"C_SpecializationInfo.GetPvpTalentSlotInfo",
	"C_SpecializationInfo.GetPvpTalentSlotUnlockLevel",
	"C_SpecializationInfo.GetPvpTalentUnlockLevel",
	"C_SpecializationInfo.GetSpecIDs",
	"C_SpecializationInfo.GetSpellsDisplay",
	"C_SpecializationInfo.IsInitialized",
	"C_SpecializationInfo.IsPvpTalentLocked",
	"C_SpecializationInfo.MatchesCurrentSpecSet",
	"C_SpecializationInfo.SetPvpTalentLocked",
	"C_Spell.DoesSpellExist",
	"C_Spell.GetMawPowerBorderAtlasBySpellID",
	"C_Spell.IsSpellDataCached",
	"C_Spell.RequestLoadSpellData",
	"C_SpellBook.ContainsAnyDisenchantSpell",
	"C_SpellBook.GetSkillLineIndexByID",
	"C_SpellBook.IsSpellDisabled",
	"C_SplashScreen.AcknowledgeSplash",
	"C_SplashScreen.CanViewSplashScreen",
	"C_SplashScreen.RequestLatestSplashScreen",
	"C_StableInfo.GetNumActivePets",
	"C_StableInfo.GetNumStablePets",
	"C_StorePublic.DoesGroupHavePurchaseableProducts",
	"C_StorePublic.IsDisabledByParentalControls",
	"C_StorePublic.IsEnabled",
	"C_SummonInfo.CancelSummon",
	"C_SummonInfo.ConfirmSummon",
	"C_SummonInfo.GetSummonConfirmAreaName",
	"C_SummonInfo.GetSummonConfirmSummoner",
	"C_SummonInfo.GetSummonConfirmTimeLeft",
	"C_SummonInfo.GetSummonReason",
	"C_SummonInfo.IsSummonSkippingStartExperience",
	"C_SuperTrack.GetHighestPrioritySuperTrackingType",
	"C_SuperTrack.GetSuperTrackedQuestID",
	"C_SuperTrack.IsSuperTrackingAnything",
	"C_SuperTrack.IsSuperTrackingCorpse",
	"C_SuperTrack.IsSuperTrackingQuest",
	"C_SuperTrack.IsSuperTrackingUserWaypoint",
	"C_SuperTrack.SetSuperTrackedQuestID",
	"C_SuperTrack.SetSuperTrackedUserWaypoint",
	"C_System.GetFrameStack",
	"C_TalkingHead.GetConversationsDeferred",
	"C_TalkingHead.GetCurrentLineAnimationInfo",
	"C_TalkingHead.GetCurrentLineInfo",
	"C_TalkingHead.IgnoreCurrentTalkingHead",
	"C_TalkingHead.IsCurrentTalkingHeadIgnored",
	"C_TalkingHead.SetConversationsDeferred",
	"C_TaskQuest.DoesMapShowTaskQuestObjectives",
	"C_TaskQuest.GetQuestInfoByQuestID",
	"C_TaskQuest.GetQuestLocation",
	"C_TaskQuest.GetQuestProgressBarInfo",
	"C_TaskQuest.GetQuestTimeLeftMinutes",
	"C_TaskQuest.GetQuestTimeLeftSeconds",
	"C_TaskQuest.GetQuestZoneID",
	"C_TaskQuest.GetQuestsForPlayerByMapID",
	"C_TaskQuest.GetThreatQuests",
	"C_TaskQuest.GetUIWidgetSetIDFromQuestID",
	"C_TaskQuest.IsActive",
	"C_TaskQuest.RequestPreloadRewardData",
	"C_TaxiMap.GetAllTaxiNodes",
	"C_TaxiMap.GetTaxiNodesForMap",
	"C_TaxiMap.ShouldMapShowTaxiNodes",
	"C_Texture.GetAtlasInfo",
	"C_Timer.After",
	"C_ToyBox.ForceToyRefilter",
	"C_ToyBox.GetCollectedShown",
	"C_ToyBox.GetIsFavorite",
	"C_ToyBox.GetNumFilteredToys",
	"C_ToyBox.GetNumLearnedDisplayedToys",
	"C_ToyBox.GetNumTotalDisplayedToys",
	"C_ToyBox.GetNumToys",
	"C_ToyBox.GetToyFromIndex",
	"C_ToyBox.GetToyInfo",
	"C_ToyBox.GetToyLink",
	"C_ToyBox.GetUncollectedShown",
	"C_ToyBox.GetUnusableShown",
	"C_ToyBox.HasFavorites",
	"C_ToyBox.IsExpansionTypeFilterChecked",
	"C_ToyBox.IsSourceTypeFilterChecked",
	"C_ToyBox.IsToyUsable",
	"C_ToyBox.PickupToyBoxItem",
	"C_ToyBox.SetAllExpansionTypeFilters",
	"C_ToyBox.SetAllSourceTypeFilters",
	"C_ToyBox.SetCollectedShown",
	"C_ToyBox.SetExpansionTypeFilter",
	"C_ToyBox.SetFilterString",
	"C_ToyBox.SetIsFavorite",
	"C_ToyBox.SetSourceTypeFilter",
	"C_ToyBox.SetUncollectedShown",
	"C_ToyBox.SetUnusableShown",
	"C_ToyBoxInfo.ClearFanfare",
	"C_ToyBoxInfo.NeedsFanfare",
	"C_TradeSkillUI.AnyRecipeCategoriesFiltered",
	"C_TradeSkillUI.AreAnyInventorySlotsFiltered",
	"C_TradeSkillUI.CanObliterateCursorItem",
	"C_TradeSkillUI.CanTradeSkillListLink",
	"C_TradeSkillUI.ClearInventorySlotFilter",
	"C_TradeSkillUI.ClearPendingObliterateItem",
	"C_TradeSkillUI.ClearRecipeCategoryFilter",
	"C_TradeSkillUI.ClearRecipeSourceTypeFilter",
	"C_TradeSkillUI.CloseObliterumForge",
	"C_TradeSkillUI.CloseTradeSkill",
	"C_TradeSkillUI.CraftRecipe",
	"C_TradeSkillUI.DropPendingObliterateItemFromCursor",
	"C_TradeSkillUI.GetAllFilterableInventorySlots",
	"C_TradeSkillUI.GetAllProfessionTradeSkillLines",
	"C_TradeSkillUI.GetAllRecipeIDs",
	"C_TradeSkillUI.GetCategories",
	"C_TradeSkillUI.GetCategoryInfo",
	"C_TradeSkillUI.GetFilterableInventorySlots",
	"C_TradeSkillUI.GetFilteredRecipeIDs",
	"C_TradeSkillUI.GetObliterateSpellID",
	"C_TradeSkillUI.GetOnlyShowLearnedRecipes",
	"C_TradeSkillUI.GetOnlyShowMakeableRecipes",
	"C_TradeSkillUI.GetOnlyShowSkillUpRecipes",
	"C_TradeSkillUI.GetOnlyShowUnlearnedRecipes",
	"C_TradeSkillUI.GetOptionalReagentBonusText",
	"C_TradeSkillUI.GetOptionalReagentInfo",
	"C_TradeSkillUI.GetPendingObliterateItemID",
	"C_TradeSkillUI.GetPendingObliterateItemLink",
	"C_TradeSkillUI.GetRecipeCooldown",
	"C_TradeSkillUI.GetRecipeDescription",
	"C_TradeSkillUI.GetRecipeInfo",
	"C_TradeSkillUI.GetRecipeItemLevelFilter",
	"C_TradeSkillUI.GetRecipeItemLink",
	"C_TradeSkillUI.GetRecipeItemNameFilter",
	"C_TradeSkillUI.GetRecipeLink",
	"C_TradeSkillUI.GetRecipeNumItemsProduced",
	"C_TradeSkillUI.GetRecipeNumReagents",
	"C_TradeSkillUI.GetRecipeReagentInfo",
	"C_TradeSkillUI.GetRecipeReagentItemLink",
	"C_TradeSkillUI.GetRecipeRepeatCount",
	"C_TradeSkillUI.GetRecipeSourceText",
	"C_TradeSkillUI.GetRecipeTools",
	"C_TradeSkillUI.GetSubCategories",
	"C_TradeSkillUI.GetTradeSkillDisplayName",
	"C_TradeSkillUI.GetTradeSkillLine",
	"C_TradeSkillUI.GetTradeSkillLineForRecipe",
	"C_TradeSkillUI.GetTradeSkillLineInfoByID",
	"C_TradeSkillUI.GetTradeSkillListLink",
	"C_TradeSkillUI.GetTradeSkillTexture",
	"C_TradeSkillUI.IsAnyRecipeFromSource",
	"C_TradeSkillUI.IsDataSourceChanging",
	"C_TradeSkillUI.IsEmptySkillLineCategory",
	"C_TradeSkillUI.IsInventorySlotFiltered",
	"C_TradeSkillUI.IsNPCCrafting",
	"C_TradeSkillUI.IsRecipeCategoryFiltered",
	"C_TradeSkillUI.IsRecipeFavorite",
	"C_TradeSkillUI.IsRecipeRepeating",
	"C_TradeSkillUI.IsRecipeSearchInProgress",
	"C_TradeSkillUI.IsRecipeSourceTypeFiltered",
	"C_TradeSkillUI.IsTradeSkillGuild",
	"C_TradeSkillUI.IsTradeSkillGuildMember",
	"C_TradeSkillUI.IsTradeSkillLinked",
	"C_TradeSkillUI.IsTradeSkillReady",
	"C_TradeSkillUI.ObliterateItem",
	"C_TradeSkillUI.OpenTradeSkill",
	"C_TradeSkillUI.SetInventorySlotFilter",
	"C_TradeSkillUI.SetOnlyShowLearnedRecipes",
	"C_TradeSkillUI.SetOnlyShowMakeableRecipes",
	"C_TradeSkillUI.SetOnlyShowSkillUpRecipes",
	"C_TradeSkillUI.SetOnlyShowUnlearnedRecipes",
	"C_TradeSkillUI.SetRecipeCategoryFilter",
	"C_TradeSkillUI.SetRecipeFavorite",
	"C_TradeSkillUI.SetRecipeItemLevelFilter",
	"C_TradeSkillUI.SetRecipeItemNameFilter",
	"C_TradeSkillUI.SetRecipeRepeatCount",
	"C_TradeSkillUI.SetRecipeSourceTypeFilter",
	"C_TradeSkillUI.StopRecipeRepeat",
	"C_Transmog.ApplyAllPending",
	"C_Transmog.CanTransmogItemWithItem",
	"C_Transmog.ClearAllPending",
	"C_Transmog.ClearPending",
	"C_Transmog.Close",
	"C_Transmog.GetApplyWarnings",
	"C_Transmog.GetBaseCategory",
	"C_Transmog.GetCost",
	"C_Transmog.GetCreatureDisplayIDForSource",
	"C_Transmog.GetItemIDForSource",
	"C_Transmog.GetItemInfo",
	"C_Transmog.GetSlotForInventoryType",
	"C_Transmog.GetSlotInfo",
	"C_Transmog.GetSlotUseError",
	"C_Transmog.GetSlotVisualInfo",
	"C_Transmog.LoadOutfit",
	"C_Transmog.LoadSources",
	"C_Transmog.SetPending",
	"C_Transmog.ValidateAllPending",
	"C_TransmogCollection.CanSetFavoriteInCategory",
	"C_TransmogCollection.ClearNewAppearance",
	"C_TransmogCollection.ClearSearch",
	"C_TransmogCollection.DeleteOutfit",
	"C_TransmogCollection.EndSearch",
	"C_TransmogCollection.GetAllAppearanceSources",
	"C_TransmogCollection.GetAppearanceCameraID",
	"C_TransmogCollection.GetAppearanceCameraIDBySource",
	"C_TransmogCollection.GetAppearanceInfoBySource",
	"C_TransmogCollection.GetAppearanceSourceDrops",
	"C_TransmogCollection.GetAppearanceSourceInfo",
	"C_TransmogCollection.GetAppearanceSources",
	"C_TransmogCollection.GetCategoryAppearances",
	"C_TransmogCollection.GetCategoryCollectedCount",
	"C_TransmogCollection.GetCategoryInfo",
	"C_TransmogCollection.GetCategoryTotal",
	"C_TransmogCollection.GetCollectedShown",
	"C_TransmogCollection.GetIllusionFallbackWeaponSource",
	"C_TransmogCollection.GetIllusionSourceInfo",
	"C_TransmogCollection.GetIllusions",
	"C_TransmogCollection.GetInspectSources",
	"C_TransmogCollection.GetIsAppearanceFavorite",
	"C_TransmogCollection.GetItemInfo",
	"C_TransmogCollection.GetLatestAppearance",
	"C_TransmogCollection.GetNumMaxOutfits",
	"C_TransmogCollection.GetNumTransmogSources",
	"C_TransmogCollection.GetOutfitName",
	"C_TransmogCollection.GetOutfitSources",
	"C_TransmogCollection.GetOutfits",
	"C_TransmogCollection.GetShowMissingSourceInItemTooltips",
	"C_TransmogCollection.GetSourceIcon",
	"C_TransmogCollection.GetSourceInfo",
	"C_TransmogCollection.GetSourceRequiredHoliday",
	"C_TransmogCollection.GetUncollectedShown",
	"C_TransmogCollection.HasFavorites",
	"C_TransmogCollection.IsCategoryValidForItem",
	"C_TransmogCollection.IsNewAppearance",
	"C_TransmogCollection.IsSearchDBLoading",
	"C_TransmogCollection.IsSearchInProgress",
	"C_TransmogCollection.IsSourceTypeFilterChecked",
	"C_TransmogCollection.ModifyOutfit",
	"C_TransmogCollection.PlayerCanCollectSource",
	"C_TransmogCollection.PlayerHasTransmog",
	"C_TransmogCollection.PlayerHasTransmogItemModifiedAppearance",
	"C_TransmogCollection.PlayerKnowsSource",
	"C_TransmogCollection.SaveOutfit",
	"C_TransmogCollection.SearchProgress",
	"C_TransmogCollection.SearchSize",
	"C_TransmogCollection.SetAllSourceTypeFilters",
	"C_TransmogCollection.SetCollectedShown",
	"C_TransmogCollection.SetIsAppearanceFavorite",
	"C_TransmogCollection.SetSearch",
	"C_TransmogCollection.SetSearchAndFilterCategory",
	"C_TransmogCollection.SetShowMissingSourceInItemTooltips",
	"C_TransmogCollection.SetSourceTypeFilter",
	"C_TransmogCollection.SetUncollectedShown",
	"C_TransmogCollection.UpdateUsableAppearances",
	"C_TransmogSets.ClearLatestSource",
	"C_TransmogSets.ClearNewSource",
	"C_TransmogSets.ClearSetNewSourcesForSlot",
	"C_TransmogSets.GetAllSets",
	"C_TransmogSets.GetAllSourceIDs",
	"C_TransmogSets.GetBaseSetID",
	"C_TransmogSets.GetBaseSets",
	"C_TransmogSets.GetBaseSetsCounts",
	"C_TransmogSets.GetBaseSetsFilter",
	"C_TransmogSets.GetCameraIDs",
	"C_TransmogSets.GetIsFavorite",
	"C_TransmogSets.GetLatestSource",
	"C_TransmogSets.GetSetInfo",
	"C_TransmogSets.GetSetNewSources",
	"C_TransmogSets.GetSetSources",
	"C_TransmogSets.GetSetsContainingSourceID",
	"C_TransmogSets.GetSourceIDsForSlot",
	"C_TransmogSets.GetSourcesForSlot",
	"C_TransmogSets.GetUsableSets",
	"C_TransmogSets.GetVariantSets",
	"C_TransmogSets.HasUsableSets",
	"C_TransmogSets.IsBaseSetCollected",
	"C_TransmogSets.IsNewSource",
	"C_TransmogSets.IsSetCollected",
	"C_TransmogSets.IsSetUsable",
	"C_TransmogSets.SetBaseSetsFilter",
	"C_TransmogSets.SetHasNewSources",
	"C_TransmogSets.SetHasNewSourcesForSlot",
	"C_TransmogSets.SetIsFavorite",
	"C_Trophy.MonumentChangeAppearanceToTrophyID",
	"C_Trophy.MonumentCloseMonumentUI",
	"C_Trophy.MonumentGetCount",
	"C_Trophy.MonumentGetSelectedTrophyID",
	"C_Trophy.MonumentGetTrophyInfoByIndex",
	"C_Trophy.MonumentLoadList",
	"C_Trophy.MonumentLoadSelectedTrophyID",
	"C_Trophy.MonumentRevertAppearanceToSaved",
	"C_Trophy.MonumentSaveSelection",
	"C_Tutorial.AbandonTutorialArea",
	"C_Tutorial.ReturnToTutorialArea",
	"C_UI.Reload",
	"C_UIWidgetManager.GetAllWidgetsBySetID",
	"C_UIWidgetManager.GetBelowMinimapWidgetSetID",
	"C_UIWidgetManager.GetBulletTextListWidgetVisualizationInfo",
	"C_UIWidgetManager.GetCaptureBarWidgetVisualizationInfo",
	"C_UIWidgetManager.GetCaptureZoneVisualizationInfo",
	"C_UIWidgetManager.GetDiscreteProgressStepsVisualizationInfo",
	"C_UIWidgetManager.GetDoubleIconAndTextWidgetVisualizationInfo",
	"C_UIWidgetManager.GetDoubleStateIconRowVisualizationInfo",
	"C_UIWidgetManager.GetDoubleStatusBarWidgetVisualizationInfo",
	"C_UIWidgetManager.GetHorizontalCurrenciesWidgetVisualizationInfo",
	"C_UIWidgetManager.GetIconAndTextWidgetVisualizationInfo",
	"C_UIWidgetManager.GetIconTextAndBackgroundWidgetVisualizationInfo",
	"C_UIWidgetManager.GetIconTextAndCurrenciesWidgetVisualizationInfo",
	"C_UIWidgetManager.GetObjectiveTrackerWidgetSetID",
	"C_UIWidgetManager.GetPowerBarWidgetSetID",
	"C_UIWidgetManager.GetScenarioHeaderCurrenciesAndBackgroundWidgetVisualizationInfo",
	"C_UIWidgetManager.GetScenarioHeaderTimerWidgetVisualizationInfo",
	"C_UIWidgetManager.GetSpellDisplayVisualizationInfo",
	"C_UIWidgetManager.GetStackedResourceTrackerWidgetVisualizationInfo",
	"C_UIWidgetManager.GetStatusBarWidgetVisualizationInfo",
	"C_UIWidgetManager.GetTextWithStateWidgetVisualizationInfo",
	"C_UIWidgetManager.GetTextureAndTextRowVisualizationInfo",
	"C_UIWidgetManager.GetTextureAndTextVisualizationInfo",
	"C_UIWidgetManager.GetTextureWithAnimationVisualizationInfo",
	"C_UIWidgetManager.GetTopCenterWidgetSetID",
	"C_UIWidgetManager.GetWidgetSetInfo",
	"C_UIWidgetManager.GetZoneControlVisualizationInfo",
	"C_UIWidgetManager.RegisterUnitForWidgetUpdates",
	"C_UIWidgetManager.SetProcessingUnit",
	"C_UIWidgetManager.UnregisterUnitForWidgetUpdates",
	"C_UserFeedback.SubmitBug",
	"C_UserFeedback.SubmitSuggestion",
	"C_VideoOptions.GetGxAdapterInfo",
	"C_VignetteInfo.FindBestUniqueVignette",
	"C_VignetteInfo.GetVignetteInfo",
	"C_VignetteInfo.GetVignettePosition",
	"C_VignetteInfo.GetVignettes",
	"C_VoiceChat.ActivateChannel",
	"C_VoiceChat.BeginLocalCapture",
	"C_VoiceChat.CanPlayerUseVoiceChat",
	"C_VoiceChat.CreateChannel",
	"C_VoiceChat.DeactivateChannel",
	"C_VoiceChat.EndLocalCapture",
	"C_VoiceChat.GetActiveChannelID",
	"C_VoiceChat.GetActiveChannelType",
	"C_VoiceChat.GetAvailableInputDevices",
	"C_VoiceChat.GetAvailableOutputDevices",
	"C_VoiceChat.GetChannel",
	"C_VoiceChat.GetChannelForChannelType",
	"C_VoiceChat.GetChannelForCommunityStream",
	"C_VoiceChat.GetCommunicationMode",
	"C_VoiceChat.GetCurrentVoiceChatConnectionStatusCode",
	"C_VoiceChat.GetInputVolume",
	"C_VoiceChat.GetJoinClubVoiceChannelError",
	"C_VoiceChat.GetLocalPlayerActiveChannelMemberInfo",
	"C_VoiceChat.GetLocalPlayerMemberID",
	"C_VoiceChat.GetMasterVolumeScale",
	"C_VoiceChat.GetMemberGUID",
	"C_VoiceChat.GetMemberID",
	"C_VoiceChat.GetMemberInfo",
	"C_VoiceChat.GetMemberName",
	"C_VoiceChat.GetMemberVolume",
	"C_VoiceChat.GetOutputVolume",
	"C_VoiceChat.GetPTTButtonPressedState",
	"C_VoiceChat.GetProcesses",
	"C_VoiceChat.GetPushToTalkBinding",
	"C_VoiceChat.GetVADSensitivity",
	"C_VoiceChat.IsChannelJoinPending",
	"C_VoiceChat.IsDeafened",
	"C_VoiceChat.IsEnabled",
	"C_VoiceChat.IsLoggedIn",
	"C_VoiceChat.IsMemberLocalPlayer",
	"C_VoiceChat.IsMemberMuted",
	"C_VoiceChat.IsMemberMutedForAll",
	"C_VoiceChat.IsMemberSilenced",
	"C_VoiceChat.IsMuted",
	"C_VoiceChat.IsParentalDisabled",
	"C_VoiceChat.IsParentalMuted",
	"C_VoiceChat.IsPlayerUsingVoice",
	"C_VoiceChat.IsSilenced",
	"C_VoiceChat.LeaveChannel",
	"C_VoiceChat.Login",
	"C_VoiceChat.Logout",
	"C_VoiceChat.MarkChannelsDiscovered",
	"C_VoiceChat.RequestJoinAndActivateCommunityStreamChannel",
	"C_VoiceChat.RequestJoinChannelByChannelType",
	"C_VoiceChat.SetCommunicationMode",
	"C_VoiceChat.SetDeafened",
	"C_VoiceChat.SetInputDevice",
	"C_VoiceChat.SetInputVolume",
	"C_VoiceChat.SetMasterVolumeScale",
	"C_VoiceChat.SetMemberMuted",
	"C_VoiceChat.SetMemberVolume",
	"C_VoiceChat.SetMuted",
	"C_VoiceChat.SetOutputDevice",
	"C_VoiceChat.SetOutputVolume",
	"C_VoiceChat.SetPortraitTexture",
	"C_VoiceChat.SetPushToTalkBinding",
	"C_VoiceChat.SetVADSensitivity",
	"C_VoiceChat.ShouldDiscoverChannels",
	"C_VoiceChat.ToggleDeafened",
	"C_VoiceChat.ToggleMemberMuted",
	"C_VoiceChat.ToggleMuted",
	"C_WeeklyRewards.CanClaimRewards",
	"C_WeeklyRewards.ClaimReward",
	"C_WeeklyRewards.CloseInteraction",
	"C_WeeklyRewards.GetActivities",
	"C_WeeklyRewards.GetConquestWeeklyProgress",
	"C_WeeklyRewards.GetExampleRewardItemHyperlinks",
	"C_WeeklyRewards.GetItemHyperlink",
	"C_WeeklyRewards.HasAvailableRewards",
	"C_WeeklyRewards.HasGeneratedRewards",
	"C_Widget.IsFrameWidget",
	"C_Widget.IsRenderableWidget",
	"C_Widget.IsWidget",
	"C_WowTokenPublic.BuyToken",
	"C_WowTokenPublic.GetCommerceSystemStatus",
	"C_WowTokenPublic.GetCurrentMarketPrice",
	"C_WowTokenPublic.GetGuaranteedPrice",
	"C_WowTokenPublic.GetListedAuctionableTokenInfo",
	"C_WowTokenPublic.GetNumListedAuctionableTokens",
	"C_WowTokenPublic.IsAuctionableWowToken",
	"C_WowTokenPublic.IsConsumableWowToken",
	"C_WowTokenPublic.UpdateListedAuctionableTokens",
	"C_WowTokenPublic.UpdateMarketPrice",
	"C_WowTokenPublic.UpdateTokenCount",
	"C_WowTokenUI.StartTokenSell",
	"C_ZoneAbility.GetActiveAbilities",
	"CalculateStringEditDistance",
	"CallCompanion",
	"CameraOrSelectOrMoveStart",
	"CameraOrSelectOrMoveStop",
	"CameraZoomIn",
	"CameraZoomOut",
	"CanAffordMerchantItem",
	"CanAutoSetGamePadCursorControl",
	"CanBeRaidTarget",
	"CanCancelScene",
	"CanChangePlayerDifficulty",
	"CanComplainInboxItem",
	"CanDualWield",
	"CanEditGuildBankTabInfo",
	"CanEditGuildEvent",
	"CanEditGuildInfo",
	"CanEditGuildTabInfo",
	"CanEditMOTD",
	"CanEditPublicNote",
	"CanEjectPassengerFromSeat",
	"CanExitVehicle",
	"CanGamePadControlCursor",
	"CanGuildBankRepair",
	"CanGuildDemote",
	"CanGuildInvite",
	"CanGuildPromote",
	"CanGuildRemove",
	"CanHearthAndResurrectFromArea",
	"CanInitiateWarGame",
	"CanInspect",
	"CanItemBeSocketedToArtifact",
	"CanJoinBattlefieldAsGroup",
	"CanLootUnit",
	"CanMapChangeDifficulty",
	"CanMerchantRepair",
	"CanPartyLFGBackfill",
	"CanReplaceGuildMaster",
	"CanResetTutorials",
	"CanScanResearchSite",
	"CanShowAchievementUI",
	"CanShowResetInstances",
	"CanSignPetition",
	"CanSolveArtifact",
	"CanSummonFriend",
	"CanSurrenderArena",
	"CanSwitchVehicleSeat",
	"CanSwitchVehicleSeats",
	"CanTrackBattlePets",
	"CanUpgradeExpansion",
	"CanUseVoidStorage",
	"CanViewGuildRecipes",
	"CanWithdrawGuildBankMoney",
	"CancelAreaSpiritHeal",
	"CancelBarberShop",
	"CancelDuel",
	"CancelEmote",
	"CancelGuildMembershipRequest",
	"CancelItemTempEnchantment",
	"CancelLogout",
	"CancelMasterLootRoll",
	"CancelPendingEquip",
	"CancelPetPossess",
	"CancelPreloadingMovie",
	"CancelScene",
	"CancelShapeshiftForm",
	"CancelSpellByName",
	"CancelTrade",
	"CancelTradeAccept",
	"CancelUnitBuff",
	"CannotBeResurrected",
	"CaseAccentInsensitiveParse",
	"CastPetAction",
	"CastShapeshiftForm",
	"CastSpell",
	"CastSpellByID",
	"CastSpellByName",
	"CenterCamera",
	"ChangeActionBarPage",
	"ChangeChatColor",
	"ChannelBan",
	"ChannelInvite",
	"ChannelKick",
	"ChannelModerator",
	"ChannelSetAllSilent",
	"ChannelSetPartyMemberSilent",
	"ChannelToggleAnnouncements",
	"ChannelUnban",
	"ChannelUnmoderator",
	"CheckBinderDist",
	"CheckInbox",
	"CheckInteractDistance",
	"CheckSpiritHealerDist",
	"CheckTalentMasterDist",
	"ClearAchievementComparisonUnit",
	"ClearAchievementSearchString",
	"ClearAllLFGDungeons",
	"ClearAllTracking",
	"ClearAutoAcceptQuestSound",
	"ClearBattlemaster",
	"ClearCursor",
	"ClearFailedPVPTalentIDs",
	"ClearFailedTalentIDs",
	"ClearFocus",
	"ClearInspectPlayer",
	"ClearItemUpgrade",
	"ClearOverrideBindings",
	"ClearPartyAssignment",
	"ClearRaidMarker",
	"ClearSendMail",
	"ClearTarget",
	"ClearTutorials",
	"ClearVoidTransferDepositSlot",
	"ClickSendMailItemButton",
	"ClickSocketButton",
	"ClickTargetTradeButton",
	"ClickTradeButton",
	"ClickVoidStorageSlot",
	"ClickVoidTransferDepositSlot",
	"ClickVoidTransferWithdrawalSlot",
	"ClickWorldMapActionButton",
	"CloseBankFrame",
	"CloseGuildBankFrame",
	"CloseGuildRegistrar",
	"CloseGuildRoster",
	"CloseItemText",
	"CloseItemUpgrade",
	"CloseLoot",
	"CloseMail",
	"CloseMerchant",
	"ClosePetStables",
	"ClosePetition",
	"ClosePlayerChoice",
	"CloseQuest",
	"CloseResearch",
	"CloseSocketInfo",
	"CloseTabardCreation",
	"CloseTaxiMap",
	"CloseTrade",
	"CloseTrainer",
	"CloseVoidStorageFrame",
	"ClosestGameObjectPosition",
	"ClosestUnitPosition",
	"CollapseAllFactionHeaders",
	"CollapseFactionHeader",
	"CollapseGuildTradeSkillHeader",
	"CollapseQuestHeader",
	"CollapseWarGameHeader",
	"CombatLogAddFilter",
	"CombatLogAdvanceEntry",
	"CombatLogClearEntries",
	"CombatLogGetCurrentEntry",
	"CombatLogGetCurrentEventInfo",
	"CombatLogGetNumEntries",
	"CombatLogGetRetentionTime",
	"CombatLogResetFilter",
	"CombatLogSetCurrentEntry",
	"CombatLogSetRetentionTime",
	"CombatLog_Object_IsA",
	"CombatTextSetActiveUnit",
	"ComplainInboxItem",
	"CompleteLFGReadyCheck",
	"CompleteLFGRoleCheck",
	"CompleteQuest",
	"ConfirmAcceptQuest",
	"ConfirmBNRequestInviteFriend",
	"ConfirmBindOnUse",
	"ConfirmBinder",
	"ConfirmLootRoll",
	"ConfirmLootSlot",
	"ConfirmNoRefundOnUse",
	"ConfirmOnUse",
	"ConfirmReadyCheck",
	"ConfirmTalentWipe",
	"ConsoleAddMessage",
	"ConsoleExec",
	"ContainerIDToInventoryID",
	"ContainerRefundItemPurchase",
	"CopyToClipboard",
	"CreateFont",
	"CreateFrame",
	"CreateMacro",
	"CreateNewRaidProfile",
	"CursorCanGoInSlot",
	"CursorHasItem",
	"CursorHasMacro",
	"CursorHasMoney",
	"CursorHasSpell",
	"DeathRecap_GetEvents",
	"DeathRecap_HasEvents",
	"DeclineChannelInvite",
	"DeclineGroup",
	"DeclineGuild",
	"DeclineGuildApplicant",
	"DeclineName",
	"DeclineQuest",
	"DeclineResurrect",
	"DeclineSpellConfirmationPrompt",
	"DeleteCursorItem",
	"DeleteGMTicket",
	"DeleteInboxItem",
	"DeleteMacro",
	"DeleteRaidProfile",
	"DemoteAssistant",
	"DepositGuildBankMoney",
	"DepositReagentBank",
	"DescendStop",
	"DestroyTotem",
	"DetectWowMouse",
	"DisableAddOn",
	"DisableAllAddOns",
	"DisableSpellAutocast",
	"DismissCompanion",
	"Dismount",
	"DisplayChannelOwner",
	"DoEmote",
	"DoMasterLootRoll",
	"DoReadyCheck",
	"DoesCurrentLocaleSellExpansionLevels",
	"DoesItemContainSpec",
	"DoesSpellExist",
	"DoesTemplateExist",
	"DropCursorMoney",
	"DropItemOnUnit",
	"DumpMovementCapture",
	"DungeonAppearsInRandomLFD",
	"EJ_ClearSearch",
	"EJ_EndSearch",
	"EJ_GetContentTuningID",
	"EJ_GetCreatureInfo",
	"EJ_GetCurrentTier",
	"EJ_GetDifficulty",
	"EJ_GetEncounterInfo",
	"EJ_GetEncounterInfoByIndex",
	"EJ_GetInstanceByIndex",
	"EJ_GetInstanceForMap",
	"EJ_GetInstanceInfo",
	"EJ_GetInvTypeSortOrder",
	"EJ_GetLootFilter",
	"EJ_GetMapEncounter",
	"EJ_GetNumEncountersForLootByIndex",
	"EJ_GetNumLoot",
	"EJ_GetNumSearchResults",
	"EJ_GetNumTiers",
	"EJ_GetSearchProgress",
	"EJ_GetSearchResult",
	"EJ_GetSearchSize",
	"EJ_GetSectionPath",
	"EJ_GetTierInfo",
	"EJ_HandleLinkPath",
	"EJ_InstanceIsRaid",
	"EJ_IsLootListOutOfDate",
	"EJ_IsSearchFinished",
	"EJ_IsValidInstanceDifficulty",
	"EJ_ResetLootFilter",
	"EJ_SelectEncounter",
	"EJ_SelectInstance",
	"EJ_SelectTier",
	"EJ_SetDifficulty",
	"EJ_SetLootFilter",
	"EJ_SetSearch",
	"EditMacro",
	"EjectPassengerFromSeat",
	"EnableAddOn",
	"EnableAllAddOns",
	"EnableSpellAutocast",
	"EndBoundTradeable",
	"EndRefund",
	"EnumerateFrames",
	"EnumerateServerChannels",
	"EquipCursorItem",
	"EquipItemByName",
	"EquipPendingItem",
	"ExecuteVoidTransfer",
	"ExpandAllFactionHeaders",
	"ExpandFactionHeader",
	"ExpandGuildTradeSkillHeader",
	"ExpandQuestHeader",
	"ExpandWarGameHeader",
	"FactionToggleAtWar",
	"FillLocalizedClassList",
	"FindBaseSpellByID",
	"FindFlyoutSlotBySpellID",
	"FindSpellBookSlotBySpellID",
	"FindSpellOverrideByID",
	"FlagTutorial",
	"FlashClientIcon",
	"FlipCameraYaw",
	"FlyoutHasSpell",
	"FocusUnit",
	"FollowUnit",
	"ForceLogout",
	"ForceQuit",
	"ForfeitDuel",
	"FrameXML_Debug",
	"GMEuropaBugsEnabled",
	"GMEuropaComplaintsEnabled",
	"GMEuropaSuggestionsEnabled",
	"GMEuropaTicketsEnabled",
	"GMItemRestorationButtonEnabled",
	"GMQuickTicketSystemEnabled",
	"GMQuickTicketSystemThrottled",
	"GMReportLag",
	"GMRequestPlayerInfo",
	"GMResponseResolve",
	"GMSurveyAnswer",
	"GMSurveyAnswerSubmit",
	"GMSurveyCommentSubmit",
	"GMSurveyNumAnswers",
	"GMSurveyQuestion",
	"GMSurveySubmit",
	"GameMovieFinished",
	"GetAccountExpansionLevel",
	"GetAchievementCategory",
	"GetAchievementComparisonInfo",
	"GetAchievementCriteriaInfo",
	"GetAchievementCriteriaInfoByID",
	"GetAchievementGuildRep",
	"GetAchievementInfo",
	"GetAchievementLink",
	"GetAchievementNumCriteria",
	"GetAchievementNumRewards",
	"GetAchievementReward",
	"GetAchievementSearchProgress",
	"GetAchievementSearchSize",
	"GetActionAutocast",
	"GetActionBarPage",
	"GetActionBarToggles",
	"GetActionCharges",
	"GetActionCooldown",
	"GetActionCount",
	"GetActionInfo",
	"GetActionLossOfControlCooldown",
	"GetActionText",
	"GetActionTexture",
	"GetActiveArtifactByRace",
	"GetActiveLevel",
	"GetActiveLootRollIDs",
	"GetActiveQuestID",
	"GetActiveSpecGroup",
	"GetActiveTitle",
	"GetAddOnCPUUsage",
	"GetAddOnDependencies",
	"GetAddOnEnableState",
	"GetAddOnInfo",
	"GetAddOnMemoryUsage",
	"GetAddOnMetadata",
	"GetAddOnOptionalDependencies",
	"GetAllowLowLevelRaid",
	"GetAlternativeDefaultLanguage",
	"GetArchaeologyInfo",
	"GetArchaeologyRaceInfo",
	"GetArchaeologyRaceInfoByID",
	"GetAreaSpiritHealerTime",
	"GetAreaText",
	"GetArenaOpponentSpec",
	"GetArtifactInfoByRace",
	"GetArtifactProgress",
	"GetAttackPowerForStat",
	"GetAutoCompletePresenceID",
	"GetAutoCompleteRealms",
	"GetAutoCompleteResults",
	"GetAutoDeclineGuildInvites",
	"GetAutoQuestPopUp",
	"GetAvailableBandwidth",
	"GetAvailableLevel",
	"GetAvailableLocaleInfo",
	"GetAvailableLocales",
	"GetAvailableQuestInfo",
	"GetAvailableTitle",
	"GetAverageItemLevel",
	"GetAvoidance",
	"GetBackgroundLoadingStatus",
	"GetBackpackAutosortDisabled",
	"GetBagName",
	"GetBagSlotFlag",
	"GetBankAutosortDisabled",
	"GetBankBagSlotFlag",
	"GetBankSlotCost",
	"GetBarberShopStyleInfo",
	"GetBarberShopTotalCost",
	"GetBattlefieldArenaFaction",
	"GetBattlefieldEstimatedWaitTime",
	"GetBattlefieldFlagPosition",
	"GetBattlefieldInstanceExpiration",
	"GetBattlefieldInstanceRunTime",
	"GetBattlefieldMapIconScale",
	"GetBattlefieldPortExpiration",
	"GetBattlefieldScore",
	"GetBattlefieldStatData",
	"GetBattlefieldStatus",
	"GetBattlefieldTeamInfo",
	"GetBattlefieldTimeWaited",
	"GetBattlefieldWinner",
	"GetBattlegroundInfo",
	"GetBattlegroundPoints",
	"GetBestFlexRaidChoice",
	"GetBestRFChoice",
	"GetBillingTimeRested",
	"GetBindLocation",
	"GetBinding",
	"GetBindingAction",
	"GetBindingByKey",
	"GetBindingKey",
	"GetBindingText",
	"GetBlockChance",
	"GetBonusBarIndex",
	"GetBonusBarOffset",
	"GetBuildInfo",
	"GetBuybackItemInfo",
	"GetBuybackItemLink",
	"GetCVarInfo",
	"GetCVarSettingValidity",
	"GetCallPetSpellInfo",
	"GetCameraZoom",
	"GetCategoryAchievementPoints",
	"GetCategoryInfo",
	"GetCategoryList",
	"GetCategoryNumAchievements",
	"GetCemeteryPreference",
	"GetChannelDisplayInfo",
	"GetChannelList",
	"GetChannelName",
	"GetChatTypeIndex",
	"GetChatWindowChannels",
	"GetChatWindowInfo",
	"GetChatWindowMessages",
	"GetChatWindowSavedDimensions",
	"GetChatWindowSavedPosition",
	"GetClassInfo",
	"GetClickFrame",
	"GetClientDisplayExpansionLevel",
	"GetCoinIcon",
	"GetCoinText",
	"GetCoinTextureString",
	"GetCombatRating",
	"GetCombatRatingBonus",
	"GetCombatRatingBonusForCombatRatingValue",
	"GetComboPoints",
	"GetCompanionInfo",
	"GetComparisonAchievementPoints",
	"GetComparisonCategoryNumAchievements",
	"GetComparisonStatistic",
	"GetContainerFreeSlots",
	"GetContainerItemCooldown",
	"GetContainerItemDurability",
	"GetContainerItemEquipmentSetInfo",
	"GetContainerItemID",
	"GetContainerItemInfo",
	"GetContainerItemLink",
	"GetContainerItemPurchaseCurrency",
	"GetContainerItemPurchaseInfo",
	"GetContainerItemPurchaseItem",
	"GetContainerItemQuestInfo",
	"GetContainerNumFreeSlots",
	"GetContainerNumSlots",
	"GetCorpseRecoveryDelay",
	"GetCorruption",
	"GetCorruptionResistance",
	"GetCritChance",
	"GetCritChanceProvidesParryEffect",
	"GetCriteriaSpell",
	"GetCurrentArenaSeason",
	"GetCurrentBindingSet",
	"GetCurrentCombatTextEventInfo",
	"GetCurrentEventID",
	"GetCurrentGlyphNameForSpell",
	"GetCurrentGraphicsSetting",
	"GetCurrentGuildBankTab",
	"GetCurrentKeyBoardFocus",
	"GetCurrentLevelFeatures",
	"GetCurrentLevelSpells",
	"GetCurrentRegion",
	"GetCurrentRegionName",
	"GetCurrentResolution",
	"GetCurrentScaledResolution",
	"GetCurrentTitle",
	"GetCursorDelta",
	"GetCursorInfo",
	"GetCursorMoney",
	"GetCursorPosition",
	"GetCustomizationDetails",
	"GetDailyQuestsCompleted",
	"GetDeathRecapLink",
	"GetDefaultGraphicsQuality",
	"GetDefaultLanguage",
	"GetDefaultScale",
	"GetDefaultVideoOption",
	"GetDefaultVideoOptions",
	"GetDefaultVideoQualityOption",
	"GetDemotionRank",
	"GetDetailedItemLevelInfo",
	"GetDifficultyInfo",
	"GetDodgeChance",
	"GetDodgeChanceFromAttribute",
	"GetDownloadedPercentage",
	"GetDungeonDifficultyID",
	"GetDungeonForRandomSlot",
	"GetDungeonInfo",
	"GetEquipmentNameFromSpell",
	"GetEventCPUUsage",
	"GetEventTime",
	"GetExistingSocketInfo",
	"GetExistingSocketLink",
	"GetExpansionDisplayInfo",
	"GetExpansionForLevel",
	"GetExpansionLevel",
	"GetExpansionTrialInfo",
	"GetExpertise",
	"GetExtraBarIndex",
	"GetFactionInfo",
	"GetFactionInfoByID",
	"GetFailedPVPTalentIDs",
	"GetFailedTalentIDs",
	"GetFileIDFromPath",
	"GetFileStreamingStatus",
	"GetFilteredAchievementID",
	"GetFlexRaidDungeonInfo",
	"GetFlyoutID",
	"GetFlyoutInfo",
	"GetFlyoutSlotInfo",
	"GetFollowerTypeIDFromSpell",
	"GetFontInfo",
	"GetFonts",
	"GetFrameCPUUsage",
	"GetFramerate",
	"GetFramesRegisteredForEvent",
	"GetFriendshipReputation",
	"GetFriendshipReputationRanks",
	"GetFunctionCPUUsage",
	"GetGMStatus",
	"GetGMTicket",
	"GetGameMessageInfo",
	"GetGameTime",
	"GetGraphicsAPIs",
	"GetGraphicsDropdownIndexByMasterIndex",
	"GetGreetingText",
	"GetGroupMemberCounts",
	"GetGuildAchievementMemberInfo",
	"GetGuildAchievementMembers",
	"GetGuildAchievementNumMembers",
	"GetGuildApplicantInfo",
	"GetGuildApplicantSelection",
	"GetGuildBankBonusDepositMoney",
	"GetGuildBankItemInfo",
	"GetGuildBankItemLink",
	"GetGuildBankMoney",
	"GetGuildBankMoneyTransaction",
	"GetGuildBankTabCost",
	"GetGuildBankTabInfo",
	"GetGuildBankTabPermissions",
	"GetGuildBankText",
	"GetGuildBankTransaction",
	"GetGuildBankWithdrawGoldLimit",
	"GetGuildBankWithdrawMoney",
	"GetGuildCategoryList",
	"GetGuildChallengeInfo",
	"GetGuildCharterCost",
	"GetGuildEventInfo",
	"GetGuildExpirationTime",
	"GetGuildFactionGroup",
	"GetGuildFactionInfo",
	"GetGuildInfo",
	"GetGuildInfoText",
	"GetGuildLogoInfo",
	"GetGuildMemberRecipes",
	"GetGuildMembershipRequestInfo",
	"GetGuildMembershipRequestSettings",
	"GetGuildNewsFilters",
	"GetGuildNewsMemberName",
	"GetGuildNewsSort",
	"GetGuildPerkInfo",
	"GetGuildRecipeInfoPostQuery",
	"GetGuildRecipeMember",
	"GetGuildRecruitmentComment",
	"GetGuildRecruitmentSettings",
	"GetGuildRenameRequired",
	"GetGuildRewardInfo",
	"GetGuildRosterInfo",
	"GetGuildRosterLargestAchievementPoints",
	"GetGuildRosterLastOnline",
	"GetGuildRosterMOTD",
	"GetGuildRosterSelection",
	"GetGuildRosterShowOffline",
	"GetGuildTabardFiles",
	"GetGuildTradeSkillInfo",
	"GetHaste",
	"GetHitModifier",
	"GetHomePartyInfo",
	"GetInboxHeaderInfo",
	"GetInboxInvoiceInfo",
	"GetInboxItem",
	"GetInboxItemLink",
	"GetInboxNumItems",
	"GetInboxText",
	"GetInsertItemsLeftToRight",
	"GetInspectArenaData",
	"GetInspectGuildInfo",
	"GetInspectHonorData",
	"GetInspectRatedBGData",
	"GetInspectSpecialization",
	"GetInspectTalent",
	"GetInstanceBootTimeRemaining",
	"GetInstanceInfo",
	"GetInstanceLockTimeRemaining",
	"GetInstanceLockTimeRemainingEncounter",
	"GetInventoryAlertStatus",
	"GetInventoryItemBroken",
	"GetInventoryItemCooldown",
	"GetInventoryItemCount",
	"GetInventoryItemDurability",
	"GetInventoryItemEquippedUnusable",
	"GetInventoryItemID",
	"GetInventoryItemLink",
	"GetInventoryItemQuality",
	"GetInventoryItemTexture",
	"GetInventoryItemsForSlot",
	"GetInventorySlotInfo",
	"GetInviteConfirmationInfo",
	"GetItemChildInfo",
	"GetItemClassInfo",
	"GetItemCooldown",
	"GetItemCount",
	"GetItemCreationContext",
	"GetItemFamily",
	"GetItemGem",
	"GetItemIcon",
	"GetItemInfo",
	"GetItemInfoInstant",
	"GetItemInventorySlotInfo",
	"GetItemLevelColor",
	"GetItemLevelIncrement",
	"GetItemQualityColor",
	"GetItemSetInfo",
	"GetItemSpecInfo",
	"GetItemSpell",
	"GetItemStatDelta",
	"GetItemStats",
	"GetItemSubClassInfo",
	"GetItemUniqueness",
	"GetItemUpdateLevel",
	"GetItemUpgradeEffect",
	"GetItemUpgradeItemInfo",
	"GetItemUpgradeStats",
	"GetJailersTowerLevel",
	"GetJournalInfoForSpellConfirmation",
	"GetLFDChoiceCollapseState",
	"GetLFDChoiceEnabledState",
	"GetLFDChoiceOrder",
	"GetLFDLockInfo",
	"GetLFDLockPlayerCount",
	"GetLFDRoleLockInfo",
	"GetLFDRoleRestrictions",
	"GetLFGBootProposal",
	"GetLFGCategoryForID",
	"GetLFGCompletionReward",
	"GetLFGCompletionRewardItem",
	"GetLFGCompletionRewardItemLink",
	"GetLFGDeserterExpiration",
	"GetLFGDungeonEncounterInfo",
	"GetLFGDungeonInfo",
	"GetLFGDungeonNumEncounters",
	"GetLFGDungeonRewardCapBarInfo",
	"GetLFGDungeonRewardCapInfo",
	"GetLFGDungeonRewardInfo",
	"GetLFGDungeonRewardLink",
	"GetLFGDungeonRewards",
	"GetLFGDungeonShortageRewardInfo",
	"GetLFGDungeonShortageRewardLink",
	"GetLFGInfoServer",
	"GetLFGInviteRoleAvailability",
	"GetLFGInviteRoleRestrictions",
	"GetLFGProposal",
	"GetLFGProposalEncounter",
	"GetLFGProposalMember",
	"GetLFGQueueStats",
	"GetLFGQueuedList",
	"GetLFGRandomCooldownExpiration",
	"GetLFGRandomDungeonInfo",
	"GetLFGReadyCheckUpdate",
	"GetLFGReadyCheckUpdateBattlegroundInfo",
	"GetLFGRoleShortageRewards",
	"GetLFGRoleUpdate",
	"GetLFGRoleUpdateBattlegroundInfo",
	"GetLFGRoleUpdateMember",
	"GetLFGRoleUpdateSlot",
	"GetLFGRoles",
	"GetLFGSuspendedPlayers",
	"GetLFRChoiceOrder",
	"GetLanguageByIndex",
	"GetLatestCompletedAchievements",
	"GetLatestCompletedComparisonAchievements",
	"GetLatestThreeSenders",
	"GetLatestUpdatedComparisonStats",
	"GetLatestUpdatedStats",
	"GetLegacyRaidDifficultyID",
	"GetLevelUpInstances",
	"GetLifesteal",
	"GetLocalGameTime",
	"GetLocale",
	"GetLookingForGuildComment",
	"GetLookingForGuildSettings",
	"GetLooseMacroIcons",
	"GetLooseMacroItemIcons",
	"GetLootInfo",
	"GetLootMethod",
	"GetLootRollItemInfo",
	"GetLootRollItemLink",
	"GetLootRollTimeLeft",
	"GetLootSlotInfo",
	"GetLootSlotLink",
	"GetLootSlotType",
	"GetLootSourceInfo",
	"GetLootSpecialization",
	"GetLootThreshold",
	"GetMacroBody",
	"GetMacroIcons",
	"GetMacroIndexByName",
	"GetMacroInfo",
	"GetMacroItem",
	"GetMacroItemIcons",
	"GetMacroSpell",
	"GetManaRegen",
	"GetMasterLootCandidate",
	"GetMastery",
	"GetMasteryEffect",
	"GetMawPowerLinkBySpellID",
	"GetMaxArenaCurrency",
	"GetMaxBattlefieldID",
	"GetMaxCombatRatingBonus",
	"GetMaxLevelForExpansionLevel",
	"GetMaxLevelForLatestExpansion",
	"GetMaxLevelForPlayerExpansion",
	"GetMaxNumCUFProfiles",
	"GetMaxPlayerLevel",
	"GetMaxRenderScale",
	"GetMaxRewardCurrencies",
	"GetMaxSpellStartRecoveryOffset",
	"GetMaxTalentTier",
	"GetMaximumExpansionLevel",
	"GetMeleeHaste",
	"GetMerchantCurrencies",
	"GetMerchantFilter",
	"GetMerchantItemCostInfo",
	"GetMerchantItemCostItem",
	"GetMerchantItemID",
	"GetMerchantItemInfo",
	"GetMerchantItemLink",
	"GetMerchantItemMaxStack",
	"GetMerchantNumItems",
	"GetMinRenderScale",
	"GetMinimapZoneText",
	"GetMinimumExpansionLevel",
	"GetMirrorTimerInfo",
	"GetMirrorTimerProgress",
	"GetModResilienceDamageReduction",
	"GetModifiedClick",
	"GetModifiedClickAction",
	"GetMoney",
	"GetMonitorAspectRatio",
	"GetMonitorCount",
	"GetMonitorName",
	"GetMouseButtonClicked",
	"GetMouseButtonName",
	"GetMouseClickFocus",
	"GetMouseFocus",
	"GetMouseMotionFocus",
	"GetMovieDownloadProgress",
	"GetMultiCastBarIndex",
	"GetMultiCastTotemSpells",
	"GetNegativeCorruptionEffectInfo",
	"GetNetIpTypes",
	"GetNetStats",
	"GetNewSocketInfo",
	"GetNewSocketLink",
	"GetNextAchievement",
	"GetNextCompleatedTutorial",
	"GetNextPendingInviteConfirmation",
	"GetNormalizedRealmName",
	"GetNumActiveQuests",
	"GetNumAddOns",
	"GetNumArchaeologyRaces",
	"GetNumArenaOpponentSpecs",
	"GetNumArenaOpponents",
	"GetNumArtifactsByRace",
	"GetNumAutoQuestPopUps",
	"GetNumAvailableQuests",
	"GetNumBankSlots",
	"GetNumBattlefieldFlagPositions",
	"GetNumBattlefieldScores",
	"GetNumBattlefieldVehicles",
	"GetNumBattlegroundTypes",
	"GetNumBindings",
	"GetNumBuybackItems",
	"GetNumChannelMembers",
	"GetNumClasses",
	"GetNumCompanions",
	"GetNumComparisonCompletedAchievements",
	"GetNumCompletedAchievements",
	"GetNumDeclensionSets",
	"GetNumDisplayChannels",
	"GetNumDungeonForRandomSlot",
	"GetNumExpansions",
	"GetNumFactions",
	"GetNumFilteredAchievements",
	"GetNumFlexRaidDungeons",
	"GetNumFlyouts",
	"GetNumFrames",
	"GetNumGroupChannels",
	"GetNumGroupMembers",
	"GetNumGuildApplicants",
	"GetNumGuildBankMoneyTransactions",
	"GetNumGuildBankTabs",
	"GetNumGuildBankTransactions",
	"GetNumGuildChallenges",
	"GetNumGuildEvents",
	"GetNumGuildMembers",
	"GetNumGuildMembershipRequests",
	"GetNumGuildNews",
	"GetNumGuildPerks",
	"GetNumGuildRewards",
	"GetNumGuildTradeSkill",
	"GetNumItemUpgradeEffects",
	"GetNumLanguages",
	"GetNumLootItems",
	"GetNumMacros",
	"GetNumMembersInRank",
	"GetNumModifiedClickActions",
	"GetNumPetitionNames",
	"GetNumQuestChoices",
	"GetNumQuestCurrencies",
	"GetNumQuestItemDrops",
	"GetNumQuestItems",
	"GetNumQuestLeaderBoards",
	"GetNumQuestLogChoices",
	"GetNumQuestLogRewardCurrencies",
	"GetNumQuestLogRewardFactions",
	"GetNumQuestLogRewardSpells",
	"GetNumQuestLogRewards",
	"GetNumQuestLogTasks",
	"GetNumQuestPOIWorldEffects",
	"GetNumQuestRewards",
	"GetNumRFDungeons",
	"GetNumRaidProfiles",
	"GetNumRandomDungeons",
	"GetNumRandomScenarios",
	"GetNumRecruitingGuilds",
	"GetNumRewardCurrencies",
	"GetNumRewardSpells",
	"GetNumRoutes",
	"GetNumSavedInstances",
	"GetNumSavedWorldBosses",
	"GetNumScenarios",
	"GetNumShapeshiftForms",
	"GetNumSockets",
	"GetNumSpecGroups",
	"GetNumSpecializations",
	"GetNumSpecializationsForClassID",
	"GetNumSpellTabs",
	"GetNumSubgroupMembers",
	"GetNumTitles",
	"GetNumTrackedAchievements",
	"GetNumTrackingTypes",
	"GetNumTrainerServices",
	"GetNumTreasurePickerItems",
	"GetNumUnspentPvpTalents",
	"GetNumUnspentTalents",
	"GetNumVoidTransferDeposit",
	"GetNumVoidTransferWithdrawal",
	"GetNumWarGameTypes",
	"GetNumWorldPVPAreas",
	"GetOSLocale",
	"GetObjectIconTextureCoords",
	"GetObjectiveText",
	"GetOptOutOfLoot",
	"GetOverrideAPBySpellPower",
	"GetOverrideBarIndex",
	"GetOverrideBarSkin",
	"GetOverrideSpellPowerByAP",
	"GetPOITextureCoords",
	"GetPVPDesired",
	"GetPVPGearStatRules",
	"GetPVPLifetimeStats",
	"GetPVPRoles",
	"GetPVPSessionStats",
	"GetPVPTimer",
	"GetPVPYesterdayStats",
	"GetParryChance",
	"GetParryChanceFromAttribute",
	"GetPartyAssignment",
	"GetPartyLFGBackfillInfo",
	"GetPartyLFGID",
	"GetPendingGlyphName",
	"GetPendingInviteConfirmations",
	"GetPersonalRatedInfo",
	"GetPetActionCooldown",
	"GetPetActionInfo",
	"GetPetActionSlotUsable",
	"GetPetActionsUsable",
	"GetPetExperience",
	"GetPetFoodTypes",
	"GetPetIcon",
	"GetPetMeleeHaste",
	"GetPetSpellBonusDamage",
	"GetPetTalentTree",
	"GetPetTimeRemaining",
	"GetPetitionInfo",
	"GetPetitionNameInfo",
	"GetPhysicalScreenSize",
	"GetPlayerAuraBySpellID",
	"GetPlayerFacing",
	"GetPlayerInfoByGUID",
	"GetPlayerTradeCurrency",
	"GetPlayerTradeMoney",
	"GetPossessInfo",
	"GetPowerRegen",
	"GetPowerRegenForPowerType",
	"GetPrevCompleatedTutorial",
	"GetPreviousAchievement",
	"GetPreviousArenaSeason",
	"GetPrimarySpecialization",
	"GetProfessionInfo",
	"GetProfessions",
	"GetProgressText",
	"GetPromotionRank",
	"GetPvpPowerDamage",
	"GetPvpPowerHealing",
	"GetPvpTalentInfoByID",
	"GetPvpTalentInfoBySpecialization",
	"GetPvpTalentLink",
	"GetQuestBackgroundMaterial",
	"GetQuestCurrencyID",
	"GetQuestCurrencyInfo",
	"GetQuestExpansion",
	"GetQuestFactionGroup",
	"GetQuestID",
	"GetQuestItemInfo",
	"GetQuestItemInfoLootType",
	"GetQuestItemLink",
	"GetQuestLink",
	"GetQuestLogChoiceInfo",
	"GetQuestLogChoiceInfoLootType",
	"GetQuestLogCompletionText",
	"GetQuestLogCriteriaSpell",
	"GetQuestLogItemDrop",
	"GetQuestLogItemLink",
	"GetQuestLogLeaderBoard",
	"GetQuestLogPortraitGiver",
	"GetQuestLogPortraitTurnIn",
	"GetQuestLogQuestText",
	"GetQuestLogQuestType",
	"GetQuestLogRewardArtifactXP",
	"GetQuestLogRewardCurrencyInfo",
	"GetQuestLogRewardFactionInfo",
	"GetQuestLogRewardHonor",
	"GetQuestLogRewardInfo",
	"GetQuestLogRewardMoney",
	"GetQuestLogRewardSkillPoints",
	"GetQuestLogRewardSpell",
	"GetQuestLogRewardTitle",
	"GetQuestLogRewardXP",
	"GetQuestLogSpecialItemCooldown",
	"GetQuestLogSpecialItemInfo",
	"GetQuestLogSpellLink",
	"GetQuestLogTimeLeft",
	"GetQuestMoneyToGet",
	"GetQuestObjectiveInfo",
	"GetQuestPOIBlobCount",
	"GetQuestPOILeaderBoard",
	"GetQuestPOIs",
	"GetQuestPortraitGiver",
	"GetQuestPortraitTurnIn",
	"GetQuestProgressBarPercent",
	"GetQuestResetTime",
	"GetQuestReward",
	"GetQuestSortIndex",
	"GetQuestSpellLink",
	"GetQuestText",
	"GetQuestUiMapID",
	"GetRFDungeonInfo",
	"GetRaidDifficultyID",
	"GetRaidProfileFlattenedOptions",
	"GetRaidProfileName",
	"GetRaidProfileOption",
	"GetRaidProfileSavedPosition",
	"GetRaidRosterInfo",
	"GetRaidTargetIndex",
	"GetRandomDungeonBestChoice",
	"GetRandomScenarioBestChoice",
	"GetRandomScenarioInfo",
	"GetRangedCritChance",
	"GetRangedHaste",
	"GetRatedBattleGroundInfo",
	"GetReadyCheckStatus",
	"GetReadyCheckTimeLeft",
	"GetReagentBankCost",
	"GetRealZoneText",
	"GetRealmID",
	"GetRealmName",
	"GetRecruitingGuildInfo",
	"GetRecruitingGuildSelection",
	"GetRecruitingGuildSettings",
	"GetReleaseTimeRemaining",
	"GetRepairAllCost",
	"GetResSicknessDuration",
	"GetRestState",
	"GetRestrictedAccountData",
	"GetRewardArtifactXP",
	"GetRewardHonor",
	"GetRewardMoney",
	"GetRewardNumSkillUps",
	"GetRewardPackArtifactPower",
	"GetRewardPackCurrencies",
	"GetRewardPackItems",
	"GetRewardPackMoney",
	"GetRewardPackTitle",
	"GetRewardPackTitleName",
	"GetRewardSkillLineID",
	"GetRewardSkillPoints",
	"GetRewardSpell",
	"GetRewardText",
	"GetRewardTitle",
	"GetRewardXP",
	"GetRuneCooldown",
	"GetRuneCount",
	"GetRunningMacro",
	"GetRunningMacroButton",
	"GetSavedInstanceChatLink",
	"GetSavedInstanceEncounterInfo",
	"GetSavedInstanceInfo",
	"GetSavedWorldBossInfo",
	"GetScenariosChoiceOrder",
	"GetSchoolString",
	"GetScreenDPIScale",
	"GetScreenHeight",
	"GetScreenResolutions",
	"GetScreenWidth",
	"GetScriptCPUUsage",
	"GetSecondsUntilParentalControlsKick",
	"GetSelectedArtifactInfo",
	"GetSelectedDisplayChannel",
	"GetSelectedFaction",
	"GetSelectedWarGameType",
	"GetSendMailCOD",
	"GetSendMailItem",
	"GetSendMailItemLink",
	"GetSendMailMoney",
	"GetSendMailPrice",
	"GetServerExpansionLevel",
	"GetServerTime",
	"GetSessionTime",
	"GetSetBonusesForSpecializationByItemID",
	"GetShapeshiftForm",
	"GetShapeshiftFormCooldown",
	"GetShapeshiftFormID",
	"GetShapeshiftFormInfo",
	"GetSheathState",
	"GetShieldBlock",
	"GetSocketItemBoundTradeable",
	"GetSocketItemInfo",
	"GetSocketItemRefundable",
	"GetSocketTypes",
	"GetSortBagsRightToLeft",
	"GetSpecChangeCost",
	"GetSpecialization",
	"GetSpecializationInfo",
	"GetSpecializationInfoByID",
	"GetSpecializationInfoForClassID",
	"GetSpecializationInfoForSpecID",
	"GetSpecializationMasterySpells",
	"GetSpecializationNameForSpecID",
	"GetSpecializationRole",
	"GetSpecializationRoleByID",
	"GetSpecializationSpells",
	"GetSpecsForSpell",
	"GetSpeed",
	"GetSpellAutocast",
	"GetSpellAvailableLevel",
	"GetSpellBaseCooldown",
	"GetSpellBonusDamage",
	"GetSpellBonusHealing",
	"GetSpellBookItemInfo",
	"GetSpellBookItemName",
	"GetSpellBookItemTexture",
	"GetSpellCharges",
	"GetSpellConfirmationPromptsInfo",
	"GetSpellCooldown",
	"GetSpellCount",
	"GetSpellCritChance",
	"GetSpellDescription",
	"GetSpellHitModifier",
	"GetSpellInfo",
	"GetSpellLevelLearned",
	"GetSpellLink",
	"GetSpellLossOfControlCooldown",
	"GetSpellPenetration",
	"GetSpellPowerCost",
	"GetSpellQueueWindow",
	"GetSpellRank",
	"GetSpellSubtext",
	"GetSpellTabInfo",
	"GetSpellTexture",
	"GetSpellTradeSkillLink",
	"GetSpellsForCharacterUpgradeTier",
	"GetStablePetFoodTypes",
	"GetStablePetInfo",
	"GetStatistic",
	"GetStatisticsCategoryList",
	"GetSturdiness",
	"GetSubZoneText",
	"GetSuggestedGroupSize",
	"GetSummonFriendCooldown",
	"GetTabardCreationCost",
	"GetTabardInfo",
	"GetTalentInfo",
	"GetTalentInfoByID",
	"GetTalentInfoBySpecialization",
	"GetTalentLink",
	"GetTalentTierInfo",
	"GetTargetTradeCurrency",
	"GetTargetTradeMoney",
	"GetTaskInfo",
	"GetTaskPOIs",
	"GetTasksTable",
	"GetTaxiBenchmarkMode",
	"GetTaxiMapID",
	"GetTempShapeshiftBarIndex",
	"GetText",
	"GetThreatStatusColor",
	"GetTickTime",
	"GetTime",
	"GetTimePreciseSec",
	"GetTimeToWellRested",
	"GetTitleName",
	"GetTitleText",
	"GetToolTipInfo",
	"GetTotalAchievementPoints",
	"GetTotemCannotDismiss",
	"GetTotemInfo",
	"GetTotemTimeLeft",
	"GetTrackedAchievements",
	"GetTrackingInfo",
	"GetTradePlayerItemInfo",
	"GetTradePlayerItemLink",
	"GetTradeTargetItemInfo",
	"GetTradeTargetItemLink",
	"GetTrainerGreetingText",
	"GetTrainerSelectionIndex",
	"GetTrainerServiceAbilityReq",
	"GetTrainerServiceCost",
	"GetTrainerServiceDescription",
	"GetTrainerServiceIcon",
	"GetTrainerServiceInfo",
	"GetTrainerServiceItemLink",
	"GetTrainerServiceLevelReq",
	"GetTrainerServiceNumAbilityReq",
	"GetTrainerServiceSkillLine",
	"GetTrainerServiceSkillReq",
	"GetTrainerServiceStepIndex",
	"GetTrainerServiceTypeFilter",
	"GetTrainerTradeskillRankValues",
	"GetTreasurePickerItemInfo",
	"GetTutorialsEnabled",
	"GetUICameraInfo",
	"GetUnitChargedPowerPoints",
	"GetUnitHealthModifier",
	"GetUnitMaxHealthModifier",
	"GetUnitPowerBarInfo",
	"GetUnitPowerBarInfoByID",
	"GetUnitPowerBarStrings",
	"GetUnitPowerBarStringsByID",
	"GetUnitPowerBarTextureInfo",
	"GetUnitPowerBarTextureInfoByID",
	"GetUnitPowerModifier",
	"GetUnitSpeed",
	"GetVehicleBarIndex",
	"GetVehicleUIIndicator",
	"GetVehicleUIIndicatorSeat",
	"GetVersatilityBonus",
	"GetVideoCaps",
	"GetVideoOptions",
	"GetVoidItemHyperlinkString",
	"GetVoidItemInfo",
	"GetVoidStorageSlotPageIndex",
	"GetVoidTransferCost",
	"GetVoidTransferDepositInfo",
	"GetVoidTransferWithdrawalInfo",
	"GetVoidUnlockCost",
	"GetWarGameQueueStatus",
	"GetWarGameTypeInfo",
	"GetWatchedFactionInfo",
	"GetWeaponEnchantInfo",
	"GetWebTicket",
	"GetWorldElapsedTime",
	"GetWorldElapsedTimers",
	"GetWorldMapActionButtonSpellInfo",
	"GetWorldPVPAreaInfo",
	"GetWorldPVPQueueStatus",
	"GetXPExhaustion",
	"GetZonePVPInfo",
	"GetZoneText",
	"GiveMasterLoot",
	"GroupHasOfflineMember",
	"GuildControlAddRank",
	"GuildControlDelRank",
	"GuildControlGetAllowedShifts",
	"GuildControlGetNumRanks",
	"GuildControlGetRankName",
	"GuildControlSaveRank",
	"GuildControlSetRank",
	"GuildControlSetRankFlag",
	"GuildControlShiftRankDown",
	"GuildControlShiftRankUp",
	"GuildDemote",
	"GuildDisband",
	"GuildInfo",
	"GuildInvite",
	"GuildLeave",
	"GuildMasterAbsent",
	"GuildNewsSetSticky",
	"GuildNewsSort",
	"GuildPromote",
	"GuildRosterSetOfficerNote",
	"GuildRosterSetPublicNote",
	"GuildSetLeader",
	"GuildSetMOTD",
	"GuildUninvite",
	"HandleAtlasMemberCommand",
	"HasAPEffectsSpellPower",
	"HasAction",
	"HasAlternateForm",
	"HasArtifactEquipped",
	"HasAttachedGlyph",
	"HasBonusActionBar",
	"HasBoundGemProposed",
	"HasCompletedAnyAchievement",
	"HasDualWieldPenalty",
	"HasExtraActionBar",
	"HasFullControl",
	"HasIgnoreDualWieldWeapon",
	"HasInboxItem",
	"HasLFGRestrictions",
	"HasLoadedCUFProfiles",
	"HasNewMail",
	"HasNoReleaseAura",
	"HasOverrideActionBar",
	"HasPendingGlyphCast",
	"HasPetSpells",
	"HasPetUI",
	"HasSPEffectsAttackPower",
	"HasSendMailItem",
	"HasTempShapeshiftActionBar",
	"HasVehicleActionBar",
	"HasWandEquipped",
	"HaveQuestData",
	"HaveQuestRewardData",
	"HearthAndResurrectFromArea",
	"HideRepairCursor",
	"InCinematic",
	"InCombatLockdown",
	"InGuildParty",
	"InRepairMode",
	"InboxItemCanDelete",
	"InitiateRolePoll",
	"InitiateTrade",
	"InteractUnit",
	"Is64BitClient",
	"IsAccountSecured",
	"IsAchievementEligible",
	"IsActionInRange",
	"IsActiveBattlefieldArena",
	"IsActiveQuestLegendary",
	"IsActiveQuestTrivial",
	"IsAddOnLoadOnDemand",
	"IsAddOnLoaded",
	"IsAddonVersionCheckEnabled",
	"IsAllowedToUserTeleport",
	"IsAltKeyDown",
	"IsArenaSkirmish",
	"IsArenaTeamCaptain",
	"IsArtifactCompletionHistoryAvailable",
	"IsArtifactPowerItem",
	"IsArtifactRelicItem",
	"IsAtStableMaster",
	"IsAttackAction",
	"IsAttackSpell",
	"IsAutoRepeatAction",
	"IsAutoRepeatSpell",
	"IsAvailableQuestTrivial",
	"IsBNLogin",
	"IsBagSlotFlagEnabledOnOtherBags",
	"IsBagSlotFlagEnabledOnOtherBankBags",
	"IsBarberShopStyleValid",
	"IsBattlePayItem",
	"IsBindingForGamePad",
	"IsBreadcrumbQuest",
	"IsCastingGlyph",
	"IsCemeterySelectionAvailable",
	"IsCharacterNewlyBoosted",
	"IsChatAFK",
	"IsChatChannelRaid",
	"IsChatDND",
	"IsCompetitiveModeEnabled",
	"IsConsumableAction",
	"IsConsumableItem",
	"IsConsumableSpell",
	"IsContainerFiltered",
	"IsContainerItemAnUpgrade",
	"IsControlKeyDown",
	"IsCorruptedItem",
	"IsCosmeticItem",
	"IsCurrentAction",
	"IsCurrentItem",
	"IsCurrentQuestFailed",
	"IsCurrentSpell",
	"IsDebugBuild",
	"IsDemonHunterAvailable",
	"IsDesaturateSupported",
	"IsDisplayChannelModerator",
	"IsDisplayChannelOwner",
	"IsDressableItem",
	"IsDualWielding",
	"IsEncounterInProgress",
	"IsEncounterLimitingResurrections",
	"IsEncounterSuppressingRelease",
	"IsEquippableItem",
	"IsEquippedAction",
	"IsEquippedItem",
	"IsEquippedItemType",
	"IsEuropeanNumbers",
	"IsEveryoneAssistant",
	"IsExpansionTrial",
	"IsFactionInactive",
	"IsFalling",
	"IsFishingLoot",
	"IsFlyableArea",
	"IsFlying",
	"IsGMClient",
	"IsGUIDInGroup",
	"IsGamePadCursorControlEnabled",
	"IsGamePadFreelookEnabled",
	"IsGuildLeader",
	"IsGuildMember",
	"IsGuildRankAssignmentAllowed",
	"IsHarmfulItem",
	"IsHarmfulSpell",
	"IsHelpfulItem",
	"IsHelpfulSpell",
	"IsInActiveWorldPVP",
	"IsInArenaTeam",
	"IsInAuthenticatedRank",
	"IsInCinematicScene",
	"IsInGroup",
	"IsInGuild",
	"IsInGuildGroup",
	"IsInInstance",
	"IsInJailersTower",
	"IsInLFGDungeon",
	"IsInRaid",
	"IsInScenarioGroup",
	"IsIndoors",
	"IsInsane",
	"IsInventoryItemAnUpgrade",
	"IsInventoryItemLocked",
	"IsInventoryItemProfessionBag",
	"IsItemAction",
	"IsItemInRange",
	"IsJailersTowerLayerTimeLocked",
	"IsKeyDown",
	"IsLFGComplete",
	"IsLFGDungeonJoinable",
	"IsLeftAltKeyDown",
	"IsLeftControlKeyDown",
	"IsLeftMetaKeyDown",
	"IsLeftShiftKeyDown",
	"IsLegacyDifficulty",
	"IsLinuxClient",
	"IsLoggedIn",
	"IsMacClient",
	"IsMasterLooter",
	"IsMetaKeyDown",
	"IsModifiedClick",
	"IsModifierKeyDown",
	"IsMounted",
	"IsMouseButtonDown",
	"IsMouselooking",
	"IsMovieLocal",
	"IsMoviePlayable",
	"IsOnGlueScreen",
	"IsOnGroundFloorInJailersTower",
	"IsOnTournamentRealm",
	"IsOutOfBounds",
	"IsOutdoors",
	"IsOutlineModeSupported",
	"IsPVPTimerRunning",
	"IsPartyLFG",
	"IsPartyWorldPVP",
	"IsPassiveSpell",
	"IsPendingGlyphRemoval",
	"IsPetActive",
	"IsPetAttackAction",
	"IsPetAttackActive",
	"IsPlayerInWorld",
	"IsPlayerMoving",
	"IsPlayerNeutral",
	"IsPlayerSpell",
	"IsPossessBarVisible",
	"IsPublicBuild",
	"IsPvpTalentSpell",
	"IsQuestCompletable",
	"IsQuestIDValidSpellTarget",
	"IsQuestItemHidden",
	"IsQuestLogSpecialItemInRange",
	"IsQuestSequenced",
	"IsRaidMarkerActive",
	"IsRangedWeapon",
	"IsReagentBankUnlocked",
	"IsRecognizedName",
	"IsRecruitAFriendLinked",
	"IsReplacingUnit",
	"IsResting",
	"IsRestrictedAccount",
	"IsRightAltKeyDown",
	"IsRightControlKeyDown",
	"IsRightMetaKeyDown",
	"IsRightShiftKeyDown",
	"IsSelectedSpellBookItem",
	"IsServerControlledBackfill",
	"IsShiftKeyDown",
	"IsSpellClassOrSpec",
	"IsSpellInRange",
	"IsSpellKnown",
	"IsSpellKnownOrOverridesKnown",
	"IsSpellOverlayed",
	"IsSpellValidForPendingGlyph",
	"IsSplashFramePrimaryFeatureUnlocked",
	"IsStackableAction",
	"IsStealthed",
	"IsStoryQuest",
	"IsSubZonePVPPOI",
	"IsSubmerged",
	"IsSwimming",
	"IsTalentSpell",
	"IsTestBuild",
	"IsThreatWarningEnabled",
	"IsTitleKnown",
	"IsTrackedAchievement",
	"IsTrackingBattlePets",
	"IsTrackingHiddenQuests",
	"IsTradeskillTrainer",
	"IsTrialAccount",
	"IsTutorialFlagged",
	"IsUnitModelReadyForUI",
	"IsUsableAction",
	"IsUsableItem",
	"IsUsableSpell",
	"IsUsingFixedTimeStep",
	"IsUsingVehicleControls",
	"IsVehicleAimAngleAdjustable",
	"IsVehicleAimPowerAdjustable",
	"IsVeteranTrialAccount",
	"IsVoidStorageReady",
	"IsWargame",
	"IsWindowsClient",
	"IsXPUserDisabled",
	"ItemAddedToArtifact",
	"ItemCanTargetGarrisonFollowerAbility",
	"ItemHasRange",
	"ItemTextGetCreator",
	"ItemTextGetItem",
	"ItemTextGetMaterial",
	"ItemTextGetPage",
	"ItemTextGetText",
	"ItemTextHasNextPage",
	"ItemTextIsFullPage",
	"ItemTextNextPage",
	"ItemTextPrevPage",
	"JoinArena",
	"JoinBattlefield",
	"JoinChannelByName",
	"JoinLFG",
	"JoinPermanentChannel",
	"JoinRatedBattlefield",
	"JoinSingleLFG",
	"JoinSkirmish",
	"JoinTemporaryChannel",
	"JumpOrAscendStart",
	"KBArticle_BeginLoading",
	"KBArticle_GetData",
	"KBArticle_IsLoaded",
	"KBQuery_BeginLoading",
	"KBQuery_GetArticleHeaderCount",
	"KBQuery_GetArticleHeaderData",
	"KBQuery_GetTotalArticleCount",
	"KBQuery_IsLoaded",
	"KBSetup_BeginLoading",
	"KBSetup_GetArticleHeaderCount",
	"KBSetup_GetArticleHeaderData",
	"KBSetup_GetCategoryCount",
	"KBSetup_GetCategoryData",
	"KBSetup_GetLanguageCount",
	"KBSetup_GetLanguageData",
	"KBSetup_GetSubCategoryCount",
	"KBSetup_GetSubCategoryData",
	"KBSetup_GetTotalArticleCount",
	"KBSetup_IsLoaded",
	"KBSystem_GetMOTD",
	"KBSystem_GetServerNotice",
	"KBSystem_GetServerStatus",
	"LFGTeleport",
	"LearnPvpTalent",
	"LearnPvpTalents",
	"LearnTalent",
	"LearnTalents",
	"LeaveBattlefield",
	"LeaveChannelByLocalID",
	"LeaveChannelByName",
	"LeaveLFG",
	"LeaveSingleLFG",
	"ListChannelByName",
	"ListChannels",
	"LoadAddOn",
	"LoadBindings",
	"LoadURLIndex",
	"LoggingChat",
	"LoggingCombat",
	"Logout",
	"LootMoneyNotify",
	"LootSlot",
	"LootSlotHasItem",
	"MouseOverrideCinematicDisable",
	"MouselookStart",
	"MouselookStop",
	"MoveAndSteerStart",
	"MoveAndSteerStop",
	"MoveBackwardStart",
	"MoveBackwardStop",
	"MoveForwardStart",
	"MoveForwardStop",
	"MoveViewDownStart",
	"MoveViewDownStop",
	"MoveViewInStart",
	"MoveViewInStop",
	"MoveViewLeftStart",
	"MoveViewLeftStop",
	"MoveViewOutStart",
	"MoveViewOutStop",
	"MoveViewRightStart",
	"MoveViewRightStop",
	"MoveViewUpStart",
	"MoveViewUpStop",
	"MultiSampleAntiAliasingSupported",
	"MuteSoundFile",
	"NeutralPlayerSelectFaction",
	"NextView",
	"NoPlayTime",
	"NotWhileDeadError",
	"NotifyInspect",
	"NumTaxiNodes",
	"OfferPetition",
	"OpenTrainer",
	"OpeningCinematic",
	"PartialPlayTime",
	"PartyLFGStartBackfill",
	"PetAbandon",
	"PetAggressiveMode",
	"PetAssistMode",
	"PetAttack",
	"PetCanBeAbandoned",
	"PetCanBeDismissed",
	"PetCanBeRenamed",
	"PetDefensiveAssistMode",
	"PetDefensiveMode",
	"PetDismiss",
	"PetFollow",
	"PetHasActionBar",
	"PetHasSpellbook",
	"PetMoveTo",
	"PetPassiveMode",
	"PetRename",
	"PetStopAttack",
	"PetUsesPetFrame",
	"PetWait",
	"PickupAction",
	"PickupBagFromSlot",
	"PickupCompanion",
	"PickupContainerItem",
	"PickupGuildBankItem",
	"PickupGuildBankMoney",
	"PickupInventoryItem",
	"PickupItem",
	"PickupMacro",
	"PickupMerchantItem",
	"PickupPetAction",
	"PickupPetSpell",
	"PickupPlayerMoney",
	"PickupPvpTalent",
	"PickupSpell",
	"PickupSpellBookItem",
	"PickupStablePet",
	"PickupTalent",
	"PickupTradeMoney",
	"PitchDownStart",
	"PitchDownStop",
	"PitchUpStart",
	"PitchUpStop",
	"PlaceAction",
	"PlaceRaidMarker",
	"PlayAutoAcceptQuestSound",
	"PlayMusic",
	"PlaySound",
	"PlaySoundFile",
	"PlayVocalErrorSoundID",
	"PlayerCanTeleport",
	"PlayerEffectiveAttackPower",
	"PlayerHasHearthstone",
	"PlayerHasToy",
	"PlayerIsPVPInactive",
	"PlayerVehicleHasComboPoints",
	"PortGraveyard",
	"PreloadMovie",
	"PrevView",
	"ProcessExceptionClient",
	"ProcessQuestLogRewardFactions",
	"PromoteToAssistant",
	"PromoteToLeader",
	"PurchaseSlot",
	"PutItemInBackpack",
	"PutItemInBag",
	"QueryGuildBankLog",
	"QueryGuildBankTab",
	"QueryGuildBankText",
	"QueryGuildEventLog",
	"QueryGuildMembersForRecipe",
	"QueryGuildNews",
	"QueryGuildRecipes",
	"QuestChooseRewardError",
	"QuestFlagsPVP",
	"QuestGetAutoAccept",
	"QuestGetAutoLaunched",
	"QuestHasPOIInfo",
	"QuestIsDaily",
	"QuestIsFromAdventureMap",
	"QuestIsFromAreaTrigger",
	"QuestIsWeekly",
	"QuestLogPushQuest",
	"QuestLogRewardHasTreasurePicker",
	"QuestLogShouldShowPortrait",
	"QuestMapUpdateAllQuests",
	"QuestPOIGetIconInfo",
	"QuestPOIGetSecondaryLocations",
	"QuestPOIUpdateIcons",
	"Quit",
	"RaidProfileExists",
	"RaidProfileHasUnsavedChanges",
	"RandomRoll",
	"ReagentBankButtonIDToInvSlotID",
	"RedockChatWindows",
	"RefreshLFGList",
	"RegisterStaticConstants",
	"RejectProposal",
	"RemoveAutoQuestPopUp",
	"RemoveChatWindowChannel",
	"RemoveChatWindowMessages",
	"RemoveItemFromArtifact",
	"RemovePvpTalent",
	"RemoveTalent",
	"RemoveTrackedAchievement",
	"RenamePetition",
	"ReopenInteraction",
	"RepairAllItems",
	"ReplaceEnchant",
	"ReplaceGuildMaster",
	"ReplaceTradeEnchant",
	"RepopMe",
	"ReportBug",
	"ReportPlayerIsPVPAFK",
	"ReportSuggestion",
	"RequestArtifactCompletionHistory",
	"RequestBattlefieldScoreData",
	"RequestBattlegroundInstanceInfo",
	"RequestBottomLeftActionBar",
	"RequestGuildApplicantsList",
	"RequestGuildChallengeInfo",
	"RequestGuildMembership",
	"RequestGuildMembershipList",
	"RequestGuildPartyState",
	"RequestGuildRecruitmentSettings",
	"RequestGuildRewards",
	"RequestLFDPartyLockInfo",
	"RequestLFDPlayerLockInfo",
	"RequestPVPOptionsEnabled",
	"RequestPVPRewards",
	"RequestRaidInfo",
	"RequestRandomBattlegroundInstanceInfo",
	"RequestRatedInfo",
	"RequestRecruitingGuildsList",
	"RequestTimePlayed",
	"RequeueSkirmish",
	"ResetAddOns",
	"ResetCPUUsage",
	"ResetChatColors",
	"ResetChatWindows",
	"ResetCursor",
	"ResetDisabledAddOns",
	"ResetInstances",
	"ResetSetMerchantFilter",
	"ResetTutorials",
	"ResetView",
	"ResistancePercent",
	"RespondInstanceLock",
	"RespondMailLockSendItem",
	"RespondToInviteConfirmation",
	"RestartGx",
	"RestoreRaidProfileFromCopy",
	"ResurrectGetOfferer",
	"ResurrectHasSickness",
	"ResurrectHasTimer",
	"RetrieveCorpse",
	"ReturnInboxItem",
	"RollOnLoot",
	"RunBinding",
	"RunMacro",
	"RunMacroText",
	"RunScript",
	"SaveAddOns",
	"SaveBindings",
	"SaveRaidProfileCopy",
	"SaveView",
	"Screenshot",
	"ScriptsDisallowedForBeta",
	"SearchLFGGetEncounterResults",
	"SearchLFGGetJoinedID",
	"SearchLFGGetNumResults",
	"SearchLFGGetPartyResults",
	"SearchLFGGetResults",
	"SearchLFGJoin",
	"SearchLFGLeave",
	"SearchLFGSort",
	"SecureCmdOptionParse",
	"SelectActiveQuest",
	"SelectAvailableQuest",
	"SelectTrainerService",
	"SelectedRealmName",
	"SellCursorItem",
	"SendChatMessage",
	"SendMail",
	"SendPlayerChoiceResponse",
	"SendSubscriptionInterstitialResponse",
	"SendSystemMessage",
	"SetAchievementComparisonUnit",
	"SetAchievementSearchString",
	"SetActionBarToggles",
	"SetActionUIButton",
	"SetAddonVersionCheck",
	"SetAllowDangerousScripts",
	"SetAllowLowLevelRaid",
	"SetAutoDeclineGuildInvites",
	"SetBackpackAutosortDisabled",
	"SetBagPortraitTexture",
	"SetBagSlotFlag",
	"SetBankAutosortDisabled",
	"SetBankBagSlotFlag",
	"SetBarSlotFromIntro",
	"SetBarberShopAlternateFormFrame",
	"SetBattlefieldScoreFaction",
	"SetBinding",
	"SetBindingClick",
	"SetBindingItem",
	"SetBindingMacro",
	"SetBindingSpell",
	"SetCemeteryPreference",
	"SetChannelOwner",
	"SetChannelPassword",
	"SetChatColorNameByClass",
	"SetChatWindowAlpha",
	"SetChatWindowColor",
	"SetChatWindowDocked",
	"SetChatWindowLocked",
	"SetChatWindowName",
	"SetChatWindowSavedDimensions",
	"SetChatWindowSavedPosition",
	"SetChatWindowShown",
	"SetChatWindowSize",
	"SetChatWindowUninteractable",
	"SetConsoleKey",
	"SetCurrentGraphicsSetting",
	"SetCurrentGuildBankTab",
	"SetCurrentTitle",
	"SetCursor",
	"SetCursorVirtualItem",
	"SetDefaultVideoOptions",
	"SetDungeonDifficultyID",
	"SetEuropeanNumbers",
	"SetEveryoneIsAssistant",
	"SetFactionActive",
	"SetFactionInactive",
	"SetFocusedAchievement",
	"SetGamePadCursorControl",
	"SetGamePadFreeLook",
	"SetGuildApplicantSelection",
	"SetGuildBankTabInfo",
	"SetGuildBankTabItemWithdraw",
	"SetGuildBankTabPermissions",
	"SetGuildBankText",
	"SetGuildBankWithdrawGoldLimit",
	"SetGuildInfoText",
	"SetGuildMemberRank",
	"SetGuildNewsFilter",
	"SetGuildRecruitmentComment",
	"SetGuildRecruitmentSettings",
	"SetGuildRosterSelection",
	"SetGuildRosterShowOffline",
	"SetGuildTradeSkillCategoryFilter",
	"SetGuildTradeSkillItemNameFilter",
	"SetInWorldUIVisibility",
	"SetInsertItemsLeftToRight",
	"SetInventoryPortraitTexture",
	"SetItemSearch",
	"SetItemUpgradeFromCursorItem",
	"SetLFGBootVote",
	"SetLFGComment",
	"SetLFGDungeon",
	"SetLFGDungeonEnabled",
	"SetLFGHeaderCollapsed",
	"SetLFGRoles",
	"SetLegacyRaidDifficultyID",
	"SetLookingForGuildComment",
	"SetLookingForGuildSettings",
	"SetLootMethod",
	"SetLootPortrait",
	"SetLootSpecialization",
	"SetLootThreshold",
	"SetMacroItem",
	"SetMacroSpell",
	"SetMerchantFilter",
	"SetModifiedClick",
	"SetMouselookOverrideBinding",
	"SetMoveEnabled",
	"SetMultiCastSpell",
	"SetNextBarberShopStyle",
	"SetOptOutOfLoot",
	"SetOverrideBinding",
	"SetOverrideBindingClick",
	"SetOverrideBindingItem",
	"SetOverrideBindingMacro",
	"SetOverrideBindingSpell",
	"SetPOIIconOverlapDistance",
	"SetPOIIconOverlapPushDistance",
	"SetPVP",
	"SetPVPRoles",
	"SetPartyAssignment",
	"SetPetSlot",
	"SetPetStablePaperdoll",
	"SetPortraitTexture",
	"SetPortraitTextureFromCreatureDisplayID",
	"SetPortraitToTexture",
	"SetRaidDifficultyID",
	"SetRaidProfileOption",
	"SetRaidProfileSavedPosition",
	"SetRaidSubgroup",
	"SetRaidTarget",
	"SetRaidTargetProtected",
	"SetRecruitingGuildSelection",
	"SetSavedInstanceExtend",
	"SetScreenResolution",
	"SetSelectedArtifact",
	"SetSelectedDisplayChannel",
	"SetSelectedFaction",
	"SetSelectedScreenResolutionIndex",
	"SetSelectedWarGameType",
	"SetSendMailCOD",
	"SetSendMailMoney",
	"SetSendMailShowing",
	"SetSortBagsRightToLeft",
	"SetSpecialization",
	"SetSpellbookPetAction",
	"SetTaxiBenchmarkMode",
	"SetTaxiMap",
	"SetTracking",
	"SetTradeCurrency",
	"SetTradeMoney",
	"SetTrainerServiceTypeFilter",
	"SetTurnEnabled",
	"SetUIVisibility",
	"SetView",
	"SetWatchedFactionIndex",
	"SetupFullscreenScale",
	"ShouldShowIslandsWeeklyPOI",
	"ShouldShowSpecialSplashScreen",
	"ShowAccountAchievements",
	"ShowBossFrameWhenUninteractable",
	"ShowBuybackSellCursor",
	"ShowContainerSellCursor",
	"ShowInventorySellCursor",
	"ShowQuestComplete",
	"ShowQuestOffer",
	"ShowRepairCursor",
	"SignPetition",
	"SitStandOrDescendStart",
	"SocketContainerItem",
	"SocketInventoryItem",
	"SocketItemToArtifact",
	"SolveArtifact",
	"SortBGList",
	"SortBags",
	"SortBankBags",
	"SortBattlefieldScoreData",
	"SortGuildRoster",
	"SortGuildTradeSkill",
	"SortQuestSortTypes",
	"SortQuests",
	"SortReagentBankBags",
	"Sound_ChatSystem_GetInputDriverNameByIndex",
	"Sound_ChatSystem_GetNumInputDrivers",
	"Sound_ChatSystem_GetNumOutputDrivers",
	"Sound_ChatSystem_GetOutputDriverNameByIndex",
	"Sound_GameSystem_GetInputDriverNameByIndex",
	"Sound_GameSystem_GetNumInputDrivers",
	"Sound_GameSystem_GetNumOutputDrivers",
	"Sound_GameSystem_GetOutputDriverNameByIndex",
	"Sound_GameSystem_RestartSoundSystem",
	"SpellCanTargetGarrisonFollower",
	"SpellCanTargetGarrisonFollowerAbility",
	"SpellCanTargetGarrisonMission",
	"SpellCanTargetItem",
	"SpellCanTargetItemID",
	"SpellCanTargetQuest",
	"SpellCanTargetUnit",
	"SpellCancelQueuedSpell",
	"SpellGetVisibilityInfo",
	"SpellHasRange",
	"SpellIsAlwaysShown",
	"SpellIsSelfBuff",
	"SpellIsTargeting",
	"SpellStopCasting",
	"SpellStopTargeting",
	"SpellTargetItem",
	"SpellTargetUnit",
	"SplashFrameCanBeShown",
	"SplitContainerItem",
	"SplitGuildBankItem",
	"StartAttack",
	"StartAutoRun",
	"StartDuel",
	"StartSpectatorWarGame",
	"StartWarGame",
	"StartWarGameByName",
	"StopAttack",
	"StopAutoRun",
	"StopCinematic",
	"StopMacro",
	"StopMusic",
	"StopSound",
	"StoreSecureReference",
	"StrafeLeftStart",
	"StrafeLeftStop",
	"StrafeRightStart",
	"StrafeRightStop",
	"Stuck",
	"SubmitRequiredGuildRename",
	"SummonFriend",
	"SummonRandomCritter",
	"SupportsClipCursor",
	"SurrenderArena",
	"SwapRaidSubgroup",
	"SwitchAchievementSearchTab",
	"TakeInboxItem",
	"TakeInboxMoney",
	"TakeInboxTextItem",
	"TakeTaxiNode",
	"TargetDirectionEnemy",
	"TargetDirectionFinished",
	"TargetDirectionFriend",
	"TargetLastEnemy",
	"TargetLastFriend",
	"TargetLastTarget",
	"TargetNearest",
	"TargetNearestEnemy",
	"TargetNearestEnemyPlayer",
	"TargetNearestFriend",
	"TargetNearestFriendPlayer",
	"TargetNearestPartyMember",
	"TargetNearestRaidMember",
	"TargetPriorityHighlightEnd",
	"TargetPriorityHighlightStart",
	"TargetSpellReplacesBonusTree",
	"TargetTotem",
	"TargetUnit",
	"TaxiGetDestX",
	"TaxiGetDestY",
	"TaxiGetNodeSlot",
	"TaxiGetSrcX",
	"TaxiGetSrcY",
	"TaxiIsDirectFlight",
	"TaxiNodeCost",
	"TaxiNodeGetType",
	"TaxiNodeName",
	"TaxiNodePosition",
	"TaxiRequestEarlyLanding",
	"TimeoutResurrect",
	"ToggleAnimKitDisplay",
	"ToggleAutoRun",
	"ToggleDebugAIDisplay",
	"TogglePVP",
	"TogglePetAutocast",
	"ToggleRun",
	"ToggleSelfHighlight",
	"ToggleSheath",
	"ToggleSpellAutocast",
	"ToggleWindowed",
	"TriggerTutorial",
	"TurnInGuildCharter",
	"TurnLeftStart",
	"TurnLeftStop",
	"TurnOrActionStart",
	"TurnOrActionStop",
	"TurnRightStart",
	"TurnRightStop",
	"UninviteUnit",
	"UnitAffectingCombat",
	"UnitAlliedRaceInfo",
	"UnitArmor",
	"UnitAttackPower",
	"UnitAttackSpeed",
	"UnitAura",
	"UnitAuraBySlot",
	"UnitAuraSlots",
	"UnitBattlePetLevel",
	"UnitBattlePetSpeciesID",
	"UnitBattlePetType",
	"UnitBuff",
	"UnitCanAssist",
	"UnitCanAttack",
	"UnitCanCooperate",
	"UnitCanPetBattle",
	"UnitCastingInfo",
	"UnitChannelInfo",
	"UnitChromieTimeID",
	"UnitClass",
	"UnitClassBase",
	"UnitClassification",
	"UnitControllingVehicle",
	"UnitCreatureFamily",
	"UnitCreatureType",
	"UnitDamage",
	"UnitDebuff",
	"UnitDetailedThreatSituation",
	"UnitDistanceSquared",
	"UnitEffectiveLevel",
	"UnitExists",
	"UnitFactionGroup",
	"UnitFullName",
	"UnitGUID",
	"UnitGetAvailableRoles",
	"UnitGetIncomingHeals",
	"UnitGetTotalAbsorbs",
	"UnitGetTotalHealAbsorbs",
	"UnitGroupRolesAssigned",
	"UnitHPPerStamina",
	"UnitHasIncomingResurrection",
	"UnitHasLFGDeserter",
	"UnitHasLFGRandomCooldown",
	"UnitHasRelicSlot",
	"UnitHasVehiclePlayerFrameUI",
	"UnitHasVehicleUI",
	"UnitHealth",
	"UnitHealthMax",
	"UnitHonor",
	"UnitHonorLevel",
	"UnitHonorMax",
	"UnitInAnyGroup",
	"UnitInBattleground",
	"UnitInOtherParty",
	"UnitInParty",
	"UnitInPartyShard",
	"UnitInRaid",
	"UnitInRange",
	"UnitInSubgroup",
	"UnitInVehicle",
	"UnitInVehicleControlSeat",
	"UnitInVehicleHidesPetFrame",
	"UnitIsAFK",
	"UnitIsBattlePet",
	"UnitIsBattlePetCompanion",
	"UnitIsCharmed",
	"UnitIsConnected",
	"UnitIsControlling",
	"UnitIsCorpse",
	"UnitIsDND",
	"UnitIsDead",
	"UnitIsDeadOrGhost",
	"UnitIsEnemy",
	"UnitIsFeignDeath",
	"UnitIsFriend",
	"UnitIsGhost",
	"UnitIsGroupAssistant",
	"UnitIsGroupLeader",
	"UnitIsInMyGuild",
	"UnitIsMercenary",
	"UnitIsOtherPlayersBattlePet",
	"UnitIsOtherPlayersPet",
	"UnitIsOwnerOrControllerOfUnit",
	"UnitIsPVP",
	"UnitIsPVPFreeForAll",
	"UnitIsPVPSanctuary",
	"UnitIsPlayer",
	"UnitIsPossessed",
	"UnitIsQuestBoss",
	"UnitIsRaidOfficer",
	"UnitIsSameServer",
	"UnitIsTapDenied",
	"UnitIsTrivial",
	"UnitIsUnconscious",
	"UnitIsUnit",
	"UnitIsVisible",
	"UnitIsWildBattlePet",
	"UnitLeadsAnyGroup",
	"UnitLevel",
	"UnitName",
	"UnitNameUnmodified",
	"UnitNameplateShowsWidgetsOnly",
	"UnitNumPowerBarTimers",
	"UnitOnTaxi",
	"UnitPVPName",
	"UnitPhaseReason",
	"UnitPlayerControlled",
	"UnitPlayerOrPetInParty",
	"UnitPlayerOrPetInRaid",
	"UnitPosition",
	"UnitPower",
	"UnitPowerBarID",
	"UnitPowerBarTimerInfo",
	"UnitPowerDisplayMod",
	"UnitPowerMax",
	"UnitPowerType",
	"UnitPvpClassification",
	"UnitQuestTrivialLevelRange",
	"UnitQuestTrivialLevelRangeScaling",
	"UnitRace",
	"UnitRangedAttackPower",
	"UnitRangedDamage",
	"UnitReaction",
	"UnitRealmRelationship",
	"UnitSelectionColor",
	"UnitSelectionType",
	"UnitSetRole",
	"UnitSex",
	"UnitShouldDisplayName",
	"UnitSpellHaste",
	"UnitStagger",
	"UnitStat",
	"UnitSwitchToVehicleSeat",
	"UnitTargetsVehicleInRaidUI",
	"UnitThreatPercentageOfLead",
	"UnitThreatSituation",
	"UnitTreatAsPlayerForDisplay",
	"UnitTrialBankedLevels",
	"UnitTrialXP",
	"UnitUsingVehicle",
	"UnitVehicleSeatCount",
	"UnitVehicleSeatInfo",
	"UnitVehicleSkin",
	"UnitWeaponAttackPower",
	"UnitWidgetSet",
	"UnitXP",
	"UnitXPMax",
	"UnlearnSpecialization",
	"UnlockVoidStorage",
	"UnmuteSoundFile",
	"UpdateAddOnCPUUsage",
	"UpdateAddOnMemoryUsage",
	"UpdateInventoryAlertStatus",
	"UpdateWarGamesList",
	"UpdateWindow",
	"UpgradeItem",
	"UseAction",
	"UseContainerItem",
	"UseHearthstone",
	"UseInventoryItem",
	"UseItemByName",
	"UseQuestLogSpecialItem",
	"UseToy",
	"UseToyByName",
	"UseWorldMapActionButtonSpellOnQuest",
	"VehicleAimDecrement",
	"VehicleAimDownStart",
	"VehicleAimDownStop",
	"VehicleAimGetAngle",
	"VehicleAimGetNormAngle",
	"VehicleAimGetNormPower",
	"VehicleAimIncrement",
	"VehicleAimRequestAngle",
	"VehicleAimRequestNormAngle",
	"VehicleAimSetNormPower",
	"VehicleAimUpStart",
	"VehicleAimUpStop",
	"VehicleExit",
	"VehicleNextSeat",
	"VehiclePrevSeat",
	"ViewGuildRecipes",
	"WarGameRespond",
	"WithdrawGuildBankMoney",
	"addframetext",
	"debuglocals",
	"debugprofilestart",
	"debugprofilestop",
	"debugstack",
	"forceinsecure",
	"geterrorhandler",
	"hooksecurefunc",
	"issecure",
	"issecurevariable",
	"scrub",
	"securecall",
	"seterrorhandler",
}

for x = 1, #temp do
	ColorTable[temp[x]] = WoWFuncColor
end
temp = nil

-- ****************************************************************************
-- * WoW Protected Functions                                                  *
-- ****************************************************************************

local temp = {
	"AcceptBattlefieldPort",
	"AcceptProposal",
	"AcceptTrade",
	"AssistUnit",
	"AttackTarget",
	"C_AuctionHouse.PostCommodity",
	"C_AuctionHouse.PostItem",
	"C_AuctionHouse.SearchForFavorites",
	"C_AuctionHouse.SendSearchQuery",
	"C_AuctionHouse.StartCommoditiesPurchase",
	"C_BlackMarket.ItemPlaceBid",
	"C_Calendar.AddEvent",
	"C_Calendar.UpdateEvent",
	"C_Club.CreateTicket",
	"C_Club.SendCharacterInvitation",
	"C_Club.SendInvitation",
	"C_Club.SendMessage",
	"C_CovenantSanctumUI.DepositAnima",
	"C_EquipmentSet.UseEquipmentSet",
	"C_FriendList.SendWho",
	"C_LFGList.ApplyToGroup",
	"C_LFGList.ClearSearchResults",
	"C_LFGList.CreateListing",
	"C_LFGList.RemoveListing",
	"C_LFGList.Search",
	"C_PetBattles.SkipTurn",
	"C_PetBattles.UseAbility",
	"C_PetBattles.UseTrap",
	"C_PetJournal.PickupPet",
	"C_PetJournal.SummonPetByGUID",
	"C_ReportSystem.InitiateReportPlayer",
	"C_ReportSystem.SendReportPlayer",
	"C_Social.TwitterCheckStatus",
	"C_Social.TwitterConnect",
	"C_Social.TwitterDisconnect",
	"C_UI.Reload",
	"CameraOrSelectOrMoveStart",
	"CameraOrSelectOrMoveStop",
	"CancelItemTempEnchantment",
	"CancelLogout",
	"CancelShapeshiftForm",
	"CancelUnitBuff",
	"CastPetAction",
	"CastShapeshiftForm",
	"CastSpell",
	"CastSpellByName",
	"ChangeActionBarPage",
	"ClearOverrideBindings",
	"ClearTarget",
	"CreateMacro",
	"DeleteCursorItem",
	"DeleteMacro",
	"DescendStop",
	"DestroyTotem",
	"FocusUnit",
	"ForceQuit",
	"GetUnscaledFrameRect",
	"GuildControlSetRank",
	"GuildControlSetRankFlag",
	"GuildDemote",
	"GuildPromote",
	"GuildUninvite",
	"JoinBattlefield",
	"JumpOrAscendStart",
	"Logout",
	"MoveBackwardStart",
	"MoveBackwardStop",
	"MoveForwardStart",
	"MoveForwardStop",
	"PetAssistMode",
	"PetAttack",
	"PetDefensiveAssistMode",
	"PetDefensiveMode",
	"PetFollow",
	"PetPassiveMode",
	"PetStopAttack",
	"PetWait",
	"PickupAction",
	"PickupCompanion",
	"PickupMacro",
	"PickupPetAction",
	"PickupSpell",
	"PickupSpellBookItem",
	"Quit",
--	"Region GetBottom",
--	"Region GetCenter",
--	"Region GetPoint",
--	"Region GetRect",
--	"Region Hide",
--	"Region SetPoint",
--	"Region Show",
	"RegisterForSave",
	"ReplaceEnchant",
	"ReplaceTradeEnchant",
	"RunMacro",
	"RunMacroText",
	"SendChatMessage",
	"SetBinding",
	"SetBindingClick",
	"SetBindingItem",
	"SetBindingMacro",
	"SetBindingSpell",
	"SetCurrentTitle",
	"SetMoveEnabled",
	"SetOverrideBinding",
	"SetOverrideBindingClick",
	"SetOverrideBindingItem",
	"SetOverrideBindingMacro",
	"SetOverrideBindingSpell",
	"SetTurnEnabled",
	"ShowUIPanel",
	"SitStandOrDescendStart",
	"SpellStopCasting",
	"SpellStopTargeting",
	"SpellTargetUnit",
	"StrafeLeftStart",
	"StrafeLeftStop",
	"StrafeRightStart",
	"StrafeRightStop",
	"Stuck",
	"SwapRaidSubgroup",
	"TargetLastEnemy",
	"TargetLastTarget",
	"TargetNearestEnemy",
	"TargetNearestFriend",
	"TargetUnit",
	"ToggleAutoRun",
	"ToggleRun",
	"TurnLeftStart",
	"TurnLeftStop",
	"TurnOrActionStart",
	"TurnOrActionStop",
	"TurnRightStart",
	"TurnRightStop",
	"UIObject SetForbidden",
	"UninviteUnit",
	"UseAction",
	"UseContainerItem",
	"UseItemByName",
	"UseToy",
	"UseToyByName",
}
for x = 1, #temp do
	ColorTable[temp[x]] = protectedFuncColor
end
temp = nil


-- ****************************************************************************
-- * WoW Methods                                                              *
-- ****************************************************************************

local temp = {
	"AddDoubleLine",
	"AddFontStrings",
	"AddHistoryLine",
	"AddLine",
	"AddMessage",
	"AddTexture",
	"AdvanceTime",
	"AllowAttributeChanges",
	"AppendText",
	"AtBottom",
	"AtTop",
	"CanChangeAttribute",
	"CanChangeProtectedState",
	"CanNonSpaceWrap",
	"CanSaveTabardNow",
	"CanWordWrap",
	"Clear",
	"ClearAllPoints",
	"ClearFocus",
	"ClearFog",
	"ClearHistory",
	"ClearLines",
	"ClearModel",
	"Click",
	"CopyFontObject",
	"CreateAnimation",
	"CreateAnimationGroup",
	"CreateControlPoint",
	"CreateFontString",
	"CreateTexture",
	"CreateTitleRegion",
	"CycleVariation",
	"Disable",
	"DisableDrawLayer",
	"DrawQuestBlob",
	"Dress",
	"Enable",
	"EnableDrawLayer",
	"EnableJoystick",
	"EnableKeyboard",
	"EnableMerging",
	"EnableMouse",
	"EnableMouseWheel",
	"EnableSmoothing",
	"EnableSubtitles",
	"FadeOut",
	"Finish",
	"GetAlpha",
	"GetAltArrowKeyMode",
	"GetAnchorType",
	"GetAnimationGroups",
	"GetAnimations",
	"GetAttribute",
	"GetBackdrop",
	"GetBackdropBorderColor",
	"GetBackdropColor",
	"GetBlendMode",
	"GetBlinkSpeed",
	"GetBottom",
	"GetBoundsRect",
	"GetButtonState",
	"GetCenter",
	"GetChange",
	"GetChecked",
	"GetCheckedTexture",
	"GetChildren",
	"GetClampRectInsets",
	"GetColorHSV",
	"GetColorRGB",
	"GetColorValueTexture",
	"GetColorValueThumbTexture",
	"GetColorWheelTexture",
	"GetColorWheelThumbTexture",
	"GetControlPoints",
	"GetCurrentLine",
	"GetCurrentScroll",
	"GetCursorPosition",
	"GetCurve",
	"GetDegrees",
	"GetDepth",
	"GetDisabledCheckedTexture",
	"GetDisabledFontObject",
	"GetDisabledTexture",
	"GetDontSavePosition",
	"GetDrawEdge",
	"GetDrawLayer",
	"GetDuration",
	"GetEffectiveAlpha",
	"GetEffectiveDepth",
	"GetEffectiveScale",
	"GetElapsed",
	"GetEndDelay",
	"GetFacing",
	"GetFadeDuration",
	"GetFading",
	"GetFieldSize",
	"GetFogColor",
	"GetFogFar",
	"GetFogNear",
	"GetFont",
	"GetFontObject",
	"GetFontString",
	"GetFrameLevel",
	"GetFrameStrata",
	"GetHeight",
	"GetHighlightFontObject",
	"GetHighlightTexture",
	"GetHistoryLines",
	"GetHitRectInsets",
	"GetHorizTile",
	"GetHorizontalScroll",
	"GetHorizontalScrollRange",
	"GetHyperlinkFormat",
	"GetHyperlinksEnabled",
	"GetID",
	"GetIndentedWordWrap",
	"GetInitialOffset",
	"GetInputLanguage",
	"GetInsertMode",
	"GetItem",
	"GetJustifyH",
	"GetJustifyV",
	"GetLeft",
	"GetLight",
	"GetLoopState",
	"GetLooping",
	"GetLowerBackgroundFileName",
	"GetLowerEmblemFileName",
	"GetLowerEmblemTexture",
	"GetMaxBytes",
	"GetMaxFramerate",
	"GetMaxLetters",
	"GetMaxLines",
	"GetMaxOrder",
	"GetMaxResize",
	"GetMessageInfo",
	"GetMinMaxValues",
	"GetMinResize",
	"GetMinimumWidth",
	"GetModel",
	"GetModelScale",
	"GetMotionScriptsWhileDisabled",
	"GetName",
	"GetNonBlocking",
	"GetNormalFontObject",
	"GetNormalTexture",
	"GetNumChildren",
	"GetNumLetters",
	"GetNumLinesDisplayed",
	"GetNumMessages",
	"GetNumPoints",
	"GetNumRegions",
	"GetNumTooltips",
	"GetNumber",
	"GetObjectType",
	"GetOffset",
	"GetOrder",
	"GetOrientation",
	"GetOrigin",
	"GetOwner",
	"GetPadding",
	"GetParent",
	"GetPingPosition",
	"GetPoint",
	"GetPosition",
	"GetProgress",
	"GetProgressWithDelay",
	"GetPushedTextOffset",
	"GetPushedTexture",
	"GetRadians",
	"GetRect",
	"GetRegionParent",
	"GetRegions",
	"GetReverse",
	"GetRight",
	"GetRotatesTexture",
	"GetScale",
	"GetScript",
	"GetScrollChild",
	"GetShadowColor",
	"GetShadowOffset",
	"GetSize",
	"GetSmoothProgress",
	"GetSmoothing",
	"GetSpacing",
	"GetSpell",
	"GetStartDelay",
	"GetStatusBarColor",
	"GetStatusBarTexture",
	"GetStringHeight",
	"GetStringWidth",
	"GetTexCoord",
	"GetText",
	"GetTextColor",
	"GetTextHeight",
	"GetTextInsets",
	"GetTextWidth",
	"GetTexture",
	"GetThumbTexture",
	"GetTimeVisible",
	"GetTitleRegion",
	"GetTooltipIndex",
	"GetTop",
	"GetUTF8CursorPosition",
	"GetUnit",
	"GetUpperBackgroundFileName",
	"GetUpperEmblemFileName",
	"GetUpperEmblemTexture",
	"GetValue",
	"GetValueStep",
	"GetVertTile",
	"GetVertexColor",
	"GetVerticalScroll",
	"GetVerticalScrollRange",
	"GetWidth",
	"GetZoom",
	"GetZoomLevels",
	"HasFocus",
	"HasScript",
	"Hide",
	"HighlightText",
	"HookScript",
	"IgnoreDepth",
	"InitializeTabardColors",
	"Insert",
	"IsAutoFocus",
	"IsClampedToScreen",
	"IsCountInvisibleLetters",
	"IsDelaying",
	"IsDesaturated",
	"IsDone",
	"IsDragging",
	"IsEnabled",
	"IsEquippedItem",
	"IsEventRegistered",
	"IsIgnoringDepth",
	"IsInIMECompositionMode",
	"IsJoystickEnabled",
	"IsKeyboardEnabled",
	"IsMouseEnabled",
	"IsMouseOver",
	"IsMouseWheelEnabled",
	"IsMovable",
	"IsMultiLine",
	"IsNumeric",
	"IsObjectType",
	"IsOwned",
	"IsPassword",
	"IsPaused",
	"IsPendingFinish",
	"IsPlaying",
	"IsProtected",
	"IsResizable",
	"IsShown",
	"IsStopped",
	"IsToplevel",
	"IsUnit",
	"IsUserPlaced",
	"IsVisible",
	"LockHighlight",
	"Lower",
	"NumLines",
	"PageDown",
	"PageUp",
	"Pause",
	"PingLocation",
	"Play",
	"Raise",
	"RefreshUnit",
	"RegisterAllEvents",
	"RegisterEvent",
	"RegisterForClicks",
	"RegisterForDrag",
	"RemoveMessagesByAccessID",
	"ReplaceIconTexture",
	"Save",
	"ScrollDown",
	"ScrollToBottom",
	"ScrollToTop",
	"ScrollUp",
	"SetAction",
	"SetAllPoints",
	"SetAlpha",
	"SetAlphaGradient",
	"SetAltArrowKeyMode",
	"SetAnchorType",
	"SetAttribute",
	"SetAuctionItem",
	"SetAuctionSellItem",
	"SetAutoFocus",
	"SetBackdrop",
	"SetBackdropBorderColor",
	"SetBackdropColor",
	"SetBackpackToken",
	"SetBagItem",
	"SetBlendMode",
	"SetBlinkSpeed",
	"SetBlipTexture",
	"SetBorderAlpha",
	"SetBorderScalar",
	"SetBorderTexture",
	"SetButtonState",
	"SetBuybackItem",
	"SetCamera",
	"SetChange",
	"SetChecked",
	"SetCheckedTexture",
	"SetClampRectInsets",
	"SetClampedToScreen",
	"SetClassBlipTexture",
	"SetColorHSV",
	"SetColorRGB",
	"SetColorValueTexture",
	"SetColorValueThumbTexture",
	"SetColorWheelTexture",
	"SetColorWheelThumbTexture",
	"SetCooldown",
	"SetCorpsePOIArrowTexture",
	"SetCountInvisibleLetters",
	"SetCreature",
	"SetCurrencyToken",
	"SetCursorPosition",
	"SetCurve",
	"SetDegrees",
	"SetDepth",
	"SetDesaturated",
	"SetDisabledCheckedTexture",
	"SetDisabledFontObject",
	"SetDisabledTexture",
	"SetDontSavePosition",
	"SetDrawEdge",
	"SetDrawLayer",
	"SetDuration",
	"SetEndDelay",
	"SetEquipmentSet",
	"SetExistingSocketGem",
	"SetFacing",
	"SetFadeDuration",
	"SetFading",
	"SetFillAlpha",
	"SetFillTexture",
	"SetFocus",
	"SetFogColor",
	"SetFogFar",
	"SetFogNear",
	"SetFont",
	"SetFontObject",
	"SetFontString",
	"SetFormattedText",
	"SetFrameLevel",
	"SetFrameStack",
	"SetFrameStrata",
	"SetGlow",
	"SetGlyph",
	"SetGradient",
	"SetGradientAlpha",
	"SetGuildBankItem",
	"SetHeight",
	"SetHighlightFontObject",
	"SetHighlightTexture",
	"SetHistoryLines",
	"SetHitRectInsets",
	"SetHorizTile",
	"SetHorizontalScroll",
	"SetHyperlink",
	"SetHyperlinkCompareItem",
	"SetHyperlinkFormat",
	"SetHyperlinksEnabled",
	"SetID",
	"SetIconTexture",
	"SetInboxItem",
	"SetIndentedWordWrap",
	"SetInitialOffset",
	"SetInsertMode",
	"SetInventoryItem",
	"SetJustifyH",
	"SetJustifyV",
	"SetLFGCompletionReward",
	"SetLFGDungeonReward",
	"SetLight",
	"SetLooping",
	"SetLootItem",
	"SetLootRollItem",
	"SetMaskTexture",
	"SetMaxBytes",
	"SetMaxFramerate",
	"SetMaxLetters",
	"SetMaxLines",
	"SetMaxResize",
	"SetMerchantCostItem",
	"SetMerchantItem",
	"SetMergeThreshold",
	"SetMinMaxValues",
	"SetMinResize",
	"SetMinimumWidth",
	"SetModel",
	"SetModelScale",
	"SetMotionScriptsWhileDisabled",
	"SetMovable",
	"SetMultiLine",
	"SetNonBlocking",
	"SetNonSpaceWrap",
	"SetNormalFontObject",
	"SetNormalTexture",
	"SetNumSplinePoints",
	"SetNumber",
	"SetNumeric",
	"SetOffset",
	"SetOrder",
	"SetOrientation",
	"SetOrigin",
	"SetOwner",
	"SetPOIArrowTexture",
	"SetPadding",
	"SetParent",
	"SetPassword",
	"SetPetAction",
	"SetPlayerTexture",
	"SetPlayerTextureHeight",
	"SetPlayerTextureWidth",
	"SetPoint",
	"SetPosition",
	"SetPossession",
	"SetPushedTextOffset",
	"SetPushedTexture",
	"SetQuestItem",
	"SetQuestLogItem",
	"SetQuestLogRewardSpell",
	"SetQuestLogSpecialItem",
	"SetQuestRewardSpell",
	"SetRadians",
	"SetResizable",
	"SetReverse",
	"SetRotatesTexture",
	"SetRotation",
	"SetScale",
	"SetScript",
	"SetScrollChild",
	"SetScrollOffset",
	"SetSendMailItem",
	"SetSequence",
	"SetSequenceTime",
	"SetShadowColor",
	"SetShadowOffset",
	"SetShapeshift",
	"SetSize",
	"SetSmoothProgress",
	"SetSmoothing",
	"SetSocketGem",
	"SetSocketedItem",
	"SetSpacing",
	"SetSpell",
	"SetSpellByID",
	"SetStartDelay",
	"SetStaticPOIArrowTexture",
	"SetStatusBarColor",
	"SetStatusBarTexture",
	"SetTalent",
	"SetTexCoord",
	"SetText",
	"SetTextColor",
	"SetTextHeight",
	"SetTextInsets",
	"SetTexture",
	"SetThumbTexture",
	"SetTimeVisible",
	"SetToplevel",
	"SetTotem",
	"SetTracking",
	"SetTradePlayerItem",
	"SetTradeSkillItem",
	"SetTradeTargetItem",
	"SetTrainerService",
	"SetUnit",
	"SetUnitAura",
	"SetUnitBuff",
	"SetUnitDebuff",
	"SetUserPlaced",
	"SetValue",
	"SetValueStep",
	"SetVertTile",
	"SetVertexColor",
	"SetVerticalScroll",
	"SetWidth",
	"SetWordWrap",
	"SetZoom",
	"Show",
	"StartMovie",
	"StartMoving",
	"StartSizing",
	"Stop",
	"StopAnimating",
	"StopMovie",
	"StopMovingOrSizing",
	"ToggleInputLanguage",
	"TryOn",
	"Undress",
	"UnlockHighlight",
	"UnregisterAllEvents",
	"UnregisterEvent",
	"UpdateColorByID",
	"UpdateMouseOverTooltip",
	"UpdateQuestPOI",
	"UpdateScrollChildRect",
}
for x = 1, #temp do
	ColorTable[temp[x]] = methodColor
end
temp = nil

-- ****************************************************************************
-- * WoW Events                                                               *
-- ****************************************************************************

local temp = {
	"ACHIEVEMENT_EARNED",
	"ACHIEVEMENT_PLAYER_NAME",
	"ACHIEVEMENT_SEARCH_UPDATED",
	"ACTIONBAR_HIDEGRID",
	"ACTIONBAR_PAGE_CHANGED",
	"ACTIONBAR_SHOWGRID",
	"ACTIONBAR_SHOW_BOTTOMLEFT",
	"ACTIONBAR_SLOT_CHANGED",
	"ACTIONBAR_UPDATE_COOLDOWN",
	"ACTIONBAR_UPDATE_STATE",
	"ACTIONBAR_UPDATE_USABLE",
	"ACTION_WILL_BIND_ITEM",
	"ACTIVATE_GLYPH",
	"ACTIVE_TALENT_GROUP_CHANGED",
	"ADAPTER_LIST_CHANGED",
	"ADDONS_UNLOADING",
	"ADDON_ACTION_BLOCKED",
	"ADDON_ACTION_FORBIDDEN",
	"ADDON_LOADED",
	"ADVENTURE_MAP_CLOSE",
	"ADVENTURE_MAP_OPEN",
	"ADVENTURE_MAP_QUEST_UPDATE",
	"ADVENTURE_MAP_UPDATE_INSETS",
	"ADVENTURE_MAP_UPDATE_POIS",
	"AJ_DUNGEON_ACTION",
	"AJ_OPEN",
	"AJ_PVE_LFG_ACTION",
	"AJ_PVP_ACTION",
	"AJ_PVP_LFG_ACTION",
	"AJ_PVP_RBG_ACTION",
	"AJ_PVP_SKIRMISH_ACTION",
	"AJ_QUEST_LOG_OPEN",
	"AJ_RAID_ACTION",
	"AJ_REFRESH_DISPLAY",
	"AJ_REWARD_DATA_RECEIVED",
	"ALLIED_RACE_CLOSE",
	"ALLIED_RACE_OPEN",
	"ALTERNATIVE_DEFAULT_LANGUAGE_CHANGED",
	"ANIMA_DIVERSION_CLOSE",
	"ANIMA_DIVERSION_OPEN",
	"ANIMA_DIVERSION_TALENT_UPDATED",
	"ARCHAEOLOGY_CLOSED",
	"ARCHAEOLOGY_FIND_COMPLETE",
	"ARCHAEOLOGY_SURVEY_CAST",
	"ARCHAEOLOGY_TOGGLE",
	"AREA_POIS_UPDATED",
	"AREA_SPIRIT_HEALER_IN_RANGE",
	"AREA_SPIRIT_HEALER_OUT_OF_RANGE",
	"ARENA_COOLDOWNS_UPDATE",
	"ARENA_CROWD_CONTROL_SPELL_UPDATE",
	"ARENA_OPPONENT_UPDATE",
	"ARENA_PREP_OPPONENT_SPECIALIZATIONS",
	"ARENA_SEASON_WORLD_STATE",
	"ARTIFACT_CLOSE",
	"ARTIFACT_DIGSITE_COMPLETE",
	"ARTIFACT_ENDGAME_REFUND",
	"ARTIFACT_RELIC_FORGE_CLOSE",
	"ARTIFACT_RELIC_FORGE_PREVIEW_RELIC_CHANGED",
	"ARTIFACT_RELIC_FORGE_UPDATE",
	"ARTIFACT_RELIC_INFO_RECEIVED",
	"ARTIFACT_RESPEC_PROMPT",
	"ARTIFACT_TIER_CHANGED",
	"ARTIFACT_UPDATE",
	"ARTIFACT_XP_UPDATE",
	"AUCTION_CANCELED",
	"AUCTION_HOUSE_AUCTION_CREATED",
	"AUCTION_HOUSE_BROWSE_FAILURE",
	"AUCTION_HOUSE_BROWSE_RESULTS_ADDED",
	"AUCTION_HOUSE_BROWSE_RESULTS_UPDATED",
	"AUCTION_HOUSE_CLOSED",
	"AUCTION_HOUSE_DISABLED",
	"AUCTION_HOUSE_FAVORITES_UPDATED",
	"AUCTION_HOUSE_NEW_BID_RECEIVED",
	"AUCTION_HOUSE_NEW_RESULTS_RECEIVED",
	"AUCTION_HOUSE_SCRIPT_DEPRECATED",
	"AUCTION_HOUSE_SHOW",
	"AUCTION_HOUSE_THROTTLED_MESSAGE_DROPPED",
	"AUCTION_HOUSE_THROTTLED_MESSAGE_QUEUED",
	"AUCTION_HOUSE_THROTTLED_MESSAGE_RESPONSE_RECEIVED",
	"AUCTION_HOUSE_THROTTLED_MESSAGE_SENT",
	"AUCTION_HOUSE_THROTTLED_SYSTEM_READY",
	"AUCTION_MULTISELL_FAILURE",
	"AUCTION_MULTISELL_START",
	"AUCTION_MULTISELL_UPDATE",
	"AUTH_CHALLENGE_FINISHED",
	"AUTH_CHALLENGE_UI_INVALID",
	"AUTOFOLLOW_BEGIN",
	"AUTOFOLLOW_END",
	"AVATAR_LIST_UPDATED",
	"AVOIDANCE_UPDATE",
	"AZERITE_EMPOWERED_ITEM_EQUIPPED_STATUS_CHANGED",
	"AZERITE_EMPOWERED_ITEM_LOOTED",
	"AZERITE_EMPOWERED_ITEM_SELECTION_UPDATED",
	"AZERITE_ESSENCE_ACTIVATED",
	"AZERITE_ESSENCE_ACTIVATION_FAILED",
	"AZERITE_ESSENCE_CHANGED",
	"AZERITE_ESSENCE_FORGE_CLOSE",
	"AZERITE_ESSENCE_FORGE_OPEN",
	"AZERITE_ESSENCE_MILESTONE_UNLOCKED",
	"AZERITE_ESSENCE_UPDATE",
	"AZERITE_ITEM_ENABLED_STATE_CHANGED",
	"AZERITE_ITEM_EXPERIENCE_CHANGED",
	"AZERITE_ITEM_POWER_LEVEL_CHANGED",
	"BAG_CLOSED",
	"BAG_NEW_ITEMS_UPDATED",
	"BAG_OPEN",
	"BAG_OVERFLOW_WITH_FULL_INVENTORY",
	"BAG_SLOT_FLAGS_UPDATED",
	"BAG_UPDATE",
	"BAG_UPDATE_COOLDOWN",
	"BAG_UPDATE_DELAYED",
	"BANKFRAME_CLOSED",
	"BANKFRAME_OPENED",
	"BANK_BAG_SLOT_FLAGS_UPDATED",
	"BARBER_SHOP_APPEARANCE_APPLIED",
	"BARBER_SHOP_CAMERA_VALUES_UPDATED",
	"BARBER_SHOP_CLOSE",
	"BARBER_SHOP_COST_UPDATE",
	"BARBER_SHOP_FORCE_CUSTOMIZATIONS_UPDATE",
	"BARBER_SHOP_OPEN",
	"BARBER_SHOP_RESULT",
	"BATTLEFIELDS_CLOSED",
	"BATTLEFIELDS_SHOW",
	"BATTLEFIELD_QUEUE_TIMEOUT",
	"BATTLEGROUND_OBJECTIVES_UPDATE",
	"BATTLEGROUND_POINTS_UPDATE",
	"BATTLEPET_FORCE_NAME_DECLENSION",
	"BATTLETAG_INVITE_SHOW",
	"BATTLE_PET_CURSOR_CLEAR",
	"BIDS_UPDATED",
	"BID_ADDED",
	"BILLING_NAG_DIALOG",
	"BIND_ENCHANT",
	"BLACK_MARKET_BID_RESULT",
	"BLACK_MARKET_CLOSE",
	"BLACK_MARKET_ITEM_UPDATE",
	"BLACK_MARKET_OPEN",
	"BLACK_MARKET_OUTBID",
	"BLACK_MARKET_UNAVAILABLE",
	"BLACK_MARKET_WON",
	"BNET_REQUEST_INVITE_CONFIRMATION",
	"BN_BLOCK_FAILED_TOO_MANY",
	"BN_BLOCK_LIST_UPDATED",
	"BN_CHAT_MSG_ADDON",
	"BN_CHAT_WHISPER_UNDELIVERABLE",
	"BN_CONNECTED",
	"BN_CUSTOM_MESSAGE_CHANGED",
	"BN_CUSTOM_MESSAGE_LOADED",
	"BN_DISCONNECTED",
	"BN_FRIEND_ACCOUNT_OFFLINE",
	"BN_FRIEND_ACCOUNT_ONLINE",
	"BN_FRIEND_INFO_CHANGED",
	"BN_FRIEND_INVITE_ADDED",
	"BN_FRIEND_INVITE_LIST_INITIALIZED",
	"BN_FRIEND_INVITE_REMOVED",
	"BN_FRIEND_LIST_SIZE_CHANGED",
	"BN_INFO_CHANGED",
	"BN_REQUEST_FOF_SUCCEEDED",
	"BONUS_ROLL_ACTIVATE",
	"BONUS_ROLL_DEACTIVATE",
	"BONUS_ROLL_FAILED",
	"BONUS_ROLL_RESULT",
	"BONUS_ROLL_STARTED",
	"BOSS_KILL",
	"CALENDAR_ACTION_PENDING",
	"CALENDAR_CLOSE_EVENT",
	"CALENDAR_EVENT_ALARM",
	"CALENDAR_NEW_EVENT",
	"CALENDAR_OPEN_EVENT",
	"CALENDAR_UPDATE_ERROR",
	"CALENDAR_UPDATE_ERROR_WITH_COUNT",
	"CALENDAR_UPDATE_ERROR_WITH_PLAYER_NAME",
	"CALENDAR_UPDATE_EVENT",
	"CALENDAR_UPDATE_EVENT_LIST",
	"CALENDAR_UPDATE_GUILD_EVENTS",
	"CALENDAR_UPDATE_INVITE_LIST",
	"CALENDAR_UPDATE_PENDING_INVITES",
	"CANCEL_GLYPH_CAST",
	"CANCEL_LOOT_ROLL",
	"CANCEL_SUMMON",
	"CAPTUREFRAMES_FAILED",
	"CAPTUREFRAMES_SUCCEEDED",
	"CEMETERY_PREFERENCE_UPDATED",
	"CHALLENGE_MODE_COMPLETED",
	"CHALLENGE_MODE_DEATH_COUNT_UPDATED",
	"CHALLENGE_MODE_KEYSTONE_RECEPTABLE_OPEN",
	"CHALLENGE_MODE_KEYSTONE_SLOTTED",
	"CHALLENGE_MODE_LEADERS_UPDATE",
	"CHALLENGE_MODE_MAPS_UPDATE",
	"CHALLENGE_MODE_MEMBER_INFO_UPDATED",
	"CHALLENGE_MODE_RESET",
	"CHALLENGE_MODE_START",
	"CHANNEL_COUNT_UPDATE",
	"CHANNEL_FLAGS_UPDATED",
	"CHANNEL_INVITE_REQUEST",
	"CHANNEL_LEFT",
	"CHANNEL_PASSWORD_REQUEST",
	"CHANNEL_ROSTER_UPDATE",
	"CHANNEL_UI_UPDATE",
	"CHARACTER_ITEM_FIXUP_NOTIFICATION",
	"CHARACTER_POINTS_CHANGED",
	"CHARACTER_UPGRADE_SPELL_TIER_SET",
	"CHAT_COMBAT_MSG_ARENA_POINTS_GAIN",
	"CHAT_MSG_ACHIEVEMENT",
	"CHAT_MSG_ADDON",
	"CHAT_MSG_ADDON_LOGGED",
	"CHAT_MSG_AFK",
	"CHAT_MSG_BG_SYSTEM_ALLIANCE",
	"CHAT_MSG_BG_SYSTEM_HORDE",
	"CHAT_MSG_BG_SYSTEM_NEUTRAL",
	"CHAT_MSG_BN",
	"CHAT_MSG_BN_INLINE_TOAST_ALERT",
	"CHAT_MSG_BN_INLINE_TOAST_BROADCAST",
	"CHAT_MSG_BN_INLINE_TOAST_BROADCAST_INFORM",
	"CHAT_MSG_BN_INLINE_TOAST_CONVERSATION",
	"CHAT_MSG_BN_WHISPER",
	"CHAT_MSG_BN_WHISPER_INFORM",
	"CHAT_MSG_BN_WHISPER_PLAYER_OFFLINE",
	"CHAT_MSG_CHANNEL",
	"CHAT_MSG_CHANNEL_JOIN",
	"CHAT_MSG_CHANNEL_LEAVE",
	"CHAT_MSG_CHANNEL_LEAVE_PREVENTED",
	"CHAT_MSG_CHANNEL_LIST",
	"CHAT_MSG_CHANNEL_NOTICE",
	"CHAT_MSG_CHANNEL_NOTICE_USER",
	"CHAT_MSG_COMBAT_FACTION_CHANGE",
	"CHAT_MSG_COMBAT_HONOR_GAIN",
	"CHAT_MSG_COMBAT_MISC_INFO",
	"CHAT_MSG_COMBAT_XP_GAIN",
	"CHAT_MSG_COMMUNITIES_CHANNEL",
	"CHAT_MSG_CURRENCY",
	"CHAT_MSG_DND",
	"CHAT_MSG_EMOTE",
	"CHAT_MSG_FILTERED",
	"CHAT_MSG_GUILD",
	"CHAT_MSG_GUILD_ACHIEVEMENT",
	"CHAT_MSG_GUILD_ITEM_LOOTED",
	"CHAT_MSG_IGNORED",
	"CHAT_MSG_INSTANCE_CHAT",
	"CHAT_MSG_INSTANCE_CHAT_LEADER",
	"CHAT_MSG_LOOT",
	"CHAT_MSG_MONEY",
	"CHAT_MSG_MONSTER_EMOTE",
	"CHAT_MSG_MONSTER_PARTY",
	"CHAT_MSG_MONSTER_SAY",
	"CHAT_MSG_MONSTER_WHISPER",
	"CHAT_MSG_MONSTER_YELL",
	"CHAT_MSG_OFFICER",
	"CHAT_MSG_OPENING",
	"CHAT_MSG_PARTY",
	"CHAT_MSG_PARTY_LEADER",
	"CHAT_MSG_PET_BATTLE_COMBAT_LOG",
	"CHAT_MSG_PET_BATTLE_INFO",
	"CHAT_MSG_PET_INFO",
	"CHAT_MSG_RAID",
	"CHAT_MSG_RAID_BOSS_EMOTE",
	"CHAT_MSG_RAID_BOSS_WHISPER",
	"CHAT_MSG_RAID_LEADER",
	"CHAT_MSG_RAID_WARNING",
	"CHAT_MSG_RESTRICTED",
	"CHAT_MSG_SAY",
	"CHAT_MSG_SKILL",
	"CHAT_MSG_SYSTEM",
	"CHAT_MSG_TARGETICONS",
	"CHAT_MSG_TEXT_EMOTE",
	"CHAT_MSG_TRADESKILLS",
	"CHAT_MSG_WHISPER",
	"CHAT_MSG_WHISPER_INFORM",
	"CHAT_MSG_YELL",
	"CHAT_REGIONAL_SEND_FAILED",
	"CHAT_REGIONAL_STATUS_CHANGED",
	"CHAT_SERVER_DISCONNECTED",
	"CHAT_SERVER_RECONNECTED",
	"CHROMIE_TIME_CLOSE",
	"CHROMIE_TIME_OPEN",
	"CINEMATIC_START",
	"CINEMATIC_STOP",
	"CLASS_TRIAL_TIMER_START",
	"CLASS_TRIAL_UPGRADE_COMPLETE",
	"CLEAR_BOSS_EMOTES",
	"CLOSE_INBOX_ITEM",
	"CLOSE_TABARD_FRAME",
	"CLUB_ADDED",
	"CLUB_ERROR",
	"CLUB_FINDER_APPLICANT_INVITE_RECIEVED",
	"CLUB_FINDER_APPLICATIONS_UPDATED",
	"CLUB_FINDER_CLUB_LIST_RETURNED",
	"CLUB_FINDER_CLUB_REPORTED",
	"CLUB_FINDER_COMMUNITY_OFFLINE_JOIN",
	"CLUB_FINDER_ENABLED_OR_DISABLED",
	"CLUB_FINDER_LINKED_CLUB_RETURNED",
	"CLUB_FINDER_MEMBERSHIP_LIST_CHANGED",
	"CLUB_FINDER_PLAYER_PENDING_LIST_RECIEVED",
	"CLUB_FINDER_POST_UPDATED",
	"CLUB_FINDER_RECRUITMENT_POST_RETURNED",
	"CLUB_FINDER_RECRUITS_UPDATED",
	"CLUB_FINDER_RECRUIT_LIST_CHANGED",
	"CLUB_INVITATIONS_RECEIVED_FOR_CLUB",
	"CLUB_INVITATION_ADDED_FOR_SELF",
	"CLUB_INVITATION_REMOVED_FOR_SELF",
	"CLUB_MEMBER_ADDED",
	"CLUB_MEMBER_PRESENCE_UPDATED",
	"CLUB_MEMBER_REMOVED",
	"CLUB_MEMBER_ROLE_UPDATED",
	"CLUB_MEMBER_UPDATED",
	"CLUB_MESSAGE_ADDED",
	"CLUB_MESSAGE_HISTORY_RECEIVED",
	"CLUB_MESSAGE_UPDATED",
	"CLUB_REMOVED",
	"CLUB_REMOVED_MESSAGE",
	"CLUB_SELF_MEMBER_ROLE_UPDATED",
	"CLUB_STREAMS_LOADED",
	"CLUB_STREAM_ADDED",
	"CLUB_STREAM_REMOVED",
	"CLUB_STREAM_SUBSCRIBED",
	"CLUB_STREAM_UNSUBSCRIBED",
	"CLUB_STREAM_UPDATED",
	"CLUB_TICKETS_RECEIVED",
	"CLUB_TICKET_CREATED",
	"CLUB_TICKET_RECEIVED",
	"CLUB_UPDATED",
	"COMBAT_LOG_EVENT",
	"COMBAT_LOG_EVENT_UNFILTERED",
	"COMBAT_RATING_UPDATE",
	"COMBAT_TEXT_UPDATE",
	"COMMENTATOR_ENTER_WORLD",
	"COMMENTATOR_HISTORY_FLUSHED",
	"COMMENTATOR_IMMEDIATE_FOV_UPDATE",
	"COMMENTATOR_MAP_UPDATE",
	"COMMENTATOR_PLAYER_NAME_OVERRIDE_UPDATE",
	"COMMENTATOR_PLAYER_UPDATE",
	"COMMENTATOR_RESET_SETTINGS",
	"COMMENTATOR_TEAMS_SWAPPED",
	"COMMENTATOR_TEAM_NAME_UPDATE",
	"COMMODITY_PRICE_UNAVAILABLE",
	"COMMODITY_PRICE_UPDATED",
	"COMMODITY_PURCHASED",
	"COMMODITY_PURCHASE_FAILED",
	"COMMODITY_PURCHASE_SUCCEEDED",
	"COMMODITY_SEARCH_RESULTS_ADDED",
	"COMMODITY_SEARCH_RESULTS_UPDATED",
	"COMMUNITIES_STREAM_CURSOR_CLEAR",
	"COMPACT_UNIT_FRAME_PROFILES_LOADED",
	"COMPANION_LEARNED",
	"COMPANION_UNLEARNED",
	"COMPANION_UPDATE",
	"CONFIRM_BEFORE_USE",
	"CONFIRM_BINDER",
	"CONFIRM_DISENCHANT_ROLL",
	"CONFIRM_LOOT_ROLL",
	"CONFIRM_SUMMON",
	"CONFIRM_TALENT_WIPE",
	"CONFIRM_XP_LOSS",
	"CONSOLE_CLEAR",
	"CONSOLE_COLORS_CHANGED",
	"CONSOLE_FONT_SIZE_CHANGED",
	"CONSOLE_LOG",
	"CONSOLE_MESSAGE",
	"CONTRIBUTION_CHANGED",
	"CONTRIBUTION_COLLECTOR_CLOSE",
	"CONTRIBUTION_COLLECTOR_OPEN",
	"CONTRIBUTION_COLLECTOR_PENDING",
	"CONTRIBUTION_COLLECTOR_UPDATE",
	"CONTRIBUTION_COLLECTOR_UPDATE_SINGLE",
	"CONVERT_TO_RAID_CONFIRMATION",
	"CORPSE_IN_INSTANCE",
	"CORPSE_IN_RANGE",
	"CORPSE_OUT_OF_RANGE",
	"COVENANT_CALLINGS_UPDATED",
	"COVENANT_CHOSEN",
	"COVENANT_PREVIEW_CLOSE",
	"COVENANT_PREVIEW_OPEN",
	"COVENANT_SANCTUM_INTERACTION_ENDED",
	"COVENANT_SANCTUM_INTERACTION_STARTED",
	"COVENANT_SANCTUM_RENOWN_LEVEL_CHANGED",
	"CRITERIA_COMPLETE",
	"CRITERIA_EARNED",
	"CRITERIA_UPDATE",
	"CURRENCY_DISPLAY_UPDATE",
	"CURRENT_SPELL_CAST_CHANGED",
	"CURSOR_CHANGED",
	"CURSOR_UPDATE",
	"CVAR_UPDATE",
	"DEBUG_MENU_TOGGLED",
	"DELETE_ITEM_CONFIRM",
	"DISABLE_DECLINE_GUILD_INVITE",
	"DISABLE_LOW_LEVEL_RAID",
	"DISABLE_TAXI_BENCHMARK",
	"DISABLE_XP_GAIN",
	"DISPLAY_SIZE_CHANGED",
	"DUEL_FINISHED",
	"DUEL_INBOUNDS",
	"DUEL_OUTOFBOUNDS",
	"DUEL_REQUESTED",
	"DYNAMIC_GOSSIP_POI_UPDATED",
	"EJ_DIFFICULTY_UPDATE",
	"EJ_LOOT_DATA_RECIEVED",
	"ENABLE_DECLINE_GUILD_INVITE",
	"ENABLE_LOW_LEVEL_RAID",
	"ENABLE_TAXI_BENCHMARK",
	"ENABLE_XP_GAIN",
	"ENCOUNTER_END",
	"ENCOUNTER_LOOT_RECEIVED",
	"ENCOUNTER_START",
	"END_BOUND_TRADEABLE",
	"ENTERED_DIFFERENT_INSTANCE_FROM_PARTY",
	"ENTITLEMENT_DELIVERED",
	"EQUIPMENT_SETS_CHANGED",
	"EQUIPMENT_SWAP_FINISHED",
	"EQUIPMENT_SWAP_PENDING",
	"EQUIP_BIND_CONFIRM",
	"EQUIP_BIND_REFUNDABLE_CONFIRM",
	"EQUIP_BIND_TRADEABLE_CONFIRM",
	"EVENT_CLASS_TRIAL_TIMER_START",
	"EXECUTE_CHAT_LINE",
	"EXPERIMENTAL_CVAR_CONFIRMATION_NEEDED",
	"EXTRA_BROWSE_INFO_RECEIVED",
	"FOG_OF_WAR_UPDATED",
	"FORBIDDEN_NAME_PLATE_CREATED",
	"FORBIDDEN_NAME_PLATE_UNIT_ADDED",
	"FORBIDDEN_NAME_PLATE_UNIT_REMOVED",
	"FRIENDLIST_UPDATE",
	"GAME_PAD_CONFIGS_CHANGED",
	"GAME_PAD_CONNECTED",
	"GAME_PAD_DISCONNECTED",
	"GARRISON_ARCHITECT_CLOSED",
	"GARRISON_ARCHITECT_OPENED",
	"GARRISON_BUILDING_ACTIVATABLE",
	"GARRISON_BUILDING_ACTIVATED",
	"GARRISON_BUILDING_ERROR",
	"GARRISON_BUILDING_LIST_UPDATE",
	"GARRISON_BUILDING_PLACED",
	"GARRISON_BUILDING_REMOVED",
	"GARRISON_BUILDING_UPDATE",
	"GARRISON_FOLLOWER_ADDED",
	"GARRISON_FOLLOWER_CATEGORIES_UPDATED",
	"GARRISON_FOLLOWER_DURABILITY_CHANGED",
	"GARRISON_FOLLOWER_LIST_UPDATE",
	"GARRISON_FOLLOWER_REMOVED",
	"GARRISON_FOLLOWER_UPGRADED",
	"GARRISON_FOLLOWER_XP_CHANGED",
	"GARRISON_HIDE_LANDING_PAGE",
	"GARRISON_INVASION_AVAILABLE",
	"GARRISON_INVASION_UNAVAILABLE",
	"GARRISON_LANDINGPAGE_SHIPMENTS",
	"GARRISON_MISSION_AREA_BONUS_ADDED",
	"GARRISON_MISSION_BONUS_ROLL_COMPLETE",
	"GARRISON_MISSION_BONUS_ROLL_LOOT",
	"GARRISON_MISSION_COMPLETE_RESPONSE",
	"GARRISON_MISSION_FINISHED",
	"GARRISON_MISSION_LIST_UPDATE",
	"GARRISON_MISSION_NPC_CLOSED",
	"GARRISON_MISSION_NPC_OPENED",
	"GARRISON_MISSION_REWARD_INFO",
	"GARRISON_MISSION_STARTED",
	"GARRISON_MONUMENT_CLOSE_UI",
	"GARRISON_MONUMENT_LIST_LOADED",
	"GARRISON_MONUMENT_REPLACED",
	"GARRISON_MONUMENT_SELECTED_TROPHY_ID_LOADED",
	"GARRISON_MONUMENT_SHOW_UI",
	"GARRISON_RANDOM_MISSION_ADDED",
	"GARRISON_RECALL_PORTAL_LAST_USED_TIME",
	"GARRISON_RECALL_PORTAL_USED",
	"GARRISON_RECRUITMENT_FOLLOWERS_GENERATED",
	"GARRISON_RECRUITMENT_NPC_CLOSED",
	"GARRISON_RECRUITMENT_NPC_OPENED",
	"GARRISON_RECRUITMENT_READY",
	"GARRISON_RECRUIT_FOLLOWER_RESULT",
	"GARRISON_SHIPMENT_RECEIVED",
	"GARRISON_SHIPYARD_NPC_CLOSED",
	"GARRISON_SHIPYARD_NPC_OPENED",
	"GARRISON_SHOW_LANDING_PAGE",
	"GARRISON_TALENT_COMPLETE",
	"GARRISON_TALENT_EVENT_UPDATE",
	"GARRISON_TALENT_NPC_CLOSED",
	"GARRISON_TALENT_NPC_OPENED",
	"GARRISON_TALENT_RESEARCH_STARTED",
	"GARRISON_TALENT_UPDATE",
	"GARRISON_TRADESKILL_NPC_CLOSED",
	"GARRISON_UPDATE",
	"GARRISON_UPGRADEABLE_RESULT",
	"GARRISON_USE_PARTY_GARRISON_CHANGED",
	"GDF_SIM_COMPLETE",
	"GENERIC_ERROR",
	"GET_ITEM_INFO_RECEIVED",
	"GLOBAL_MOUSE_DOWN",
	"GLOBAL_MOUSE_UP",
	"GLUE_CONSOLE_LOG",
	"GLUE_SCREENSHOT_FAILED",
	"GM_PLAYER_INFO",
	"GOSSIP_CLOSED",
	"GOSSIP_CONFIRM",
	"GOSSIP_CONFIRM_CANCEL",
	"GOSSIP_ENTER_CODE",
	"GOSSIP_SHOW",
	"GROUP_FORMED",
	"GROUP_INVITE_CONFIRMATION",
	"GROUP_JOINED",
	"GROUP_LEFT",
	"GROUP_ROSTER_UPDATE",
	"GUILDBANKBAGSLOTS_CHANGED",
	"GUILDBANKFRAME_CLOSED",
	"GUILDBANKFRAME_OPENED",
	"GUILDBANKLOG_UPDATE",
	"GUILDBANK_ITEM_LOCK_CHANGED",
	"GUILDBANK_TEXT_CHANGED",
	"GUILDBANK_UPDATE_MONEY",
	"GUILDBANK_UPDATE_TABS",
	"GUILDBANK_UPDATE_TEXT",
	"GUILDBANK_UPDATE_WITHDRAWMONEY",
	"GUILDTABARD_UPDATE",
	"GUILD_CHALLENGE_COMPLETED",
	"GUILD_CHALLENGE_UPDATED",
	"GUILD_EVENT_LOG_UPDATE",
	"GUILD_INVITE_CANCEL",
	"GUILD_INVITE_REQUEST",
	"GUILD_MOTD",
	"GUILD_NEWS_UPDATE",
	"GUILD_PARTY_STATE_UPDATED",
	"GUILD_RANKS_UPDATE",
	"GUILD_RECIPE_KNOWN_BY_MEMBERS",
	"GUILD_REGISTRAR_CLOSED",
	"GUILD_REGISTRAR_SHOW",
	"GUILD_RENAME_REQUIRED",
	"GUILD_REWARDS_LIST",
	"GUILD_ROSTER_UPDATE",
	"GUILD_TRADESKILL_UPDATE",
	"GX_RESTARTED",
	"HEARTHSTONE_BOUND",
	"HEIRLOOMS_UPDATED",
	"HEIRLOOM_UPGRADE_TARGETING_CHANGED",
	"HIDE_SUBTITLE",
	"HONOR_LEVEL_UPDATE",
	"HONOR_XP_UPDATE",
	"IGNORELIST_UPDATE",
	"IGR_BILLING_NAG_DIALOG",
	"INCOMING_RESURRECT_CHANGED",
	"INCOMING_SUMMON_CHANGED",
	"INITIAL_CLUBS_LOADED",
	"INITIAL_HOTFIXES_APPLIED",
	"INSPECT_ACHIEVEMENT_READY",
	"INSPECT_HONOR_UPDATE",
	"INSPECT_READY",
	"INSTANCE_BOOT_START",
	"INSTANCE_BOOT_STOP",
	"INSTANCE_ENCOUNTER_ADD_TIMER",
	"INSTANCE_ENCOUNTER_ENGAGE_UNIT",
	"INSTANCE_ENCOUNTER_OBJECTIVE_COMPLETE",
	"INSTANCE_ENCOUNTER_OBJECTIVE_START",
	"INSTANCE_ENCOUNTER_OBJECTIVE_UPDATE",
	"INSTANCE_GROUP_SIZE_CHANGED",
	"INSTANCE_LOCK_START",
	"INSTANCE_LOCK_STOP",
	"INSTANCE_LOCK_WARNING",
	"INVENTORY_SEARCH_UPDATE",
	"INVITE_TO_PARTY_CONFIRMATION",
	"INVITE_TRAVEL_PASS_CONFIRMATION",
	"ISLANDS_QUEUE_CLOSE",
	"ISLANDS_QUEUE_OPEN",
	"ISLAND_AZERITE_GAIN",
	"ISLAND_COMPLETED",
	"ITEM_CHANGED",
	"ITEM_DATA_LOAD_RESULT",
	"ITEM_INTERACTION_CLOSE",
	"ITEM_INTERACTION_ITEM_SELECTION_UPDATED",
	"ITEM_INTERACTION_OPEN",
	"ITEM_KEY_ITEM_INFO_RECEIVED",
	"ITEM_LOCKED",
	"ITEM_LOCK_CHANGED",
	"ITEM_PURCHASED",
	"ITEM_PUSH",
	"ITEM_RESTORATION_BUTTON_STATUS",
	"ITEM_SEARCH_RESULTS_ADDED",
	"ITEM_SEARCH_RESULTS_UPDATED",
	"ITEM_TEXT_BEGIN",
	"ITEM_TEXT_CLOSED",
	"ITEM_TEXT_READY",
	"ITEM_TEXT_TRANSLATION",
	"ITEM_UNLOCKED",
	"ITEM_UPGRADE_MASTER_CLOSED",
	"ITEM_UPGRADE_MASTER_OPENED",
	"ITEM_UPGRADE_MASTER_SET_ITEM",
	"ITEM_UPGRADE_MASTER_UPDATE",
	"JAILERS_TOWER_LEVEL_UPDATE",
	"KNOWLEDGE_BASE_ARTICLE_LOAD_FAILURE",
	"KNOWLEDGE_BASE_ARTICLE_LOAD_SUCCESS",
	"KNOWLEDGE_BASE_QUERY_LOAD_FAILURE",
	"KNOWLEDGE_BASE_QUERY_LOAD_SUCCESS",
	"KNOWLEDGE_BASE_SERVER_MESSAGE",
	"KNOWLEDGE_BASE_SETUP_LOAD_FAILURE",
	"KNOWLEDGE_BASE_SETUP_LOAD_SUCCESS",
	"KNOWLEDGE_BASE_SYSTEM_MOTD_UPDATED",
	"KNOWN_TITLES_UPDATE",
	"LANGUAGE_LIST_CHANGED",
	"LEARNED_SPELL_IN_TAB",
	"LEAVE_PARTY_CONFIRMATION",
	"LEAVING_TUTORIAL_AREA",
	"LFG_BOOT_PROPOSAL_UPDATE",
	"LFG_COMPLETION_REWARD",
	"LFG_GROUP_DELISTED_LEADERSHIP_CHANGE",
	"LFG_INVALID_ERROR_MESSAGE",
	"LFG_LIST_ACTIVE_ENTRY_UPDATE",
	"LFG_LIST_APPLICANT_LIST_UPDATED",
	"LFG_LIST_APPLICANT_UPDATED",
	"LFG_LIST_APPLICATION_STATUS_UPDATED",
	"LFG_LIST_AVAILABILITY_UPDATE",
	"LFG_LIST_ENTRY_CREATION_FAILED",
	"LFG_LIST_ENTRY_EXPIRED_TIMEOUT",
	"LFG_LIST_ENTRY_EXPIRED_TOO_MANY_PLAYERS",
	"LFG_LIST_JOINED_GROUP",
	"LFG_LIST_SEARCH_FAILED",
	"LFG_LIST_SEARCH_RESULTS_RECEIVED",
	"LFG_LIST_SEARCH_RESULT_UPDATED",
	"LFG_LOCK_INFO_RECEIVED",
	"LFG_OFFER_CONTINUE",
	"LFG_OPEN_FROM_GOSSIP",
	"LFG_PROPOSAL_DONE",
	"LFG_PROPOSAL_FAILED",
	"LFG_PROPOSAL_SHOW",
	"LFG_PROPOSAL_SUCCEEDED",
	"LFG_PROPOSAL_UPDATE",
	"LFG_QUEUE_STATUS_UPDATE",
	"LFG_READY_CHECK_DECLINED",
	"LFG_READY_CHECK_HIDE",
	"LFG_READY_CHECK_PLAYER_IS_READY",
	"LFG_READY_CHECK_SHOW",
	"LFG_READY_CHECK_UPDATE",
	"LFG_ROLE_CHECK_DECLINED",
	"LFG_ROLE_CHECK_HIDE",
	"LFG_ROLE_CHECK_ROLE_CHOSEN",
	"LFG_ROLE_CHECK_SHOW",
	"LFG_ROLE_CHECK_UPDATE",
	"LFG_ROLE_UPDATE",
	"LFG_UPDATE",
	"LFG_UPDATE_RANDOM_INFO",
	"LF_GUILD_BROWSE_UPDATED",
	"LF_GUILD_MEMBERSHIP_LIST_CHANGED",
	"LF_GUILD_MEMBERSHIP_LIST_UPDATED",
	"LF_GUILD_POST_UPDATED",
	"LF_GUILD_RECRUITS_UPDATED",
	"LF_GUILD_RECRUIT_LIST_CHANGED",
	"LIFESTEAL_UPDATE",
	"LOADING_SCREEN_DISABLED",
	"LOADING_SCREEN_ENABLED",
	"LOCALPLAYER_PET_RENAMED",
	"LOC_RESULT",
	"LOGOUT_CANCEL",
	"LOOT_BIND_CONFIRM",
	"LOOT_CLOSED",
	"LOOT_HISTORY_AUTO_SHOW",
	"LOOT_HISTORY_FULL_UPDATE",
	"LOOT_HISTORY_ROLL_CHANGED",
	"LOOT_HISTORY_ROLL_COMPLETE",
	"LOOT_ITEM_AVAILABLE",
	"LOOT_ITEM_ROLL_WON",
	"LOOT_OPENED",
	"LOOT_READY",
	"LOOT_ROLLS_COMPLETE",
	"LOOT_SLOT_CHANGED",
	"LOOT_SLOT_CLEARED",
	"LORE_TEXT_UPDATED_CAMPAIGN",
	"LOSS_OF_CONTROL_ADDED",
	"LOSS_OF_CONTROL_COMMENTATOR_ADDED",
	"LOSS_OF_CONTROL_COMMENTATOR_UPDATE",
	"LOSS_OF_CONTROL_UPDATE",
	"LUA_WARNING",
	"MACRO_ACTION_BLOCKED",
	"MACRO_ACTION_FORBIDDEN",
	"MAIL_CLOSED",
	"MAIL_FAILED",
	"MAIL_INBOX_UPDATE",
	"MAIL_LOCK_SEND_ITEMS",
	"MAIL_SEND_INFO_UPDATE",
	"MAIL_SEND_SUCCESS",
	"MAIL_SHOW",
	"MAIL_SUCCESS",
	"MAIL_UNLOCK_SEND_ITEMS",
	"MAP_EXPLORATION_UPDATED",
	"MASTERY_UPDATE",
	"MAX_EXPANSION_LEVEL_UPDATED",
	"MAX_SPELL_START_RECOVERY_OFFSET_CHANGED",
	"MERCHANT_CLOSED",
	"MERCHANT_CONFIRM_TRADE_TIMER_REMOVAL",
	"MERCHANT_FILTER_ITEM_UPDATE",
	"MERCHANT_SHOW",
	"MERCHANT_UPDATE",
	"MINIMAP_PING",
	"MINIMAP_UPDATE_TRACKING",
	"MINIMAP_UPDATE_ZOOM",
	"MIN_EXPANSION_LEVEL_UPDATED",
	"MIRROR_TIMER_PAUSE",
	"MIRROR_TIMER_START",
	"MIRROR_TIMER_STOP",
	"MODIFIER_STATE_CHANGED",
	"MOUNT_CURSOR_CLEAR",
	"MOUNT_EQUIPMENT_APPLY_RESULT",
	"MOUNT_JOURNAL_SEARCH_UPDATED",
	"MOUNT_JOURNAL_USABILITY_CHANGED",
	"MUTELIST_UPDATE",
	"MYTHIC_PLUS_CURRENT_AFFIX_UPDATE",
	"MYTHIC_PLUS_NEW_SEASON_RECORD",
	"MYTHIC_PLUS_NEW_WEEKLY_RECORD",
	"NAME_PLATE_CREATED",
	"NAME_PLATE_UNIT_ADDED",
	"NAME_PLATE_UNIT_REMOVED",
	"NAVIGATION_FRAME_CREATED",
	"NAVIGATION_FRAME_DESTROYED",
	"NEUTRAL_FACTION_SELECT_RESULT",
	"NEWCOMER_GRADUATION",
	"NEW_MOUNT_ADDED",
	"NEW_PET_ADDED",
	"NEW_RECIPE_LEARNED",
	"NEW_RUNEFORGE_POWER_ADDED",
	"NEW_TOY_ADDED",
	"NEW_WMO_CHUNK",
	"NOTIFY_PVP_AFK_RESULT",
	"NPE_TUTORIAL_UPDATE",
	"OBJECT_ENTERED_AOI",
	"OBJECT_LEFT_AOI",
	"OBLITERUM_FORGE_CLOSE",
	"OBLITERUM_FORGE_PENDING_ITEM_CHANGED",
	"OBLITERUM_FORGE_SHOW",
	"OPEN_MASTER_LOOT_LIST",
	"OPEN_REPORT_PLAYER",
	"OPEN_SPLASH_SCREEN",
	"OPEN_TABARD_FRAME",
	"OWNED_AUCTIONS_UPDATED",
	"OWNED_AUCTION_BIDDER_INFO_RECEIVED",
	"PARTY_INVITE_CANCEL",
	"PARTY_INVITE_REQUEST",
	"PARTY_LEADER_CHANGED",
	"PARTY_LFG_RESTRICTED",
	"PARTY_LOOT_METHOD_CHANGED",
	"PARTY_MEMBER_DISABLE",
	"PARTY_MEMBER_ENABLE",
	"PENDING_AZERITE_ESSENCE_CHANGED",
	"PETITION_CLOSED",
	"PETITION_SHOW",
	"PET_ATTACK_START",
	"PET_ATTACK_STOP",
	"PET_BAR_HIDEGRID",
	"PET_BAR_SHOWGRID",
	"PET_BAR_UPDATE",
	"PET_BAR_UPDATE_COOLDOWN",
	"PET_BAR_UPDATE_USABLE",
	"PET_BATTLE_ABILITY_CHANGED",
	"PET_BATTLE_ACTION_SELECTED",
	"PET_BATTLE_AURA_APPLIED",
	"PET_BATTLE_AURA_CANCELED",
	"PET_BATTLE_AURA_CHANGED",
	"PET_BATTLE_CAPTURED",
	"PET_BATTLE_CLOSE",
	"PET_BATTLE_FINAL_ROUND",
	"PET_BATTLE_HEALTH_CHANGED",
	"PET_BATTLE_LEVEL_CHANGED",
	"PET_BATTLE_LOOT_RECEIVED",
	"PET_BATTLE_MAX_HEALTH_CHANGED",
	"PET_BATTLE_OPENING_DONE",
	"PET_BATTLE_OPENING_START",
	"PET_BATTLE_OVER",
	"PET_BATTLE_OVERRIDE_ABILITY",
	"PET_BATTLE_PET_CHANGED",
	"PET_BATTLE_PET_ROUND_PLAYBACK_COMPLETE",
	"PET_BATTLE_PET_ROUND_RESULTS",
	"PET_BATTLE_PET_TYPE_CHANGED",
	"PET_BATTLE_PVP_DUEL_REQUESTED",
	"PET_BATTLE_PVP_DUEL_REQUEST_CANCEL",
	"PET_BATTLE_QUEUE_PROPOSAL_ACCEPTED",
	"PET_BATTLE_QUEUE_PROPOSAL_DECLINED",
	"PET_BATTLE_QUEUE_PROPOSE_MATCH",
	"PET_BATTLE_QUEUE_STATUS",
	"PET_BATTLE_XP_CHANGED",
	"PET_DISMISS_START",
	"PET_FORCE_NAME_DECLENSION",
	"PET_JOURNAL_AUTO_SLOTTED_PET",
	"PET_JOURNAL_CAGE_FAILED",
	"PET_JOURNAL_LIST_UPDATE",
	"PET_JOURNAL_NEW_BATTLE_SLOT",
	"PET_JOURNAL_PETS_HEALED",
	"PET_JOURNAL_PET_DELETED",
	"PET_JOURNAL_PET_RESTORED",
	"PET_JOURNAL_PET_REVOKED",
	"PET_JOURNAL_TRAP_LEVEL_SET",
	"PET_SPECIALIZATION_CHANGED",
	"PET_SPELL_POWER_UPDATE",
	"PET_STABLE_CLOSED",
	"PET_STABLE_SHOW",
	"PET_STABLE_UPDATE",
	"PET_STABLE_UPDATE_PAPERDOLL",
	"PET_UI_CLOSE",
	"PET_UI_UPDATE",
	"PLAYERBANKBAGSLOTS_CHANGED",
	"PLAYERBANKSLOTS_CHANGED",
	"PLAYERREAGENTBANKSLOTS_CHANGED",
	"PLAYER_ALIVE",
	"PLAYER_AVG_ITEM_LEVEL_UPDATE",
	"PLAYER_CAMPING",
	"PLAYER_CHOICE_CLOSE",
	"PLAYER_CHOICE_UPDATE",
	"PLAYER_CONTROL_GAINED",
	"PLAYER_CONTROL_LOST",
	"PLAYER_DAMAGE_DONE_MODS",
	"PLAYER_DEAD",
	"PLAYER_DIFFICULTY_CHANGED",
	"PLAYER_ENTERING_BATTLEGROUND",
	"PLAYER_ENTERING_WORLD",
	"PLAYER_ENTER_COMBAT",
	"PLAYER_EQUIPMENT_CHANGED",
	"PLAYER_FARSIGHT_FOCUS_CHANGED",
	"PLAYER_FLAGS_CHANGED",
	"PLAYER_FOCUS_CHANGED",
	"PLAYER_GAINS_VEHICLE_DATA",
	"PLAYER_GUILD_UPDATE",
	"PLAYER_LEARN_PVP_TALENT_FAILED",
	"PLAYER_LEARN_TALENT_FAILED",
	"PLAYER_LEAVE_COMBAT",
	"PLAYER_LEAVING_WORLD",
	"PLAYER_LEVEL_CHANGED",
	"PLAYER_LEVEL_UP",
	"PLAYER_LOGIN",
	"PLAYER_LOGOUT",
	"PLAYER_LOOT_SPEC_UPDATED",
	"PLAYER_LOSES_VEHICLE_DATA",
	"PLAYER_MONEY",
	"PLAYER_MOUNT_DISPLAY_CHANGED",
	"PLAYER_PVP_KILLS_CHANGED",
	"PLAYER_PVP_RANK_CHANGED",
	"PLAYER_PVP_TALENT_UPDATE",
	"PLAYER_QUITING",
	"PLAYER_REGEN_DISABLED",
	"PLAYER_REGEN_ENABLED",
	"PLAYER_REPORT_SUBMITTED",
	"PLAYER_ROLES_ASSIGNED",
	"PLAYER_SKINNED",
	"PLAYER_SPECIALIZATION_CHANGED",
	"PLAYER_STARTED_LOOKING",
	"PLAYER_STARTED_MOVING",
	"PLAYER_STARTED_TURNING",
	"PLAYER_STOPPED_LOOKING",
	"PLAYER_STOPPED_MOVING",
	"PLAYER_STOPPED_TURNING",
	"PLAYER_TALENT_UPDATE",
	"PLAYER_TARGET_CHANGED",
	"PLAYER_TOTEM_UPDATE",
	"PLAYER_TRADE_CURRENCY",
	"PLAYER_TRADE_MONEY",
	"PLAYER_TRIAL_XP_UPDATE",
	"PLAYER_UNGHOST",
	"PLAYER_UPDATE_RESTING",
	"PLAYER_XP_UPDATE",
	"PLAYTIME_CHANGED",
	"PLAY_MOVIE",
	"PORTRAITS_UPDATED",
	"POST_MATCH_CURRENCY_REWARD_UPDATE",
	"POST_MATCH_ITEM_REWARD_UPDATE",
	"PRODUCT_ASSIGN_TO_TARGET_FAILED",
	"PRODUCT_CHOICE_UPDATE",
	"PRODUCT_DISTRIBUTIONS_UPDATED",
	"PROVING_GROUNDS_SCORE_UPDATE",
	"PVPQUEUE_ANYWHERE_SHOW",
	"PVPQUEUE_ANYWHERE_UPDATE_AVAILABLE",
	"PVP_BRAWL_INFO_UPDATED",
	"PVP_MATCH_ACTIVE",
	"PVP_MATCH_COMPLETE",
	"PVP_MATCH_INACTIVE",
	"PVP_POWER_UPDATE",
	"PVP_RATED_STATS_UPDATE",
	"PVP_REWARDS_UPDATE",
	"PVP_ROLE_UPDATE",
	"PVP_SPECIAL_EVENT_INFO_UPDATED",
	"PVP_TIMER_UPDATE",
	"PVP_TYPES_ENABLED",
	"PVP_VEHICLE_INFO_UPDATED",
	"PVP_WORLDSTATE_UPDATE",
	"QUESTLINE_UPDATE",
	"QUEST_ACCEPTED",
	"QUEST_ACCEPT_CONFIRM",
	"QUEST_AUTOCOMPLETE",
	"QUEST_BOSS_EMOTE",
	"QUEST_COMPLETE",
	"QUEST_CURRENCY_LOOT_RECEIVED",
	"QUEST_DATA_LOAD_RESULT",
	"QUEST_DETAIL",
	"QUEST_FINISHED",
	"QUEST_GREETING",
	"QUEST_ITEM_UPDATE",
	"QUEST_LOG_CRITERIA_UPDATE",
	"QUEST_LOG_UPDATE",
	"QUEST_LOOT_RECEIVED",
	"QUEST_POI_UPDATE",
	"QUEST_PROGRESS",
	"QUEST_REMOVED",
	"QUEST_SESSION_CREATED",
	"QUEST_SESSION_DESTROYED",
	"QUEST_SESSION_ENABLED_STATE_CHANGED",
	"QUEST_SESSION_JOINED",
	"QUEST_SESSION_LEFT",
	"QUEST_SESSION_MEMBER_CONFIRM",
	"QUEST_SESSION_MEMBER_START_RESPONSE",
	"QUEST_SESSION_NOTIFICATION",
	"QUEST_TURNED_IN",
	"QUEST_WATCH_LIST_CHANGED",
	"QUEST_WATCH_UPDATE",
	"QUICK_TICKET_SYSTEM_STATUS",
	"QUICK_TICKET_THROTTLE_CHANGED",
	"RAF_ENTITLEMENT_DELIVERED",
	"RAF_INFO_UPDATED",
	"RAF_RECRUITING_ENABLED_STATUS",
	"RAF_SYSTEM_ENABLED_STATUS",
	"RAF_SYSTEM_INFO_UPDATED",
	"RAID_BOSS_EMOTE",
	"RAID_BOSS_WHISPER",
	"RAID_INSTANCE_WELCOME",
	"RAID_ROSTER_UPDATE",
	"RAID_TARGET_UPDATE",
	"RAISED_AS_GHOUL",
	"READY_CHECK",
	"READY_CHECK_CONFIRM",
	"READY_CHECK_FINISHED",
	"REAGENTBANK_PURCHASED",
	"REAGENTBANK_UPDATE",
	"RECEIVED_ACHIEVEMENT_LIST",
	"RECEIVED_ACHIEVEMENT_MEMBER_LIST",
	"REPLACE_ENCHANT",
	"REPLICATE_ITEM_LIST_UPDATE",
	"REPORT_PLAYER_RESULT",
	"REQUEST_CEMETERY_LIST_RESPONSE",
	"REQUEST_INVITE_CONFIRMATION",
	"REQUIRED_GUILD_RENAME_RESULT",
	"RESEARCH_ARTIFACT_COMPLETE",
	"RESEARCH_ARTIFACT_DIG_SITE_UPDATED",
	"RESEARCH_ARTIFACT_HISTORY_READY",
	"RESEARCH_ARTIFACT_UPDATE",
	"RESPEC_AZERITE_EMPOWERED_ITEM_CLOSED",
	"RESPEC_AZERITE_EMPOWERED_ITEM_OPENED",
	"RESURRECT_REQUEST",
	"ROLE_CHANGED_INFORM",
	"ROLE_POLL_BEGIN",
	"RUNEFORGE_LEGENDARY_CRAFTING_CLOSED",
	"RUNEFORGE_LEGENDARY_CRAFTING_OPENED",
	"RUNEFORGE_POWER_INFO_UPDATED",
	"RUNE_POWER_UPDATE",
	"SAVED_VARIABLES_TOO_LARGE",
	"SCENARIO_BONUS_OBJECTIVE_COMPLETE",
	"SCENARIO_BONUS_VISIBILITY_UPDATE",
	"SCENARIO_COMPLETED",
	"SCENARIO_CRITERIA_SHOW_STATE_UPDATE",
	"SCENARIO_CRITERIA_UPDATE",
	"SCENARIO_POI_UPDATE",
	"SCENARIO_SPELL_UPDATE",
	"SCENARIO_UPDATE",
	"SCRAPPING_MACHINE_CLOSE",
	"SCRAPPING_MACHINE_ITEM_REMOVED_OR_CANCELLED",
	"SCRAPPING_MACHINE_PENDING_ITEM_CHANGED",
	"SCRAPPING_MACHINE_SCRAPPING_FINISHED",
	"SCRAPPING_MACHINE_SHOW",
	"SCREENSHOT_FAILED",
	"SCREENSHOT_STARTED",
	"SCREENSHOT_SUCCEEDED",
	"SEARCH_DB_LOADED",
	"SECURE_TRANSFER_CANCEL",
	"SECURE_TRANSFER_CONFIRM_SEND_MAIL",
	"SECURE_TRANSFER_CONFIRM_TRADE_ACCEPT",
	"SELF_RES_SPELL_CHANGED",
	"SEND_MAIL_COD_CHANGED",
	"SEND_MAIL_MONEY_CHANGED",
	"SESSION_TIME_ALERT",
	"SHIPMENT_CRAFTER_CLOSED",
	"SHIPMENT_CRAFTER_INFO",
	"SHIPMENT_CRAFTER_OPENED",
	"SHIPMENT_CRAFTER_REAGENT_UPDATE",
	"SHIPMENT_UPDATE",
	"SHOW_FACTION_SELECT_UI",
	"SHOW_LFG_EXPAND_SEARCH_PROMPT",
	"SHOW_LOOT_TOAST",
	"SHOW_LOOT_TOAST_LEGENDARY_LOOTED",
	"SHOW_LOOT_TOAST_UPGRADE",
	"SHOW_PVP_FACTION_LOOT_TOAST",
	"SHOW_RATED_PVP_REWARD_TOAST",
	"SHOW_SUBSCRIPTION_INTERSTITIAL",
	"SIMPLE_BROWSER_WEB_ERROR",
	"SIMPLE_BROWSER_WEB_PROXY_FAILED",
	"SIMPLE_CHECKOUT_CLOSED",
	"SKILL_LINES_CHANGED",
	"SOCIAL_ITEM_RECEIVED",
	"SOCIAL_QUEUE_CONFIG_UPDATED",
	"SOCIAL_QUEUE_UPDATE",
	"SOCKET_INFO_ACCEPT",
	"SOCKET_INFO_BIND_CONFIRM",
	"SOCKET_INFO_CLOSE",
	"SOCKET_INFO_FAILURE",
	"SOCKET_INFO_REFUNDABLE_CONFIRM",
	"SOCKET_INFO_SUCCESS",
	"SOCKET_INFO_UPDATE",
	"SOULBIND_ACTIVATED",
	"SOULBIND_CONDUITS_RESET",
	"SOULBIND_CONDUIT_COLLECTION_CLEARED",
	"SOULBIND_CONDUIT_COLLECTION_REMOVED",
	"SOULBIND_CONDUIT_COLLECTION_UPDATED",
	"SOULBIND_CONDUIT_INSTALLED",
	"SOULBIND_CONDUIT_UNINSTALLED",
	"SOULBIND_FORGE_INTERACTION_ENDED",
	"SOULBIND_FORGE_INTERACTION_STARTED",
	"SOULBIND_NODE_LEARNED",
	"SOULBIND_NODE_UNLEARNED",
	"SOULBIND_NODE_UPDATED",
	"SOULBIND_PATH_CHANGED",
	"SOULBIND_PENDING_CONDUIT_CHANGED",
	"SOUNDKIT_FINISHED",
	"SOUND_DEVICE_UPDATE",
	"SPEC_INVOLUNTARILY_CHANGED",
	"SPEED_UPDATE",
	"SPELLS_CHANGED",
	"SPELL_ACTIVATION_OVERLAY_GLOW_HIDE",
	"SPELL_ACTIVATION_OVERLAY_GLOW_SHOW",
	"SPELL_ACTIVATION_OVERLAY_HIDE",
	"SPELL_ACTIVATION_OVERLAY_SHOW",
	"SPELL_CONFIRMATION_PROMPT",
	"SPELL_CONFIRMATION_TIMEOUT",
	"SPELL_DATA_LOAD_RESULT",
	"SPELL_FLYOUT_UPDATE",
	"SPELL_POWER_CHANGED",
	"SPELL_PUSHED_TO_ACTIONBAR",
	"SPELL_TEXT_UPDATE",
	"SPELL_UPDATE_CHARGES",
	"SPELL_UPDATE_COOLDOWN",
	"SPELL_UPDATE_ICON",
	"SPELL_UPDATE_USABLE",
	"START_AUTOREPEAT_SPELL",
	"START_LOOT_ROLL",
	"START_TIMER",
	"STOP_AUTOREPEAT_SPELL",
	"STORE_BOOST_AUTO_CONSUMED",
	"STORE_CHARACTER_LIST_RECEIVED",
	"STORE_CONFIRM_PURCHASE",
	"STORE_OPEN_SIMPLE_CHECKOUT",
	"STORE_ORDER_INITIATION_FAILED",
	"STORE_PRODUCTS_UPDATED",
	"STORE_PRODUCT_DELIVERED",
	"STORE_PURCHASE_ERROR",
	"STORE_PURCHASE_LIST_UPDATED",
	"STORE_REFRESH",
	"STORE_STATUS_CHANGED",
	"STORE_VAS_PURCHASE_COMPLETE",
	"STORE_VAS_PURCHASE_ERROR",
	"STREAMING_ICON",
	"STREAM_VIEW_MARKER_UPDATED",
	"STURDINESS_UPDATE",
	"SUBSCRIPTION_CHANGED_KICK_IMMINENT",
	"SUPER_TRACKING_CHANGED",
	"SYSMSG",
	"TABARD_CANSAVE_CHANGED",
	"TABARD_SAVE_PENDING",
	"TALENTS_INVOLUNTARILY_RESET",
	"TALKINGHEAD_CLOSE",
	"TALKINGHEAD_REQUESTED",
	"TASK_PROGRESS_UPDATE",
	"TAXIMAP_CLOSED",
	"TAXIMAP_OPENED",
	"TIME_PLAYED_MSG",
	"TOGGLE_CONSOLE",
	"TOKEN_AUCTION_SOLD",
	"TOKEN_BUY_CONFIRM_REQUIRED",
	"TOKEN_BUY_RESULT",
	"TOKEN_CAN_VETERAN_BUY_UPDATE",
	"TOKEN_DISTRIBUTIONS_UPDATED",
	"TOKEN_MARKET_PRICE_UPDATED",
	"TOKEN_REDEEM_BALANCE_UPDATED",
	"TOKEN_REDEEM_CONFIRM_REQUIRED",
	"TOKEN_REDEEM_FRAME_SHOW",
	"TOKEN_REDEEM_GAME_TIME_UPDATED",
	"TOKEN_REDEEM_RESULT",
	"TOKEN_SELL_CONFIRMED",
	"TOKEN_SELL_CONFIRM_REQUIRED",
	"TOKEN_SELL_RESULT",
	"TOKEN_STATUS_CHANGED",
	"TOYS_UPDATED",
	"TRACKED_ACHIEVEMENT_LIST_CHANGED",
	"TRACKED_ACHIEVEMENT_UPDATE",
	"TRADE_ACCEPT_UPDATE",
	"TRADE_CLOSED",
	"TRADE_CURRENCY_CHANGED",
	"TRADE_MONEY_CHANGED",
	"TRADE_PLAYER_ITEM_CHANGED",
	"TRADE_POTENTIAL_BIND_ENCHANT",
	"TRADE_POTENTIAL_REMOVE_TRANSMOG",
	"TRADE_REPLACE_ENCHANT",
	"TRADE_REQUEST",
	"TRADE_REQUEST_CANCEL",
	"TRADE_SHOW",
	"TRADE_SKILL_CLOSE",
	"TRADE_SKILL_DATA_SOURCE_CHANGED",
	"TRADE_SKILL_DATA_SOURCE_CHANGING",
	"TRADE_SKILL_DETAILS_UPDATE",
	"TRADE_SKILL_LIST_UPDATE",
	"TRADE_SKILL_NAME_UPDATE",
	"TRADE_SKILL_OPTIONAL_REAGENT_BONUS_TEXT_UPDATED",
	"TRADE_SKILL_SHOW",
	"TRADE_TARGET_ITEM_CHANGED",
	"TRADE_UPDATE",
	"TRAINER_CLOSED",
	"TRAINER_DESCRIPTION_UPDATE",
	"TRAINER_SERVICE_INFO_NAME_UPDATE",
	"TRAINER_SHOW",
	"TRAINER_UPDATE",
	"TRANSMOGRIFY_CLOSE",
	"TRANSMOGRIFY_ITEM_UPDATE",
	"TRANSMOGRIFY_OPEN",
	"TRANSMOGRIFY_SUCCESS",
	"TRANSMOGRIFY_UPDATE",
	"TRANSMOG_COLLECTION_CAMERA_UPDATE",
	"TRANSMOG_COLLECTION_ITEM_UPDATE",
	"TRANSMOG_COLLECTION_SOURCE_ADDED",
	"TRANSMOG_COLLECTION_SOURCE_REMOVED",
	"TRANSMOG_COLLECTION_UPDATED",
	"TRANSMOG_OUTFITS_CHANGED",
	"TRANSMOG_SEARCH_UPDATED",
	"TRANSMOG_SETS_UPDATE_FAVORITE",
	"TRANSMOG_SOURCE_COLLECTABILITY_UPDATE",
	"TREASURE_PICKER_CACHE_FLUSH",
	"TRIAL_CAP_REACHED_LEVEL",
	"TRIAL_CAP_REACHED_MONEY",
	"TRIAL_STATUS_UPDATE",
	"TUTORIAL_HIGHLIGHT_SPELL",
	"TUTORIAL_TRIGGER",
	"TUTORIAL_UNHIGHLIGHT_SPELL",
	"TWITTER_LINK_RESULT",
	"TWITTER_POST_RESULT",
	"TWITTER_STATUS_UPDATE",
	"UI_ERROR_MESSAGE",
	"UI_INFO_MESSAGE",
	"UI_MODEL_SCENE_INFO_UPDATED",
	"UI_SCALE_CHANGED",
	"UNIT_ABSORB_AMOUNT_CHANGED",
	"UNIT_ATTACK",
	"UNIT_ATTACK_POWER",
	"UNIT_ATTACK_SPEED",
	"UNIT_AURA",
	"UNIT_CHEAT_TOGGLE_EVENT",
	"UNIT_CLASSIFICATION_CHANGED",
	"UNIT_COMBAT",
	"UNIT_CONNECTION",
	"UNIT_CTR_OPTIONS",
	"UNIT_DAMAGE",
	"UNIT_DEFENSE",
	"UNIT_DISPLAYPOWER",
	"UNIT_ENTERED_VEHICLE",
	"UNIT_ENTERING_VEHICLE",
	"UNIT_EXITED_VEHICLE",
	"UNIT_EXITING_VEHICLE",
	"UNIT_FACTION",
	"UNIT_FLAGS",
	"UNIT_HEALTH",
	"UNIT_HEAL_ABSORB_AMOUNT_CHANGED",
	"UNIT_HEAL_PREDICTION",
	"UNIT_INVENTORY_CHANGED",
	"UNIT_LEVEL",
	"UNIT_MANA",
	"UNIT_MAXHEALTH",
	"UNIT_MAXPOWER",
	"UNIT_MODEL_CHANGED",
	"UNIT_NAME_UPDATE",
	"UNIT_OTHER_PARTY_CHANGED",
	"UNIT_PET",
	"UNIT_PET_EXPERIENCE",
	"UNIT_PHASE",
	"UNIT_PORTRAIT_UPDATE",
	"UNIT_POWER_BAR_HIDE",
	"UNIT_POWER_BAR_SHOW",
	"UNIT_POWER_BAR_TIMER_UPDATE",
	"UNIT_POWER_FREQUENT",
	"UNIT_POWER_POINT_CHARGE",
	"UNIT_POWER_UPDATE",
	"UNIT_QUEST_LOG_CHANGED",
	"UNIT_RANGEDDAMAGE",
	"UNIT_RANGED_ATTACK_POWER",
	"UNIT_RESISTANCES",
	"UNIT_SPELLCAST_CHANNEL_START",
	"UNIT_SPELLCAST_CHANNEL_STOP",
	"UNIT_SPELLCAST_CHANNEL_UPDATE",
	"UNIT_SPELLCAST_DELAYED",
	"UNIT_SPELLCAST_FAILED",
	"UNIT_SPELLCAST_FAILED_QUIET",
	"UNIT_SPELLCAST_INTERRUPTED",
	"UNIT_SPELLCAST_INTERRUPTIBLE",
	"UNIT_SPELLCAST_NOT_INTERRUPTIBLE",
	"UNIT_SPELLCAST_SENT",
	"UNIT_SPELLCAST_START",
	"UNIT_SPELLCAST_STOP",
	"UNIT_SPELLCAST_SUCCEEDED",
	"UNIT_SPELL_HASTE",
	"UNIT_STATS",
	"UNIT_TARGET",
	"UNIT_TARGETABLE_CHANGED",
	"UNIT_THREAT_LIST_UPDATE",
	"UNIT_THREAT_SITUATION_UPDATE",
	"UPDATE_ACTIVE_BATTLEFIELD",
	"UPDATE_ALL_UI_WIDGETS",
	"UPDATE_BATTLEFIELD_SCORE",
	"UPDATE_BATTLEFIELD_STATUS",
	"UPDATE_BINDINGS",
	"UPDATE_BONUS_ACTIONBAR",
	"UPDATE_CHAT_COLOR",
	"UPDATE_CHAT_COLOR_NAME_BY_CLASS",
	"UPDATE_CHAT_WINDOWS",
	"UPDATE_EXHAUSTION",
	"UPDATE_EXPANSION_LEVEL",
	"UPDATE_EXTRA_ACTIONBAR",
	"UPDATE_FACTION",
	"UPDATE_FLOATING_CHAT_WINDOWS",
	"UPDATE_GM_STATUS",
	"UPDATE_INSTANCE_INFO",
	"UPDATE_INVENTORY_ALERTS",
	"UPDATE_INVENTORY_DURABILITY",
	"UPDATE_LFG_LIST",
	"UPDATE_MACROS",
	"UPDATE_MASTER_LOOT_LIST",
	"UPDATE_MOUSEOVER_UNIT",
	"UPDATE_MULTI_CAST_ACTIONBAR",
	"UPDATE_OVERRIDE_ACTIONBAR",
	"UPDATE_PENDING_MAIL",
	"UPDATE_POSSESS_BAR",
	"UPDATE_SHAPESHIFT_COOLDOWN",
	"UPDATE_SHAPESHIFT_FORM",
	"UPDATE_SHAPESHIFT_FORMS",
	"UPDATE_SHAPESHIFT_USABLE",
	"UPDATE_STEALTH",
	"UPDATE_SUMMONPETS_ACTION",
	"UPDATE_TRADESKILL_RECAST",
	"UPDATE_UI_WIDGET",
	"UPDATE_VEHICLE_ACTIONBAR",
	"UPDATE_WEB_TICKET",
	"USER_WAYPOINT_UPDATED",
	"USE_BIND_CONFIRM",
	"USE_GLYPH",
	"USE_NO_REFUND_CONFIRM",
	"Unit",
	"VARIABLES_LOADED",
	"VEHICLE_ANGLE_SHOW",
	"VEHICLE_ANGLE_UPDATE",
	"VEHICLE_PASSENGERS_CHANGED",
	"VEHICLE_POWER_SHOW",
	"VEHICLE_UPDATE",
	"VIGNETTES_UPDATED",
	"VIGNETTE_MINIMAP_UPDATED",
	"VOICE_CHAT_ACTIVE_INPUT_DEVICE_UPDATED",
	"VOICE_CHAT_ACTIVE_OUTPUT_DEVICE_UPDATED",
	"VOICE_CHAT_AUDIO_CAPTURE_ENERGY",
	"VOICE_CHAT_AUDIO_CAPTURE_STARTED",
	"VOICE_CHAT_AUDIO_CAPTURE_STOPPED",
	"VOICE_CHAT_CHANNEL_ACTIVATED",
	"VOICE_CHAT_CHANNEL_DEACTIVATED",
	"VOICE_CHAT_CHANNEL_DISPLAY_NAME_CHANGED",
	"VOICE_CHAT_CHANNEL_JOINED",
	"VOICE_CHAT_CHANNEL_MEMBER_ACTIVE_STATE_CHANGED",
	"VOICE_CHAT_CHANNEL_MEMBER_ADDED",
	"VOICE_CHAT_CHANNEL_MEMBER_ENERGY_CHANGED",
	"VOICE_CHAT_CHANNEL_MEMBER_GUID_UPDATED",
	"VOICE_CHAT_CHANNEL_MEMBER_MUTE_FOR_ALL_CHANGED",
	"VOICE_CHAT_CHANNEL_MEMBER_MUTE_FOR_ME_CHANGED",
	"VOICE_CHAT_CHANNEL_MEMBER_REMOVED",
	"VOICE_CHAT_CHANNEL_MEMBER_SILENCED_CHANGED",
	"VOICE_CHAT_CHANNEL_MEMBER_SPEAKING_STATE_CHANGED",
	"VOICE_CHAT_CHANNEL_MEMBER_VOLUME_CHANGED",
	"VOICE_CHAT_CHANNEL_MUTE_STATE_CHANGED",
	"VOICE_CHAT_CHANNEL_PTT_CHANGED",
	"VOICE_CHAT_CHANNEL_REMOVED",
	"VOICE_CHAT_CHANNEL_TRANSMIT_CHANGED",
	"VOICE_CHAT_CHANNEL_VOLUME_CHANGED",
	"VOICE_CHAT_COMMUNICATION_MODE_CHANGED",
	"VOICE_CHAT_CONNECTION_SUCCESS",
	"VOICE_CHAT_DEAFENED_CHANGED",
	"VOICE_CHAT_ERROR",
	"VOICE_CHAT_INPUT_DEVICES_UPDATED",
	"VOICE_CHAT_LOGIN",
	"VOICE_CHAT_LOGOUT",
	"VOICE_CHAT_MUTED_CHANGED",
	"VOICE_CHAT_OUTPUT_DEVICES_UPDATED",
	"VOICE_CHAT_PENDING_CHANNEL_JOIN_STATE",
	"VOICE_CHAT_PTT_BUTTON_PRESSED_STATE_CHANGED",
	"VOICE_CHAT_SILENCED_CHANGED",
	"VOID_DEPOSIT_WARNING",
	"VOID_STORAGE_CLOSE",
	"VOID_STORAGE_CONTENTS_UPDATE",
	"VOID_STORAGE_DEPOSIT_UPDATE",
	"VOID_STORAGE_OPEN",
	"VOID_STORAGE_UPDATE",
	"VOID_TRANSFER_DONE",
	"VOID_TRANSFER_SUCCESS",
	"VOTE_KICK_REASON_NEEDED",
	"WARFRONT_COMPLETED",
	"WARGAME_REQUESTED",
	"WAR_MODE_STATUS_UPDATE",
	"WAYPOINT_UPDATE",
	"WEAR_EQUIPMENT_SET",
	"WEEKLY_REWARDS_HIDE",
	"WEEKLY_REWARDS_ITEM_CHANGED",
	"WEEKLY_REWARDS_SHOW",
	"WEEKLY_REWARDS_UPDATE",
	"WHO_LIST_UPDATE",
	"WORLD_MAP_CLOSE",
	"WORLD_MAP_OPEN",
	"WORLD_QUEST_COMPLETED_BY_SPELL",
	"WORLD_STATE_TIMER_START",
	"WORLD_STATE_TIMER_STOP",
	"WOW_MOUSE_NOT_FOUND",
	"ZONE_CHANGED",
	"ZONE_CHANGED_INDOORS",
	"ZONE_CHANGED_NEW_AREA",
}
for x = 1, #temp do
	TextColorTable[temp[x]] = eventColor
end
temp = nil

-- ****************************************************************************
-- * WoW Widget Events                                                        *
-- ****************************************************************************

local temp = {
	"OnAnimFinished",
	"OnAttributeChanged",
	"OnCursorChanged",
	"OnDoubleClick",
	"OnDragStart",
	"OnDragStop",
	"OnEnter",
	"OnEnterPressed",
	"OnEscapePressed",
	"OnEvent",
	"OnHide",
	"OnKeyDown",
	"OnKeyUp",
	"OnLeave",
	"OnLoad",
	"OnMouseDown",
	"OnMouseUp",
	"OnMouseWheel",
	"OnReceiveDrag",
	"OnShow",
	"OnSizeChanged",
	"OnSpacePressed",
	"OnTabPressed",
	"OnUpdate",
	"OnChar",
	"OnCharComposition",
	"OnEditFocusGained",
	"OnEditFocusLost",
	"OnInputLanguageChanged",
	"OnTextChanged",
	"OnTextSet",
	"OnHorizontalScroll",
	"OnScrollRangeChanged",
	"OnVerticalScroll",
	"OnValueChanged",
	}
for x = 1, #temp do
	TextColorTable[temp[x]] = eventColor
end
temp = nil
